{Q03P03D2}

Program Ranas_croando;


Procedure Estado_inicial_ranas (var eiA,eiB,eiC,eiD:char);
  {Introducir por teclado el estado inicial de las 4 ranas }
   begin
      repeat
        begin
           writeln('Elija si la rana croa o calla en el primer turno (S/N)');
           writeln;
           writeln('ranaA:'); readln(eiA);
           eiA:=upcase(eiA);
           writeln('ranaB:'); readln(eiB);
           eiB:=upcase(eiB);
           writeln('ranaC:'); readln(eiC);
           eiC:=upcase(eiC);
           writeln('ranaD:'); readln(eiD);
           eiD:=upcase(eiD);
           writeln
        end;
      until ((eiA='N') or (eiA='S')) and ((eiB='N')
      or (eiB='S')) and ((eiC='N') or (eiC='S')) and ((eiD='N') or (eiD='S'))
   end;


Procedure Reglas_turno_siguiente (var v0,v1,v2,v3:char);
   {Introducir las condiciones (numero de vecinas) necesarias para que
    cada rana croe o no en el turno siguiente}
   begin
      repeat
         writeln('Decida si la rana va a croar en el turno siguiente (S/N) si tiene:');
         writeln;
         writeln('0 vecinas croando'); readln(v0);
         v0:=upcase(v0);
         writeln('1 vecinas croando'); readln(v1);
         v1:=upcase(v1);
         writeln('2 vecinas croando'); readln(v2);
         v2:=upcase(v2);
         writeln('3 vecinas croando'); readln(v3);
         v3:=upcase(v3);
         writeln
      until ((v0='S') or (v0='N')) and ((v1='S') or (v1='N')) and
            ((v2='S') or (v2='N')) and ((v3='S') or (v3='N'))
   end;


Procedure Contador_turno (var n:integer);
   {Indicar el turno en el que se encuentra el juego}
   begin
      n:=n+1;
      write (n:2,':')
   end;


Procedure Mostrar_turno (mA,mB,mC,mD:char;var num:integer);
   {Presentar en la pantalla en el turno actual las 4 ranas}
   begin
      contador_turno(num);
      if (mA='S') then write ('C') else write (' ');
      if (mB='S') then write ('C') else write (' ');
      if (mC='S') then write ('C') else write (' ');
      if (mD='S') then write ('C') else write (' ');
      writeln;
      readln
   end;


Procedure Numero_vecinas (iA,iB,iC,iD:char; var vA,vB,vC,vD:integer);
   {Calcular en el turno anterior el n de vecinas croando que tiene
    cada rana para saber que harn en el turno actual}
   var
      rA,rB,rC,rD:integer;
   begin
      if (iA='S') then rA:=1 else rA:=0;
      if (iB='S') then rB:=1 else rB:=0;
      if (iC='S') then rC:=1 else rC:=0;
      if (iD='S') then rD:=1 else rD:=0;
      vA:=rB+rC+rD;
      vB:=rA+rC+rD;
      vC:=rA+rB+rD;
      vD:=rA+rB+rC
   end;


Procedure Nuevo_turno (veA,veB,veC,veD:integer; Ve0,Ve1,Ve2,Ve3:char;
                       var tA,tB,tC,tD:char);
   {Establecer de acuerdo con las condiciones de entrada (n de vecinas
    croando necesarias) y el n de vecinas croando en el turno anterior,
    si cada rana va a croar o no en el turno actual}
   begin
      case veA of
         0: if Ve0='S' then tA:='S' else tA:='N';
         1: if Ve1='S' then tA:='S' else tA:='N';
         2: if Ve2='S' then tA:='S' else tA:='N';
         3: if Ve3='S' then tA:='S' else tA:='N'
      end;
      case veB of
         0: if Ve0='S' then tB:='S' else tB:='N';
         1: if Ve1='S' then tB:='S' else tB:='N';
         2: if Ve2='S' then tB:='S' else tB:='N';
         3: if Ve3='S' then tB:='S' else tB:='N'
      end;
      case veC of
         0: if Ve0='S' then tC:='S' else tC:='N';
         1: if Ve1='S' then tC:='S' else tC:='N';
         2: if Ve2='S' then tC:='S' else tC:='N';
         3: if Ve3='S' then tC:='S' else tC:='N'
      end;
      case veD of
         0: if Ve0='S' then tD:='S' else tD:='N';
         1: if Ve1='S' then tD:='S' else tD:='N';
         2: if Ve2='S' then tD:='S' else tD:='N';
         3: if Ve3='S' then tD:='S' else tD:='N'
      end
   end;


Procedure Actualizar_turno (actA,actB,actC,actD:char;
                            var antA,antB,antC,antD:char);
   {Una vez mostrado el turno actual, habr que cambiar el estado actual
    de cada rana y ponerlo como estado anterior}
   begin
      if actA='S' then antA:='S'  else antA:='N';
      if actB='S' then antB:='S'  else antB:='N';
      if actC='S' then antC:='S'  else antC:='N';
      if actD='S' then antD:='S'  else antD:='N'
   end;


Function final_del_juego (turno:integer;tacA,tacB,tacC,tacD,
                          tanA,tanB,tanC,tanD:char): boolean;
   {Para indicar cuando a terminado el juego, nos dicen que hay dos casos,
    tras 20 turnos o si durante dos turnos las ranas no cambian}
   begin
      if (turno>=20) then final_del_juego:=true;
      if (tacA=tanA) and (tacB=tanB) and (tacC=tanC) and (tacD=tanD) then
      final_del_juego:=true
   end;


Function volver_a_jugar: boolean;
   {Si se quiere volver a jugar}
   var
      fin:char;
   begin
      repeat
      writeln('Quiere volver a jugar? (S/N)');
      readln(fin);
      fin:=upcase(fin);
      until (fin='S') or (fin='N');
      if fin='S' then volver_a_jugar:=true;
      if fin='N' then volver_a_jugar:=false
   end;



{----------------------------PROGRAMA PRINCIPAL-----------------------------}
{---------------------------------------------------------------------------}

var
   nturnos:integer;  {contar e indicar cada turno}
   A,B,C,D,InA,InB,InC,InD:char; {estado de cada rana: si croa o no}
   vec0,vec1,vec2,vec3:char; {si para un n de vecinas las ranas croan o no}
   vecA,vecB,vecC,vecD:integer; {n de vecinas croan en el turno anterior}
   finjuego:boolean; {saber cuando termina el juego}
begin
   Repeat
      nturnos:=0;
      Estado_inicial_ranas(InA,InB,InC,InD);
      Reglas_turno_siguiente(vec0,vec1,vec2,vec3);
      repeat
         begin
            Numero_vecinas(InA,InB,InC,InD,vecA,vecB,vecC,vecD);
            nuevo_turno(vecA,vecB,vecC,vecD,vec0,vec1,vec2,vec3,A,B,C,D);
            Mostrar_turno(InA,InB,InC,InD,nturnos);
            finjuego:=final_del_juego(nturnos,A,B,C,D,InA,InB,InC,InD);
            Actualizar_turno(A,B,C,D,InA,InB,InC,InD)
         end;
      until finjuego=true;
      if nturnos>=20 then
      writeln ('FIN DEL JUEGO:   Ya han pasado los 20 turnos  !!!')
      else writeln ('FIN DEL JUEGO:   El siguiente turno es exactamente igual !!!');
      writeln;
      readln
   until volver_a_jugar=false
end.