PROGRAM RanasCroando;
USES CRT;

PROCEDURE Encabezado;   {presentacion del programa al usuario}
     begin
     writeln;
     writeln('********************************************************************************');
     writeln('***************************** CROA RANITA, CROA ********************************');
     writeln('********************************************************************************');
     writeln;
     end;

FUNCTION  DecideCroaRana(letra:char):integer;     {para que el usuario elija si croa o no la rana}
var
   decisionCroar:integer;

begin
     {$I-}
     Repeat
           writeln;
           write('Si quieres que croe la rana ',letra,' pulsa 1 y si no pulsa 0. ');
           readln(decisionCroar)
     until (ioresult=0) and (not(decisionCroar<>1) or not(decisionCroar<>0));
     {$I+}
     DecideCroaRana:=decisionCroar;
end;


PROCEDURE EstadoInicial (var RanaA, RanaB, RanaC, RanaD:integer);  {almacena el estado inicial de las ranas}
var
   r:char;
   resultado:integer;
begin
     For r:='A' to 'D' do
        begin
           resultado:=DecideCroaRana(r);
            case r of
                 'A':RanaA:=resultado;
                 'B':RanaB:=resultado;
                 'C':RanaC:=resultado;
                 'D':RanaD:=resultado;
            end
        end
end;

 PROCEDURE CreaReglas (var regla0,regla1,regla2,regla3: integer);  {el usuario elige en que casos croa la rana}
 var
    n,decision:integer;
 begin
     writeln;
     writeln('Decide las reglas de la partida.');

     For n:=0 to 3 do
      begin
       {$I-}
       Repeat
       writeln;
       writeln('Si ',n, ' ranas estn croando, Quieres que croe la rana?');
       write('Pulsa 1  0 si quieres que croe o no, respectivamente. ');
       readln(decision)
       until (ioresult=0) and (decision=0) or (decision=1);
       {$I+}

       case n of
            0:regla0:=decision;
            1:regla1:=decision;
            2:regla2:=decision;
            3:regla3:=decision
       end
      end {del for}
 end;


PROCEDURE DibujaEstado(RanaA, RanaB, RanaC, RanaD:integer); {dibuja C  _ segn los valores en cada caso}

    begin
    if(RanaA=1) then write('C') else write('_');
    if(RanaB=1) then write('C') else write('_');
    if(RanaC=1) then write('C') else write('_');
    if(RanaD=1) then write('C') else write('_');
    writeln
    end;


PROCEDURE TurnosSiguientes (r0,r1,r2,r3:integer; vecina1, vecina2, vecina3: integer;
                             var turnoSiguiente: integer); {asigna el turno siguiente a cada rana}
 var
       suma:integer;
 Begin
       suma:=(vecina1 + vecina2 + vecina3);
       case suma of        {casos: cero a tres ranas croando}
            0: turnoSiguiente:=r0;
            1: turnoSiguiente:=r1;
            2: turnoSiguiente:=r2;
            3: turnoSiguiente:=r3
       end
 end;

FUNCTION TurnosIguales(RanaA,RanaB,RanaC,RanaD:integer;
turnoSiguienteA,turnoSiguienteB,turnoSiguienteC,turnoSiguienteD:integer):boolean;

{devuelve verdadero si dos turnos seguidos coinciden}

begin
     if (RanaA=turnoSiguienteA) AND (RanaB=turnoSiguienteB) AND
        (RanaC=turnoSiguienteC) AND (RanaD=turnoSiguienteD) then
     TurnosIguales:=true
     else TurnosIguales:=false
end;

PROCEDURE MostrarTurno(r0,r1,r2,r3:integer; RanaA,RanaB,RanaC,RanaD:integer;
          var turnoSiguienteA,turnoSiguienteB,turnoSiguienteC,turnoSiguienteD:integer);
           {dibuja los turnos sucesivos}

const
   MaxTurno=20;
var
   turno: integer;
   finjuego: boolean;
   tempA,tempB,tempC,tempD:integer;
begin
     turno:=1;
     Repeat
        TurnosSiguientes (r0,r1,r2,r3,RanaB, RanaC, RanaD,turnoSiguienteA);
        TurnosSiguientes (r0,r1,r2,r3,RanaA, RanaC, RanaD,turnoSiguienteB);
        TurnosSiguientes (r0,r1,r2,r3,RanaA, RanaB, RanaD,turnoSiguienteC);
        TurnosSiguientes (r0,r1,r2,r3,RanaA, RanaB, RanaC,turnoSiguienteD);

        DibujaEstado(turnoSiguienteA,turnoSiguienteB,turnoSiguienteC,turnoSiguienteD);
        writeln;
        turno:=turno+1;
        tempA:=RanaA;
        tempB:=RanaB;
        tempC:=RanaC;
        tempD:=RanaD;
        RanaA:=turnoSiguienteA;         {las asignaciones en otro mdulo y lo llamamos aqu}
        RanaB:=turnoSiguienteB;
        RanaC:=turnoSiguienteC;
        RanaD:=turnoSiguienteD;

        If (turno=MaxTurno) then finjuego:=true
     until (finjuego=true) OR
     (TurnosIguales(tempA,tempB,tempC,tempD,
      turnoSiguienteA,turnoSiguienteB,turnoSiguienteC,turnoSiguienteD)=true)

end;

FUNCTION RepitePartida:char;   {Da la opcin de volver a jugar}
var
    partidaNueva:char;
begin
          {$I-}
          Repeat
          writeln;
          write('Quieres jugar otra partida?(S/N): ');
          readln(partidaNueva);
          until (IOresult=0) AND ((partidaNueva='n') OR (partidaNueva='N')
                          OR (partidaNueva='s') or (partidaNueva='S'));
          {$I+}
          RepitePartida:=partidaNueva
end;

VAR

   Rana1A,Rana1B,Rana1C,Rana1D:integer;  {almacenan el turno actual}
   reglaCroa0,reglaCroa1,reglaCroa2,reglaCroa3:integer;   {almacenan si croan las ranas o no}
   turnoSigA,turnoSigB,turnoSigC,turnoSigD: integer;    {almacenan el turno siguiente}
   otraPartida:char;      {para dar la opcin a jugar otra(s) partida(s)}

BEGIN  {programa principal}

  Repeat
     Clrscr;
     Encabezado;
     writeln('Para empezar, se preguntar si quieres que croen las ranas A, B, C y D.');
     EstadoInicial (Rana1A, Rana1B, Rana1C, Rana1D);
     CreaReglas (reglaCroa0,reglaCroa1,reglaCroa2,reglaCroa3);
     writeln;
     writeln('La secuencia de estados de las ranas es la siguiente: ');
     writeln;
     DibujaEstado(Rana1A, Rana1B, Rana1C, Rana1D);
     writeln;
     MostrarTurno(reglaCroa0,reglaCroa1,reglaCroa2,reglaCroa3,
                  Rana1A,Rana1B,Rana1C,Rana1D,
                  turnoSigA,turnoSigB,turnoSigC,turnoSigD);

     otraPartida:=RepitePartida;

  until (ioresult=0) AND (otraPartida='n') OR (otraPartida='N');
     writeln;
     writeln('Ha finalizado el programa. Pulse intro para salir.');
     readln;
END. {fin del programa}