program juegoderanas;

var {declaracin de las variables del algoritmo principal}
  RA, RB, RC, RD : INTEGER;  {representan a las ranas A, B, C y D}
  C0, C1, C2, C3 : INTEGER;  {representan a las condiciones de vecinas croando}
  SA, SB, SC, SD : INTEGER;  {son las auxiliares para reasignar valores}
  i : INTEGER;  {es la auxiliar para realizar la funcin 'for to'}
  repetir: CHAR;  {es la auxiliar que permite repetir el programa}


procedure tomadatos (var RA, RB, RC, RD : integer);
   {con este procedimiento tomamos los datos iniciales de que ranas croan}
   {asignaremos el valor "1" a las ranas que croen, y el "0" a las que no croen}

  var

     RPA, RPB, RPC, RPD: CHAR;  {representan si las ranas croan en el primer turno}

  begin {comienzo del algoritmo del procedimiento tomadatos}


     writeln (' ');
     writeln (' ');
     writeln (' ');


     REPEAT
     writeln ('Quiere que la rana A croe en el primer turno?');
     writeln ('Pulse "s" para Si, o "n" para No, despues pulse intro');
     writeln(' ');
     writeln(' ');
     readln(RPA);
     until (RPA = 's') or (RPA = 'n') or (RPA ='N') or (RPA ='S') ;
     if (RPA='s') or (RPA='S')
        then RA :=1
        else RA :=0;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     REPEAT
     writeln ('Quiere que la rana B croe en el primer turno?');
     writeln ('Pulse "s" para Si, o "n" para No, despues pulse intro');
     writeln(' ');
     writeln(' ');
     readln(RPB);
      until (RPB = 's') or (RPB = 'n')  or (RPB = 'N') or (RPB ='S');
     if (RPB='s') or (RPA='S')
        then RB :=1
        else RB :=0;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     REPEAT
     writeln ('quiere que la rana C croe en el primer turno?');
     writeln ('Pulse "s" para Si y, o "n" para No, despues pulse intro');
     writeln(' ');
     writeln(' ');
     readln(RPC);
      until (RPC = 's') or (RPC = 'n') or (RPC ='N') or (RPC ='S') ;
     if (RPC='s') or (RPA='S')
        then RC :=1
        else RC :=0;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     REPEAT
     writeln ('Quiere que la rana D croe en el primer turno?');
     writeln('Pulse "s" para Si, o "n" para No, despues pulse intro');
     writeln(' ');
     writeln(' ');
     readln(RPD);
     until (RPD = 's') or (RPD = 'n') or (RPD ='N') or (RPD ='S') ;
     if (RPD='s') or (RPA='S')
        then RD :=1
        else RD :=0;
   end;  {fin del algoritmo del procedimiento tomadatos}


procedure condiciones (var C0, C1, C2, C3:integer);
   {Con este procedimiento tomamos las condiciones en que croan las ranas.}
   {Asignaremos el valor de la condicion si la condicion es positiva y}
   {asignaremos un valor mayor que 4 (10) si la condicion es negativa}

  var

     auxC0, auxC1, auxC2, auxC3:string[1];  {representan las condiciones}

  begin  {comienzo del algoritmo del procedimiento condiciones}


     writeln (' ');
     writeln ('********************************************* ');
     writeln (' ');
     repeat
     writeln('Croarn las ranas si tienen 0 vecinas croando?');
     writeln('Pulse la tecla "s" para Si, o "n" para no, despues pulse intro.');
     writeln(' ');
     writeln(' ');
     readln(auxC0);
     until (auxC0 = 's') or (auxC0 = 'n') or (auxC0 ='N') or (auxC0 ='S') ;
     if (auxC0='s')
        then C0:=0
        else C0:=10;
     writeln;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     repeat
     writeln('Croarn las ranas si tienen 1 vecinas croando?');
     writeln('Pulse la tecla "s" para Si, o "n" para No, despues pulse intro.');
     writeln(' ');
     writeln(' ');
     readln(auxC1);
     until (auxC1 = 's') or (auxC1 = 'n') or (auxC1 ='N') or (auxC1 ='S') ;
     if (auxC1='s')
        then C1:=1
        else C1:=10;
     writeln;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     repeat
     writeln('Croarn las ranas si tienen 2 vecinas croando?');
     writeln('Pulse la tecla "s" para Si, o "n" para No, despues pulse intro.');
     writeln(' ');
     writeln(' ');
     readln(auxC2);
     until (auxC2 = 's') or (auxC2 = 'n') or (auxC2 ='N') or (auxC2 ='S') ;
     if (auxC2='s')
        then C2:=2
        else C2:=10;
     writeln;

     writeln (' ');
     writeln (' ');
     writeln (' ');
     repeat
     writeln('Croarn las ranas si tienen 3 vecinas croando?');
     writeln('Pulse la tecla "s" para Si,  o "n" para No, despues pulse intro.');
     writeln(' ');
     writeln(' ');
     readln(auxC3);
     until (auxC3 = 's') or (auxC3 = 'n') or (auxC3 ='N') or (auxC3 ='S') ;
     if (auxC3='s')
        then C3:=3
        else C3:=10;
     writeln;
     writeln(' ');
     writeln(' ');
     writeln(' ');
     writeln('ENHORABUENA!!! HA RELLENADO CORRECTAMENTE TODOS LOS DATOS');
     writeln(' ');
     writeln('PULSE UNA TECLA PARA VER SU DIBUJO ');
     READLN;



  end; {fin del algoritmo del procedimiento condiciones}


function ranacroa (v1, v2, v3, C0, C1, C2, C3 : integer) :integer;
  {Esta funcion nos da un valor (0 o 1) que nos indica si la rana croa o no.}
  {Para ello sumamos las ranas vecinas y comparamos con la condicion}

  begin  {comienzo del algoritmo de la funcion ranacroa}

     if (V1+V2+V3=C0) or (V1+V2+V3=C1) or (V1+V2+V3=C2) or (V1+V2+V3=C3)
        then ranacroa :=1
        else ranacroa :=0;

  end;  {fin del algoritmo de la funcion ranacroa}


procedure escribe (RA, RB, RC, RD, C0, C1, C2, C3: integer);
  {Con este procedimiento se muestra por pantalla el resultado de un turno.}
  {Para ello escribimos la funcion 4 veces, condistintas variables en cada caso.}

  begin  {comienzo del algoritmo del procedimiento escribe}

     write (ranacroa(RB, RC, RD, C0, C1, C2, C3));
     write (ranacroa(RA, RC, RD, C0, C1, C2, C3));
     write (ranacroa(RA, RB, RD, C0, C1, C2, C3));
     write (ranacroa(RA, RB, RC, C0, C1, C2, C3));
     writeln;

 end;  {fin del algoritmo del procedimiento escribe}


procedure reasignacion (var RA, RB, RC, RD, C0, C1, C2, C3: integer);
    {Con este procedimiento cambiamos de valor la variable de cada rana.}
    {Para ello la almacenamos y y le damos el valor con "ranacroa" y las auxiliares}

  begin  {comienzo del algoritmo del procedimiento reasignacion}

     SA:=RA;
     SB:=RB;
     SC:=RC;
     SD:=RD;

     RA:=  ranacroa(SB, SC, SD, C0, C1, C2, C3);
     RB:=  ranacroa(SA, SC, SD, C0, C1, C2, C3);
     RC:=  ranacroa(SA, SB, SD, C0, C1, C2, C3);
     RD:=  ranacroa(SA, SB, SC, C0, C1, C2, C3);

 end;  {fin del algoritmo del procedimiento reasignacion}


begin {comienzo del algoritmo principal}

  repeat  {la accion que se repetira hasta que el usuario decida}

     begin  {comienzo del proceso que se repite}

        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln('     *     *     *     *    * ');
        writeln('    *    *    *    *    *    * ');
        writeln('   *  *   *   *   *   *   *   * ');
        writeln('  *  *  *  *  *  *  *  *  *  *  *  ');
        writeln(' * * * * * * * * * * * * * * * * * ');
        writeln(' *********************************');
        writeln(' ***** PROGRAMA DE LAS RANAS ***** ');
        writeln(' *********************************');
        writeln(' * * * * * * * * * * * * * * * * *  ');
        writeln('  *  *  *  *  *  *  *  *  *  *  * ');
        writeln('   *   *   *   *   *   *   *   * ');
        writeln('    *    *    *    *    *    * ');
        writeln('     *     *     *     *    * ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln('A CONTINUACION RELLENE LOS SIGUIENTES DATOS ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');
        writeln(' ');

        writeln;
        tomaDatos(RA, RB, RC, RD);  {llamada al procedimiento tomadatos}
        condiciones(C0, C1, C2, C3);  {llamada al procedimiento condiciones}
        writeln;
        writeln;
        writeln('ABCD');
        writeln;
        writeln(RA,RB,RC,RD); {escritura del primer turno}
        for i:=1 to 19 do  {bucle que se crea para mostrar los 20 turnos}

           begin  {comienzo del bucle de 19 turnos}
              escribe (RA, RB, RC, RD, C0, C1, C2, C3);
              reasignacion (RA, RB, RC, RD, C0, C1, C2, C3);
           end;  {fin del bucle de 19 turnos}

        writeln;
        writeln;
        writeln('Si desea salir del juego pulse le tecla "s" y despues pulse intro.');
        writeln('En caso contrario, pulse otra tecla y despues pulse intro.');
        writeln(' ');
        writeln(' ');
        readln(repetir);

     end;  {fin del proceso que se repite}

  until (repetir='s') or (repetir='S');  {condiciones para que se repita la accion}

end.  {fin del algoritmo principal}


