Program Ranas;
{Programa que simula un grupo de 4 ranas croando durante una serie de turnos}
 Uses
  CRT;
 Procedure MostrarCartel;
 {Procedimiento que muestra por pantalla el cartel del juego}
  begin
   TextColor(15);
   Sound(1000);
   writeln;
   writeln;
   writeln;
   writeln('             *************************');
   writeln('             ******-RANAS CROAN-******');
   writeln('             *************************');
   writeln;
   writeln;
   writeln;
   NoSound;
  end;

 Procedure PedirRanas (var  a,b,c,d:char; var n:integer);
 {Procedimiento por el cual se pide al usuario que diga si cada una,}
 {de las ranas va a croar o no en el primer turno.}
  begin
  {$I-}
   n:=0;
   Repeat
    writeln;
    writeln;
    TextColor(8);
    writeln(' La rana -a- croa en el primer turno? Teclea C (croa)  _ (no croa)');
    writeln;
    TextColor(2);
    readln(a);
    writeln;
    writeln(a);
   until (IOResult=0) and (a='C') or (a='_');
   if a='C' then
   n:=n+1;

   Repeat
    writeln;
    TextColor(8);
    writeln(' La rana -b- croa en el primer turno? Teclea C(croa)  _(no croa)');
    writeln;
    TextColor(2);
    readln(b);
    writeln;
    writeln(b);
   until (IOResult=0) and (b='C') or (b='_');
   if b='C' then
   n:=n+1;

   Repeat
    writeln;
    TextColor(8);
    writeln(' La rana -c- croa en el primer turno? Teclea C(croa)  _(no croa)');
    writeln;
    TextColor(2);
    readln(c);
    writeln;
    writeln(c);
   until (IOResult=0) and (c='C') or (c='_');
   if c='C' then
   n:=n+1;

   Repeat
    writeln;
    TextColor(8);
    writeln(' La rana -d- croa en el primer turno? Teclea C(croa)  _(no croa)');
    writeln;
    TextColor(2);
    readln(d);
    writeln;
    writeln(d);
   until (IOResult=0) and (d='C') or (d='_');
   if d='C' then
   n:=n+1;

  {$I+}
  end;

Procedure PedirReglas(var v0,v1,v2,v3:char);
{Procedimiento por el cual se pide al usuario que introduzca,}
{para cada uno de los casos posibles si la rana va a croar o no}
{en el siguiente turno. Los casos posibles son 0,1,2  3 ranas vecinas}
{croando.}
 begin
 {$I-}
  Repeat
   writeln;
   TextColor(8);
   writeln(' Las ranas croan cuando tienen 0 ranas vecinas? Teclea s  n');
   writeln;
   TextColor(2);
   readln(v0);
   writeln;
   writeln(v0);
  until (IOResult=0) and (v0='s') or (v0='n');
  Repeat
   writeln;
   TextColor(8);
   writeln(' Las ranas croan cuando tienen 1 rana vecina? Teclea s  n');
   writeln;
   TextColor(2);
   readln(v1);
   writeln;
   writeln(v1);
  until (IOResult=0) and (v1='s') or (v1='n');
  Repeat
   writeln;
   TextColor(8);
   writeln(' Las ranas croan cuando tienen 2 ranas vecinas? Teclea s  n');
   writeln;
   TextColor(2);
   readln(v2);
   writeln;
   writeln(v2);
  until (IOResult=0) and (v2='s') or (v2='n');
  Repeat
   writeln;
   TextColor(8);
   writeln(' Las ranas croan cuando tienen 3 ranas vecinas? Teclea s  n');
   writeln;
   TextColor(2);
   readln(v3);
   writeln;
   writeln(v3);
  until (IOResult=0) and (v3='s') or (v3='n');
  {$I+}
 end;

Procedure CambiarVecinas(var r0,r1,r2,r3:integer);
{Procedimiento que intercambia las variables de tipo carcter por las}
{variables de tipo entero, de este modo, por ejemplo, si tenemos un s,}
{para que las ranas croen cuando tienen 0 vecinas, la respuesta s la}
{intercambia por el entero 0.}
 var
  v0,v1,v2,v3:char;
 begin
 PedirReglas(v0,v1,v2,v3);
 if v0='s'then
  r0:=0
 else
  r0:=9;
 if v1='s'then
  r1:=1
 else
  r1:=8;
 if v2='s'then
  r2:=2
 else
  r2:=7;
 if v3='s'then
  r3:=3
 else
  r3:=6;
end;


Procedure Caso1(var t1,t2,t3,t4:char; var a,b,c,d:char);
 var
  n,r0,r1,r2,r3,t,na,nb,nc,nd:integer;
 begin
  PedirRanas(a,b,c,d,n);
  CambiarVecinas(r0,r1,r2,r3);

  na:=n;
  if a='C' then
   na:=na-1;
  if (na<>r0) and (na<>r1) and (na<>r2) and (na<>r3) then
   t1:='_'
  else
   t1:='C';

  nb:=n;
  if b='C' then
   nb:=nb-1;
  if (nb<>r0) and (nb<>r1) and (nb<>r2) and (nb<>r3) then
   t2:='_'
  else
   t2:='C';

  nc:=n;
  if c='C' then
   nc:=nc-1;
  if (nc<>r0) and (nc<>r1) and (nc<>r2) and (nc<>r3) then
   t3:='_'
  else
   t3:='C';

  nd:=n;
  if d='C' then
   nd:=nd-1;
  if (nd<>r0) and (nd<>r1) and (nd<>r2) and (nd<>r3) then
   t4:='_'
  else
   t4:='C';

 end;

Procedure Visualizar (var g1,g2,g3,g4:char; var t:integer);
var
 a,b,c,d,t1,t2,t3,t4: char;
begin

  Caso1(t1,t2,t3,t4,a,b,c,d);
  g1:=a; g2:=b; g3:=c; g4:=d;
  t:=1;
  writeln;
  writeln;
  writeln;
  TextColor(5);
  writeln('***RESULTADO***');
  writeln;
  writeln;
  TextColor(2);
  writeln('   ABCD ');
  writeln;
  TextColor(10);
  Sound(700);
  writeln(t,': ',g1,g2,g3,g4);
  t:=t+1;
  writeln;
  writeln(t,': ',t1,t2,t3,t4);
  writeln;
  NoSound;
 end;




{Programa Principal}
Var
 G1,G2,G3,G4:char;
 T:integer;
 respuesta:char;

Begin
 ClrScr;
 MostrarCartel;
 {$I-}
 Repeat
  begin
   Visualizar(G1,G2,G3,G4,T);
   writeln;
   writeln;
   writeln;
   TextColor(8);
   writeln(' Quieres volver a jugar con las ranas?');
   writeln;
   writeln(' Teclea S (si quieres volver a jugar), sino teclea N');
   writeln;
   TextColor(2);
   readln(respuesta);
   writeln;
   While (respuesta<>'S') and (respuesta<>'N') do
    begin
     writeln;
     TextColor(4);
     writeln(' Escribe S o N');
     writeln;
     TextColor(2);
     readln(respuesta);
     writeln;
    end;
    writeln(respuesta);
    writeln;
    writeln;
    writeln;
    TextColor(15);
    Sound(1000);
    writeln('            *******-JUEGA DE NUEVO-*******');
    NoSound;
   end;
 until (respuesta='N');
 {$I+}
End.