Program ranas;

 Uses
   crt;

 {Creamos una funcion para pedirle al usuario si croan o no cada rana de la charca en el primer turno}
 Function PedirRanas (X:char):integer;
    var
      croa:integer;
    Begin
      {$I-}
      Repeat
         writeln('Escribe 1 o 0 para la rana ',X,' si quieres que croe o no croe:');
         readln(croa)
       until (croa=1) OR (croa=0) AND (IORESULT=0);
       {$I+}
       PedirRanas:=croa
     end;

  {Creamos otro procedimiento que llama a la funcion anterior,guardando si croa o no cada rana en una variable de tipo entero}
  Procedure PedirRana(var A1,B1,C1,D1:integer);
    Begin
       A1:=PedirRanas('A');
       B1:=PedirRanas('B');
       C1:=PedirRanas('C');
       D1:=PedirRanas('D')
    end;

   {Con esta funcion pedimos al usuario que diga si croan o no las ranas con un determinado numero de vecinas croando}
   Function PedirReglas (Y:integer):integer;
     var
       resultado:integer;
     Begin
       {$I-}
       Repeat
         writeln('Introduce 1 o 0 si quieres que las ranas croen o no, con ',Y,' vecinas croando: ');
         readln(resultado) ;
       until (resultado=1) OR (resultado=0) AND (IOresult=0);
       {$I+}
       PedirReglas:=resultado
     end;

   {Hacemos un procedimiento que llamando a la funcion anterior guarda en 4 variables
   de tipo entero si croan o no las ranas con un determinado numero de vecinas croando}
   Procedure PedirRegla(var V0,V1,V2,V3:integer);
     Begin
        V0:=PedirReglas(0);
        V1:=PedirReglas(1);
        V2:=PedirReglas(2);
        V3:=PedirReglas(3)
     end;

   {Mediante este procedimiento hacemos que introduciendo las variables de las ranas y las variables de las reglas,
   nos diga si cada rana croa o no en el turno siguiente}
   Procedure SigTurno (var XX:integer;V0,V1,V2,V3,X1,X2,X3:integer);
     Begin
       If (X1+X2+X3=0) And (V0=1) then XX:=1
        else
         If (X1+X2+X3=1) And (V1=1) then XX:=1
          else
           If (X1+X2+X3=2) And (V2=1) then XX:=1
            else
             If (X1+X2+X3=3) And (V3=1) then XX:=1
              else XX:=0
     end;

   {Mediante esta funcion cambiamos los 1 y 0 por C y _ respectivamente}
   Function signos (Z:integer):char;
     Begin
        If (Z=1) then signos:='C' else signos:='_';
     end;

   {Definimos las variables del programa principal}
   var
      eleccion,final:char;
      AA1,BB1,CC1,DD1:INTEGER;
      VV0,VV1,VV2,VV3:integer;
      turnos:integer;
      AAA,BBB,CCC,DDD:integer;

   {Comienza el programa principal}
   Begin
      Repeat
        clrscr;
        textcolor(green);
        writeln(' ******************************************************************************');
        write(' ***************************** ');
        textcolor(130);
        write('CHARCA DE RANAS');
        textcolor(green);
        write(' ********************************');
        textColor(green);
        writeln('  ******************************************************************************');
        normvideo;
        writeln;

        {Llamamos a los procedimientos que nos han guardado si croa o no cada rana al principio
         y las condiciones que necesitan para croar en el siguiente turno cada rana}
        PedirRana(AA1,BB1,CC1,DD1);
        PedirRegla(VV0,VV1,VV2,VV3);

        {Inicializamos final a 1 para que tenga un valor distinto de 0 y evitarnos posteriores problemas}
        final:='1';
        turnos:=1;

        writeln;
        writeln('  A B C D');
        writeln;
        writeln(turnos,':',signos(AA1),' ',signos(BB1),' ',signos(CC1),' ',signos(DD1));

        {Llamamos 4 veces al procedimiento que introduciendo lo que hacian en el primer turno cada rana
         y las 4 condiciones, nos dice lo que haran el turno siguiente}
        Repeat
           SigTurno(AAA,VV0,VV1,VV2,VV3,BB1,CC1,DD1);
           SigTurno(BBB,VV0,VV1,VV2,VV3,AA1,CC1,DD1);
           SigTurno(CCC,VV0,VV1,VV2,VV3,AA1,BB1,DD1);
           SigTurno(DDD,VV0,VV1,VV2,VV3,AA1,BB1,CC1);

           {Introducimos la condicion de que si se repite algun resultado finalice el programa}
           if (AA1=AAA) AND (BB1=BBB) AND (CC1=CCC) AND (DD1=DDD) THEN final:='0';

           {Asignamos a las variables que guardan si croan o no las ranas del anterior turno
           las del nuevo turno}
           AA1:=AAA;
           BB1:=BBB;
           CC1:=CCC;
           DD1:=DDD;

           turnos:=turnos+1;
           writeln(turnos,':',signos(AA1),' ',signos(BB1),' ',signos(CC1),' ',signos(DD1));

        {Ponemos la otra condicion para que finalice el programa, que llegue a 20 turnos}
        until (turnos>=20) OR (final='0');

        {Creamos un bucle repeat para preguntarle al usuario si quiere jugar otra vez, en este caso
        el programa comienza de nuevo,en caso contrario el programa finalizara}
        {Con otro repeat hacemos que si el usuario no introduce una S o una N se repita la pregunta
        hasta que introduzca uno de esos caracteres}

          {$I-}
          Repeat
             writeln;
             writeln('Introduce (s/S) si quieres jugar otra vez sino introduce (n/N) para terminar.');
             readln(eleccion)
          until (eleccion='N') OR (eleccion='n') OR (eleccion='S') OR (eleccion='s') AND (IORESULT=0);
          {$I+}

      until(eleccion='N') OR (eleccion='n')
   End.