program RanasCroar;

uses crt;
const turnos=20;



{Pide el estado inicial de las ranas}
procedure PedirRanas (var a,b,c,d:char);
begin
{$I-}
     repeat
           write('Quieres que la rana A croe?(s/n): ');
           readln(a);
     until (a='s') or (a='n') and (IORESULT=0);
     repeat
           write('Quieres que la rana B croe?(s/n): ');
           readln(b);
     until (b='s') or (b='n') and (IORESULT=0);
     repeat
           write('Quieres que la rana C croe?(s/n): ');
           readln(c);
     until (c='s') or (c='n') and (IORESULT=0);
     repeat
           write('Quieres que la rana D croe?(s/n): ');
           readln(d);
     until (d='s') or (d='n') and (IORESULT=0);
{$I+}
end;

{Pide las reglas de cambio de estado}
procedure PedirReglas (var r0,r1,r2,r3:char);
begin
{$I-}
     repeat
           write('Quieres que las ranas croen cuando tengan 0 vecinas croando?(s/n): ');
           readln(r0);
     until (r0='s') or (r0='n') and (IORESULT=0);
     repeat
           write('Quieres que las ranas croen cuando tengan 1 vecinas croando?(s/n): ');
           readln(r1);
     until (r1='s') or (r1='n') and (IORESULT=0);
     repeat
           write('Quieres que las ranas croen cuando tengan 2 vecinas croando?(s/n): ');
           readln(r2);
     until (r2='s') or (r2='n') and (IORESULT=0);
     repeat
          write('Quieres que las ranas croen cuando tengan 3 vecinas croando?(s/n): ');
          readln(r3);
     until (r3='s') or (r3='n') and (IORESULT=0);
end;

{Pinta el estado en que se encuentran las ranas}
procedure pintaEstado(a,b,c,d:char);
begin
     If (a='s') then write('C') else write('_');
     If (b='s') then write('C') else write('_');
     If (c='s') then write('C') else write('_');
     If (d='s') then writeln('C') else writeln('_');
end;

{Comprueba si los estados son iguales}
function compruebaEstadoCambio(a,b,c,d,a2,b2,c2,d2:char):char;
begin
     if(a=a2) and (b=b2) and (c=c2) and (d=d2) then
     begin
          compruebaEstadoCambio:='n';
     end
     else
     begin
          compruebaEstadoCambio:='s';
     end;
end;

{Cuenta ranas croando}
function cuentaRanasCroando(a,b,c,d:char):integer;
var
   cuenta:integer;
begin
     cuenta:=0;
     if(a='s') then cuenta:=cuenta+1;
     if(b='s') then cuenta:=cuenta+1;
     if(c='s') then cuenta:=cuenta+1;
     if(d='s') then cuenta:=cuenta+1;
     cuentaRanasCroando:=cuenta;
end;

{Cambia el estado de la rana}
function cambiaEstadoRana(a:char;numeroRanasCroando:integer;r0,r1,r2,r3:char):char;
begin
     {Calcula el nmero de ranas vecinas croando}
     if (a='s') then numeroRanasCroando:=numeroRanasCroando-1;
     {Calcula si alguna de las reglas se cumple y la regla est activada}
     if(r0='s') and (numeroRanasCroando=0) then cambiaEstadoRana:='s';
     if(r1='s') and (numeroRanasCroando=1) then cambiaEstadoRana:='s';
     if(r2='s') and (numeroRanasCroando=2) then cambiaEstadoRana:='s';
     if(r3='s') and (numeroRanasCroando=3) then cambiaEstadoRana:='s';
end;

{Cambia el estado de las ranas}
procedure cambiaTurno(a,b,c,d:char;VAR a2,b2,c2,d2:char;r0,r1,r2,r3:char);
var
   numeroRanasCroando:integer;
begin
     numeroRanasCroando:=cuentaRanasCroando(a,b,c,d);
     a2:=cambiaEstadoRana(a,numeroRanasCroando,r0,r1,r2,r3);
     b2:=cambiaEstadoRana(b,numeroRanasCroando,r0,r1,r2,r3);
     c2:=cambiaEstadoRana(c,numeroRanasCroando,r0,r1,r2,r3);
     d2:=cambiaEstadoRana(d,numeroRanasCroando,r0,r1,r2,r3);
end;

{Cuerpo principal del juego}
procedure cuerpoPrincipal(a,b,c,d,r0,r1,r2,r3:char;repeticiones:integer);
var
   a2,b2,c2,d2:char;{variables del siguiente turno}
   cambianComportamiento:char;{indica si hay un cmabio de comportamiento en el turno}
begin
   cambianComportamiento:='s';

   repeat
         {Pinta el estado validado}
         pintaEstado(a,b,c,d);

         cambiaTurno(a,b,c,d,a2,b2,c2,d2,r0,r1,r2,r3);
         {comprueba si se va a hacer una ejecucin mas}
         cambianComportamiento:=compruebaEstadoCambio(a,b,c,d,a2,b2,c2,d2);
         repeticiones:=repeticiones-1;
         {asigna los valores del proximo estado}
         a:=a2;b:=b2;c:=c2;d:=d2;
   until (cambianComportamiento='n') or (repeticiones=0);
   if(cambianComportamiento='n') then write('El estado de las ranas se repite');
end;

var
	A,B,C,D:char;
	R0,R1,R2,R3:char;
	simbo,nuevo:char;
begin
      repeat

{Limpia la pantalla}
        clrscr;
{Pidiendo las ranas y las reglas}
	pedirRanas (A,B,C,D);
	pedirReglas (R0,R1,R2,R3);
{Pintando charca}
        cuerpoPrincipal(a,b,c,d,r0,r1,r2,r3,20);
        read(simbo);

       write('Quieres jugar de nuevo, s/n?: ');
       readln(nuevo);
       writeln;
       while not ((nuevo='s') or (nuevo='n')) do

             begin

             write('Error, pulsa s  n: ');
             readln(nuevo);
             writeln;
             end;


     until  (nuevo='n');


end.