Program Ranas;
  Procedure Inicializacion;
  {Procedimiento que simplemente presenta el programa al usuario}
    Begin
      writeln('Bienvenido al programa "la charca"');
      writeln;
      writeln('Con esta aplicacin podr hacer croar a varias ranas');
      writeln;
      writeln('Hay 4 ranas en la charca');
      writeln;
    End;
  Function CambioCaracteres (Aux:Char):Char;
  {Funcin que convierte un dato a 'C'(Croar) o a '_'(Callar)}
    Var
      Rana:Char;
    Begin
      Case Aux of
        'A':Rana:='_';
        'C':Rana:='C';
      End;
      CambioCaracteres:=Rana;
    End;
  Procedure EstadoInicial(var turactA,turactB,turactC,turactD:char);
  {Procedimiento que recoge el estado inicial de cada rana}
    Begin
      writeln('En el estado inicial indique que rana croa(C) o calla (A)');
      writeln;
      Repeat
          writeln('Croa o calla ranaA:');
          readln(turactA);
      Until (turactA='C') or (turactA='A');
          turactA:=CambioCaracteres(turactA);
      Repeat
          writeln('Croa o calla ranaB:');
          readln(turactB);
      Until (turactB='C') or (turactB='A');
          turactB:=CambioCaracteres(turactB);
      Repeat
          writeln('Croa o calla ranaC:');
          readln(turactC);
      Until (turactC='C') or (turactC='A');
          turactC:=CambioCaracteres(turactC);
      Repeat
          writeln('Croa o calla ranaD:');
          readln(turactD);
      Until (turactD='C') or (turactD='A');
          turactD:=CambioCaracteres(turactD);
    End;
  Procedure CondicionesVecinas(var C0,C1,C2,C3:Char);
  {Procedimiento que recoge las condiciones en las que actuar la Charca}
    Begin
      writeln('Indique procedimiento a seguir en cada caso:Croar(S) o Callar(A):');
      writeln;
      Repeat
          writeln('Si croan cero ranas vecinas:');
          readln(C0);
      Until (C0='C') or (C0='A');
      C0:=CambioCaracteres(C0);
      Repeat
          writeln('Si croa una rana vecina:');
          readln(C1);
      Until (C1='C') or (C1='A');
      C1:=CambioCaracteres(C1);
      Repeat
          writeln('Si croan dos ranas vecinas:');
          readln(C2);
      Until (C2='C') or (C2='A');
      C2:=CambioCaracteres(C2);
      Repeat
          writeln('Si croan tres ranas vecinas:');
          readln(C3);
      Until (C3='C') or (C3='A');
      C3:=CambioCaracteres(C3);
      writeln;
    End;
  Procedure DibujarCharca (turactA,turactB,turactC,turactD:Char;i:Integer);
  {Procedimiento que dibuja la Chaca}
    Begin
      If i<10 then
        write(i,': ')
       Else
        write(i,':');
      writeln(turactA,turactB,turactC,turactD);
    End;
  Function Turno(Vec1,Vec2,Vec3,C0,C1,C2,C3:Char):Char;
  {Funcin que da un valor a la rana en funcin de sus vecinas y las condiciones}
    Var
      i:Integer;
      TurnoRana:Char;
    Begin
      i:=0;
       If Vec1='C' then
         i:=i+1;
       If Vec2='C' then
         i:=i+1;
       If Vec3='C' then
         i:=i+1;
       Case i of
         0:TurnoRana:=C0;
         1:TurnoRana:=C1;
         2:TurnoRana:=C2;
         3:TurnoRana:=C3;
       End;
       Turno:=TurnoRana;
    End;
  Function CharcaIgual (turactA,turactB,turactC,turactD,tursigA,tursigB,tursigC,tursigD:Char):Boolean;
  {Funcin que indica si el turno anterior y el actual son iguales}
    Begin
      If (turactA=tursigA) and (turactB=tursigB) and (turactC=tursigC) and (turactD=tursigD) then
         CharcaIgual:=True
       Else
         CharcaIgual:=False;
     End;
  Procedure SiguienteTurno (turactA,turactB,turactC,turactD,C0,C1,C2,C3:Char;Var tursigA,tursigB,tursigC,tursigD:Char);
  {Funcin que calcula el valor de las ranas en cada turno}
    Var
      i:Integer;
      Charca:Boolean;
    Begin
      i:=1;
      writeln('   ABCD');
      writeln;
      DibujarCharca(turactA,turactB,turactC,turactD,i);
      Repeat
         tursigA:=Turno(turactB,turactC,turactD,C0,C1,C2,C3);
         tursigB:=Turno(turactA,turactC,turactD,C0,C1,C2,C3);
         tursigC:=Turno(turactA,turactB,turactD,C0,C1,C2,C3);
         tursigD:=Turno(turactA,turactB,turactC,C0,C1,C2,C3);
         i:=i+1;
         DibujarCharca(tursigA,tursigB,tursigC,tursigD,i);
         Charca:=CharcaIgual(turactA,turactB,turactC,turactD,tursigA,tursigB,tursigC,tursigD);
         turactA:=tursigA;
         turactB:=tursigB;
         turactC:=tursigC;
         turactD:=tursigD;
      Until (i=20) or (Charca=True);
      writeln;
    End;
  Function RepetirCharca (Respuesta:Char):Boolean;
  {Funcin que nos indicar si el usuario quiere repetir el programa o no}
    Var
      Repetir:Boolean;
    Begin
       If Respuesta='S' then
          Repetir:=True
        Else
          Repetir:=False;
       RepetirCharca:=Repetir;
     End;
  Procedure Pregunta (Var Repetir:Boolean);
  {Procedimiento que indica si el programa debe repetirse o no}
    Var
      Respuesta:Char;
    Begin
     Repeat
       writeln('Quiere volver a realizar una "Charca" (S/N)?');
       readln(Respuesta);
       writeln;
     Until (Respuesta='S') or (Respuesta='N');
     Repetir:=RepetirCharca(Respuesta);
    End;
  {Programa principal}
   Var
     turactA,turactB,turactC,turactD:Char;
     tursigA,tursigB,tursigC,tursigD:Char;
     C0,C1,C2,C3:Char;
     Repetir:Boolean;
   Begin
     Inicializacion;
     Repetir:=True;
     While Repetir=True do
      Begin
       EstadoInicial(turactA,turactB,turactC,turactD);
       CondicionesVecinas(C0,C1,C2,C3);
       SiguienteTurno(turactA,turactB,turactC,turactD,C0,C1,C2,C3,tursigA,tursigB,tursigC,tursigD);
       Pregunta(Repetir);
      End;
     writeln('Pulse ENTER para salir');
     readln;
   End.





