program ranas;

Uses crt;
function inicializarPrimerTurno:boolean;
var
	croar:char;
begin
	writeln('Quiere que la rana croe en el primer turno?');
    writeln('Si quiere que croe pulse S sino pulse N');

    {$I-}
    readln(croar);
    {$I+}

    while (((croar<>'S') and (croar<>'N') and (croar<>'s') and (croar<>'n')) or (IOResult <> 0)) do
       begin
    	writeln('Lo sentimos, debe pulsar S o N');
    	writeln('Quiere que la rana croe en el primer turno?');
    	writeln('Si quiere que croe pulse S sino pulse N');

        {$I-}
        readln(croar);
        {$I+}
       end;

    if ((croar = 'S') or (croar = 's')) then inicializarPrimerTurno := true
    else
     inicializarPrimerTurno := false;
end;

function inicializarCondicion(ranas_cantando:integer):boolean;
var
	croar:char;
begin
	write('Quiere que las ranas croen cuando haya ');
	write(ranas_cantando);
	writeln(' rana(s) croando?');
	writeln('Si quiere que croen pulse S sino pulse N');

    {$I-}

    readln(croar);

    {$I+}

    while (((croar<>'S') and (croar<>'N') and (croar<>'s') and (croar<>'n')) or (IOResult <> 0)) do
	begin

    	 writeln('Lo sentimos, debe pulsar S o N');
    	 writeln('Quiere que la rana croe en el primer turno?');
    	 writeln('Si quiere que croe pulse S sino pulse N');

         {$I-}
         readln(croar);
         {$I+}
        end;
    if ((croar = 'S') or (croar = 's')) then inicializarCondicion := true
    else inicializarCondicion := false;
end;

procedure inicializacion(VAR ranaA,ranaB,ranaC,ranaD,croa_0,croa_1,croa_2,croa_3:boolean);
begin
	writeln('Rana A');
	ranaA := inicializarPrimerTurno;
	writeln('Rana B');
	ranaB := inicializarPrimerTurno;
	writeln('Rana C');
	ranaC := inicializarPrimerTurno;
	writeln('Rana D');
	ranaD := inicializarPrimerTurno;
	croa_0 := inicializarCondicion(0);
	croa_1 := inicializarCondicion(1);
	croa_2 := inicializarCondicion(2);
	croa_3 := inicializarCondicion(3);
end;

function contarCantando(rana1,rana2,rana3:boolean):integer;
var
	cuenta:integer;
begin
	cuenta := 0;
	if (rana1) then cuenta := cuenta+1;
	if (rana2) then cuenta := cuenta+1;
	if (rana3) then cuenta := cuenta+1;
	contarCantando := cuenta;
end;


procedure calcularRana(VAR rana_sig:boolean; croa_0,croa_1,croa_2,croa_3:boolean; cantando:integer);
begin
	case cantando of
	 0: rana_sig := croa_0;
     	 1: rana_sig := croa_1;
     	 2: rana_sig := croa_2;
  	 3: rana_sig := croa_3;
        end;
end;

procedure calcularSiguienteEstado(VAR ranaA_sig,ranaB_sig,ranaC_sig,ranaD_sig:boolean;
					   				  ranaA,ranaB,ranaC,ranaD,
					  				  croa_0,croa_1,croa_2,croa_3:boolean);
var
	cantandoA,cantandoB,cantandoC,cantandoD:integer;
begin
	cantandoA := contarCantando(ranaB,ranaC,ranaD);
	cantandoB := contarCantando(ranaA,ranaC,ranaD);
	cantandoC := contarCantando(ranaA,ranaB,ranaD);
	cantandoD := contarCantando(ranaA,ranaB,ranaC);
	calcularRana(ranaA_sig,croa_0,croa_1,croa_2,croa_3,cantandoA);
	calcularRana(ranaB_sig,croa_0,croa_1,croa_2,croa_3,cantandoB);
	calcularRana(ranaC_sig,croa_0,croa_1,croa_2,croa_3,cantandoC);
	calcularRana(ranaD_sig,croa_0,croa_1,croa_2,croa_3,cantandoD);
end;

function comprobarIguales(ranaA,ranaA_sig,ranaB,ranaB_sig,ranaC,ranaC_sig,ranaD,ranaD_sig:boolean):boolean;
 begin

  comprobarIguales := (ranaA = ranaA_sig) and   (ranaB = ranaB_sig) and
                      (ranaC = ranaC_sig) and (ranaD = ranaD_sig);
 end;


function comprobarFinalizacion(ronda:integer;iguales_actual,iguales_siguiente:boolean):boolean;
var
	resultado:boolean;
begin
	if(ronda>=20) then resultado := true
	else
         begin
		if ((iguales_actual) and (iguales_siguiente)) then resultado := true
		else resultado := false;
	 end;

	comprobarFinalizacion := resultado;
end;

procedure visualizarRana(croa:boolean);
begin
	if (croa) then write('C')
	else write('_')
end;

procedure visualizarEstado(ranaA,ranaB,ranaC,ranaD:boolean; ronda:integer);
begin
	write(ronda);
	write(': ');
	visualizarRana(ranaA);
	visualizarRana(ranaB);
	visualizarRana(ranaC);
	visualizarRana(ranaD);
	writeln('');
end;

 procedure avanzarRanas(VAR ranaA,ranaB,ranaC,ranaD:boolean; ranaA_sig,ranaB_sig,ranaC_sig,ranaD_sig:boolean);
 begin
	ranaA := ranaA_sig;
	ranaB := ranaB_sig;
	ranaC := ranaC_sig;
	ranaD := ranaD_sig;
 end;


 {Programa Principal}

Var
	ranaA,ranaB,ranaC,ranaD:boolean; {Estado actual de las ranas}
	ranaA_sig,ranaB_sig,ranaC_sig,ranaD_sig:boolean; {Siguiente estado de las ranas}
	croa_0,croa_1,croa_2,croa_3,croa_4:boolean; {Indican cuando croan}
	ronda:integer;
	final:boolean;
	iguales_actual,iguales_siguiente:boolean;
	fin:char;

Begin
	inicializacion(ranaA,ranaB,ranaC,ranaD,croa_0,croa_1,croa_2,croa_3);
	ronda := 0;
	final := false;
	iguales_actual := false;

	while(not final) do
	 begin
		calcularSiguienteEstado(ranaA_sig,ranaB_sig,ranaC_sig,ranaD_sig,
				   				ranaA,ranaB,ranaC,ranaD,
				   				croa_0,croa_1,croa_2,croa_3);
		ronda := ronda + 1;
		visualizarEstado(ranaA,ranaB,ranaC,ranaD,ronda);
		iguales_siguiente := comprobarIguales(ranaA,ranaA_sig,ranaB,ranaB_sig,ranaC,ranaC_sig,ranaD,ranaD_sig);
		final := comprobarFinalizacion(ronda,iguales_actual,iguales_siguiente);
		iguales_actual := iguales_siguiente;
		avanzarRanas(ranaA,ranaB,ranaC,ranaD,ranaA_sig,ranaB_sig,ranaC_sig,ranaD_sig);
	 end;

	writeln('Introduzca cualquier letra para finalizar');

	{I-}
	readln(fin);
	{I+}
        clrscr;
end.