Program Ranitas;

Uses CRT;

Procedure PulsaTecla;
var c:char;
   Begin
      Repeat
      Until KeyPressed;
      while KeyPressed do c:=readkey;

   End;

{Procedimiento de cabecera del juego}
Procedure CabeceraJuego;
   Begin
      clrscr;
      TextColor (yellow);
      TextBackground (blue);
      Gotoxy (21,2); writeln ('*****************************************');
      Gotoxy (21,3); writeln ('** PRACTICA 2:  RANAS CROANDO ***********');
      Gotoxy (21,4); writeln ('*****************************************');
      Gotoxy (21,5); writeln ('**** Autoras: Lucia Martinez Latorre ****');
      Gotoxy (21,6); writeln ('************* Monica Pilar Mores ********');
      Gotoxy (21,7); writeln ('*****************************************');
      Gotoxy (21,8); writeln ('Este juego simula un grupo de 4 ranas    ');
      Gotoxy (21,9); writeln ('croando alrededor de una charca durante  ');
      Gotoxy (21,10); writeln ('una serie de turnos.                     ');
      Gotoxy (21,11); writeln ('Para comenzar diras si cada rana va a    ');
      Gotoxy (21,12); writeln ('croar y en que condiciones croara.       ');
      Gotoxy (21,13); writeln ('* Nota: Para que los turnos vayan pasando');
      Gotoxy (21,14); writeln ('         debes presionar una tecla.      ');
      TextColor (white);
      TextBackground (black);
      writeln;
      Gotoxy (21,20); writeln('Pulse una tecla para comenzar el juego');
      PulsaTecla;
      writeln;
      clrscr;
   end;

{Procedimiento para pintar el tablero de juego}
Procedure Tablero (t:integer);
   Begin
      TextColor (green);
      Gotoxy (1+(t mod 5)*15,2+(t div 5)*5); writeln ('+------+------+');
      Gotoxy (1+(t mod 5)*15,3+(t div 5)*5); writeln ('|      |      |');
      Gotoxy (1+(t mod 5)*15,4+(t div 5)*5); writeln ('+------+------+');
      Gotoxy (1+(t mod 5)*15,5+(t div 5)*5); writeln ('|      |      |');
      Gotoxy (1+(t mod 5)*15,6+(t div 5)*5); writeln ('+-------------+');
      TextColor (white);
      writeln;

   end;

{Procedimiento para pintar las ranas}
Procedure PintarRanas (ranaa,ranab,ranac,ranad:char;turn:integer);
   Begin
      TextColor (green);
      if (ranaa='s') or (ranaa='S') then
         begin Gotoxy (2+(turn mod 5)*15,3+(turn div 5)*5); write ('CROOAA') end;
      if (ranab='s') or (ranab='S') then
         begin Gotoxy (2+(turn mod 5)*15,5+(turn div 5)*5); write ('CROOAA') end;
      if (ranac='s') or (ranac='S') then
         begin Gotoxy (9+(turn mod 5)*15,3+(turn div 5)*5); write ('CROOAA') end;
      if (ranad='s') or (ranad='S') then
         begin Gotoxy (9+(turn mod 5)*15,5+(turn div 5)*5); write ('CROOAA') end;
      TextColor (white);
   end;

{Procedimiento para decir que la respuesta del usuario a las preguntas es correcta}
Procedure EsCorrecta (var caracter:char);
   Begin
      readln (caracter);
      while (caracter<>'s') and (caracter<>'S') and (caracter<>'n') and (caracter<>'N') do
            begin
               writeln ('Debes contestar S/N');
               readln(caracter);
            end;
   end;

{Procedimiento para pedir al usuario si quiere que croen cada una de las ranas}
Procedure Croar ( var ra,rb,rc,rd:char);
   Begin
       writeln ('Di si quieres que cada una de las siguientes ranas croe');
       writeln;
       write ('Rana A :  ');
       EsCorrecta(ra);
       writeln;
       write ('Rana B :  ');
       EsCorrecta(rb);
       writeln;
       write ('Rana C :  ');
       EsCorrecta(rc);
       writeln;
       write ('Rana D :  ');
       EsCorrecta(rd);
       writeln;
   End;

{Procedimiento en el que se pide al usuario en que condicinoes van a croar las ranas}
Procedure Condiciones (var cero,uno,dos,tres :char);
   Begin
       writeln;
       writeln ('Contesta con S/N para cada uno de los siguientes casos');
       writeln;
       writeln ('Cuando quieres que croen las ranas?');
       writeln;
       writeln ('Cuando haya:'); writeln;
       write (' 0 ranas vecina croando:    ');
       EsCorrecta(cero);
       writeln;
       write (' 1 rana vecina croando:    ');
       EsCorrecta(uno);
       writeln;
       write (' 2 ranas vecina croando:    ');
       EsCorrecta(dos);
       writeln;
       write (' 3 ranas vecina croando:    ');
       EsCorrecta(tres);
       writeln;
   End;

{Procedimiento para finalizar el juego}
Procedure TerminarJuego (var acaba:char);
   Begin
       writeln;writeln;writeln;writeln;writeln;
       writeln('Desea volver a jugar de nuevo?');
       EsCorrecta(acaba);
   end;

{Funcion que devuelve si dos turnos son iguales}
Function Iguales (a,b,c,d,x,y,z,w:char):boolean;
   Begin
       if (a=x) and (b=y) and (c=z) and (d=w) then Iguales:=true
       else Iguales:=false;
   end;

{Funcion para contar el  numero de ranas vecinas}
Function Contar (x,y,z:char):integer;
var n:integer;
   Begin
       n:=0;
       if (x='s') or (x='S') then n:=n+1;
       if (y='s') or (y='S') then n:=n+1;
       if (z='s') or (z='S') then n:=n+1;
       Contar:=n;
   end;

{Procedimiento para comparar las ranas vecinas con los casos}
Procedure Comparar (n:integer; caso0,caso1,caso2,caso3:char;
                   var x:char);
   Begin
      if n=0 then x:=caso0;
      if n=1 then x:=caso1;
      if n=2 then x:=caso2;
      if n=3 then x:=caso3;
   end;

{Procedimiento para cambiar valores de una variable a otra}
Procedure CambioValores ( x:char;
                        var n:char);
   Begin
       n:=x;
   end;


Var
   a,b,c,d,a1,b1,c1,d1:char;
   casocero,casouno,casodos,casotres:char;
   termina:char;
   turno:integer;
   salir:boolean;

Begin
   CabeceraJuego;
   termina:='S';
   while (termina='s') or (termina='S') do
     Begin
     clrscr;
     turno:=0; salir:=false;
     Croar (a,b,c,d);
     Condiciones(casocero,casouno,casodos,casotres);
     clrscr;
     while (turno<=19) and (Not salir) do
         begin
              Comparar(Contar(b,c,d),casocero,casouno,casodos,casotres,a1);
              Comparar(Contar(a,c,d),casocero,casouno,casodos,casotres,b1);
              Comparar(Contar(a,b,c),casocero,casouno,casodos,casotres,d1);
              Comparar(Contar(a,b,d),casocero,casouno,casodos,casotres,c1);
              salir:=Iguales(a,b,c,d,a1,b1,c1,d1);
              CambioValores(a1,a);
              CambioValores(b1,b);
              CambioValores(c1,c);
              CambioValores(d1,d);
              Tablero(turno);
              PintarRanas(a,b,c,d,turno);
              PulsaTecla;
              turno:=turno+1;
          end;
   TerminarJuego(termina);
   end;
End.