Program Juego_De_Ranas;

Uses
  Crt;

Procedure Datos_Rana (var croa:integer);
{Introduce la posibilidad de croar o no de la rana en el primer turno}

    Var
      resp:char;

    Begin
       Repeat
       write ('Esta rana croa en el primer turno?,(S/N): ');
       readln (resp);
       resp:=upcase(resp);
       Until (resp='S') Or (resp='N');
       croa:=0;
       If resp='S' Then croa:=1;
    End;

Procedure Condicion (var con0,con1,con2,con3:integer);
{Introduce la posibilidad para determinar en qu condiciones va a croar}

    Var
      i:integer;
      resp:char;

    Begin
       For i:=0 To 3 Do
         Begin
            Repeat
               write ('Las ranas croaran en el siguiente turno si hay ',i,' vecinas croando? (S/N): ');
               readln (resp);
               writeln;
               resp:=upcase(resp);
            Until ((resp='S') Or (resp='N'));
            If i=0 Then
               If resp='S' Then con0:=0 Else con0:=4;
            If i=1 Then
               If resp='S' Then con1:=1 Else con1:=4;
            If i=2 Then
               If resp='S' Then con2:=2 Else con2:=4;
            If i=3 Then
               If resp='S' Then con3:=3 Else con3:=4
               {En caso de que la respuesta sea negativa le asignamos
                el valor 4 que segun la construccion de la funcion
                Rana_Vecina es una condicion imposible.}
         End
End;

Procedure Escribe_Linea (c1,c2,c3,c4:integer);
{Muestra por pantalla la combinacin de las ranas croando o no}

    Begin
       If c1=1 Then write ('C') Else write ('_');
       If c2=1 then write ('C') Else write ('_');
       If c3=1 then write ('C') Else write ('_');
       If c4=1 then writeln ('C') Else writeln ('_')
    End;

function Iguales (c1,c2,c3,c4,a1,a2,a3,a4:integer):boolean;
{Determina si una lnea de combinacin de ranas es igual a la anterior}

    Begin
       If (c1=a1) And (c2=a2) And (c3=a3) And (c4=a4) Then iguales:= TRUE Else iguales:=FALSE
    End;

Procedure Guarda_Anterior (c1,c2,c3,c4:integer; var a1,a2,a3,a4:integer);
{Guardo primer turno de la combinacin de ranas}

    Begin
       a1:=c1;
       a2:=c2;
       a3:=c3;
       a4:=c4
    End;

Procedure Actualiza_Croado (var c1,c2,c3,c4:integer; a1,a2,a3,a4,con1,con2,con3,con4:integer);
{Actualiza los turnos de las distintas combinaciones de las ranas}

       Function Rana_Vecina (atx,aty,atz,cd1,cd2,cd3,cd4:integer):integer;
       {Compara la situacion de las ranas vecinas con las
       condiciones de croado introducidas por el usuario}

           Begin
              If (atx+aty+atz=cd1) Or (atx+aty+atz=cd2) Or (atx+aty+atz=cd3) Or (atx+aty+atz=cd4) Then
              Rana_Vecina:=1 Else Rana_Vecina:=0
           End;

    Begin
       c1:=Rana_Vecina(a2,a3,a4,con1,con2,con3,con4);
       c2:=Rana_Vecina(a1,a3,a4,con1,con2,con3,con4);
       c3:=Rana_Vecina(a2,a1,a4,con1,con2,con3,con4);
       c4:=Rana_Vecina(a2,a3,a1,con1,con2,con3,con4)
    End;


Var {Comienza programa principal}
  res: char;
  j,control,cA,conA,cB,conB,cC,conC,cD,conD,antA,antB,antC,antD: integer;

Begin
  Repeat
     Clrscr;
     writeln ('A continuacion se le pediran los datos iniciales de cada rana.');
     writeln;
     writeln ('Rana A: ');
     Datos_Rana (cA);
     writeln;
     writeln ('Rana B: ');
     Datos_Rana (cB);
     writeln;
     writeln ('Rana C: ');
     Datos_Rana (cC);
     writeln;
     writeln ('Rana D: ');
     Datos_Rana (cD);
     writeln;
     writeln;
     writeln ('Condiciones de croado: ');
     writeln;
     Condicion (conA,conB,conC,conD);
     control:=0;
     j:=1;
     While (j<=20) And (control<2) Do
        Begin
           writeln;
           Escribe_Linea (cA,cB,cC,cD);
           Guarda_Anterior (cA,cB,cC,cD,antA,antB,antC,antD);
           Actualiza_Croado (cA,cB,cC,cD,antA,antB,antC,antD,conA,conB,conC,conD);
           If iguales(cA,cB,cC,cD,antA,antB,antC,antD) Then control:=control+1 Else control:=0;
           j:=j+1
        End;
     Repeat
        writeln;
        write ('Quiere volver a jugar?,(S/N): ');
        readln (res);
        res:=upcase(res);
     Until ((res='S') Or (res='N'));
Until (res='N');
End.