program juego_de_la_rana;
uses crt;

procedure condiciones_ranas(orden : char;var que_rana : boolean);

{Este procedimiento necesita 2 variables, que_rana y la rana que es, para
modificar la variable que_rana cpn las condiciones introducidas. Lo que resulta
son las condiciones de inicio de la rana}

var
  respuesta : char;
  incorrecto : boolean;
  i : integer;

begin
  write(' Quiere que la rana ' , orden,  ' croe al inicio ? S/N ');
  repeat
    respuesta:= readkey;
    que_rana := false;{para saber si la rana va a croar al principio y
    luego saber si debe croar o no}
    incorrecto := false; {para saber si he metido s-S-n-N}
    if (respuesta = 's') or (respuesta = 'S') then
      begin
        writeln(upcase(respuesta));
        que_rana:= true
      end
     else
       if (respuesta = 'n') or (respuesta = 'N') then
         begin
           que_rana := false;
           writeln(upcase(respuesta));
         end
        else
         incorrecto := true;
  until (incorrecto = false);
end;

procedure como_croar(letra : char;var c:boolean;var u:boolean;var d:boolean;var t:boolean);

{Este procedimiento necesita el nombre de la rana a tratar, para saber como
va a croar en el programa. No modifica nada.}

var i :integer;
    respuesta : char;
begin
  {aqui voy a preguntar como quiero que croe en cada turno}
  c := false;
  u := false;
  d := false;
  t := false;
  for i := 0 to 3 do
    begin
      write(' Quiere que croe la rana ');
      write(letra,' si hay ');
      write(i);
      write(' ranas croando a su alrededor? (S/N) ');
      repeat
        respuesta := readkey
      until (respuesta = 'S') or (respuesta = 's') or
            (respuesta = 'N') or (respuesta = 'n');

      writeln(upcase(respuesta));
      if (respuesta = 's') or (respuesta = 'S') then
        begin
          case i of
            0: c := true;
            1: u := true;
            2: d := true;
            3: t := true;
          end;
        end;
    end;
end;

procedure pintar_estado(rana:boolean;var pintado:string);

{Este procedimiento necesita saber el estado de la rana que vamos a pintar,
para que pinte en pantalla C si la rana esta croando y un espacio en blanco
si no lo esta. Este modulo modifica el valor de la variable pintado}

begin
    if (rana) then
      begin
        write('C ');
        pintado := pintado + 'C';
      end
     else
      begin
        write('  ');
        pintado := pintado + ' ';
      end
end;

procedure tratamiento_rana(rana_1,rana_2,rana_3 : boolean;var rana:boolean;
         cero,uno,dos,tres:boolean);

{Este procedimiento necesita el estado de las ranas, de como debe croar una rana
dependiendo de cuantas ranas estan croando alrededor asi como el contador de
veces que no se ha modificado el estado (croando o no) de la rana. Modifica la
variable rana. Lo que devuelve es el estado de la variable rana y el contador
de veces que no se ha cambiado el estado de la rana.}

var cuantas_croando : integer;

begin
  cuantas_croando := 0;
  if rana_1 then
    cuantas_croando := cuantas_croando + 1;
  if rana_2 then
    cuantas_croando := cuantas_croando + 1;
  if rana_3 then
    cuantas_croando := cuantas_croando + 1;
  {en cuantas croando tengo el numero de ranas que estan croando alrededor de una de ellas}
  case cuantas_croando of
    0:
      rana := cero;
    1:
      rana := uno;
    2:
      rana := dos;
    3:
      rana := tres;
  end;
end;

var
  rana_a, rana_b, rana_c, rana_d : boolean;{para saber las condiciones de la rana}
  rana_a_old, rana_b_old, rana_c_old, rana_d_old : boolean;{para guarda la anterior}
  cero_a,uno_a,dos_a,tres_a: boolean;{true->croa, false-> no croa}
  cero_b,uno_b,dos_b,tres_b: boolean;{true->croa, false-> no croa}
  cero_c,uno_c,dos_c,tres_c: boolean;{true->croa, false-> no croa}
  cero_d,uno_d,dos_d,tres_d: boolean;{true->croa, false-> no croa}
  respuesta : char;
  contador : integer;
  salir : boolean;
  pintado_antes,pintado_ahora : string;

{Programa principal}

begin
  repeat
    clrscr; {limpio pantalla}
    {cojo los datos de las ranas}
    condiciones_ranas('A',rana_a);
    condiciones_ranas('B',rana_b);
    condiciones_ranas('C',rana_c);
    condiciones_ranas('D',rana_d);
    como_croar('A',cero_a,uno_a,dos_a,tres_a);
    como_croar('B',cero_b,uno_b,dos_b,tres_b);
    como_croar('C',cero_c,uno_c,dos_c,tres_c);
    como_croar('D',cero_d,uno_d,dos_d,tres_d);
    clrscr;
    pintado_antes := '';
    pintado_ahora := '';
    contador := 1;{ inicializo variables}
    salir := false;

    writeln('          A B C D');
    writeln('');

    while ((contador <= 20) and (salir = false)) do
      begin
        write('Turno ');
        if (contador < 10) then
          write('0');
        write(contador);
        write(': ');
        pintado_antes := pintado_ahora;
        pintado_ahora := '';
        pintar_estado(rana_a,pintado_ahora);
        pintar_estado(rana_b,pintado_ahora);
        pintar_estado(rana_c,pintado_ahora);
        pintar_estado(rana_d,pintado_ahora);
        writeln('');{salto de linea por el cambio de turno}

        {guardo la posicion anterior}
        rana_a_old := rana_a;
        rana_b_old := rana_b;
        rana_c_old := rana_c;
        rana_d_old := rana_d;

        {rana a}
        tratamiento_rana(rana_b,rana_c,rana_d,rana_a_old,cero_a,uno_a,dos_a,tres_a);
        {rana b}
        tratamiento_rana(rana_a,rana_c,rana_d,rana_b_old,cero_b,uno_b,dos_b,tres_b);
        {rana c}
        tratamiento_rana(rana_a,rana_b,rana_d,rana_c_old,cero_c,uno_c,dos_c,tres_c);
        {rana d}
        tratamiento_rana(rana_a,rana_b,rana_c,rana_d_old,cero_d,uno_d,dos_d,tres_d);

        rana_a := rana_a_old;
        rana_b := rana_b_old;
        rana_c := rana_c_old;
        rana_d := rana_d_old;

        contador := contador + 1;
        if (pintado_antes = pintado_ahora) then
          salir := true
      end;
    {pregunto si desea repetir}
    writeln('');{salto de linea}
    respuesta := ' ';
    write(' Desea repetir el juego de las ranas ? S/N : ');
    repeat
     respuesta := readkey;
    until (respuesta = 's') or
          (respuesta = 'S') or
          (respuesta = 'n') or
          (respuesta = 'N');
    writeln(upcase(respuesta));
  until (respuesta = 'N') or (respuesta = 'n');
end.
