program ranas_croando;

{Utilizamos la biblioteca crt para poder utilizar el procedimiento ClearScreen}
uses
    crt;

{Esta funcion devuelve un booleano y sirve para determinar si la rana esta o no croando}
{Esta funcion sera llamada en el programa principal}
function  rana_inicial:boolean;
          var
             {Esta variable es de tipo char, para la pregunta de si la rana esta croando}
             resp:char;

          begin
               writeln('La rana esta croando?(Pulse S(Si) o N(No)): ');
               readln(resp);
               {utilizamos while para proporcionar al programa una entrada robusta de datos}
               while NOT ((resp = 's') or (resp = 'S') or (resp = 'n') or (resp = 'N')) do
                     begin
                          writeln;
                          writeln('Por favor pulse S(Si) o N(No): ');
                          readln(resp);
                     end;

               {Si la respuesta es si, la funcion sera true, ya que es booleana}
               If ((resp = 's') or (resp = 'S')) then
               rana_inicial:=true;

               {Si la respuesta es no, la funcion sera False}
               If ((resp = 'n') or (resp = 'N')) then
               rana_inicial:=false;
          end;

{Este procedimiento sirve para la condiciones de cero ranas vecinas croando}
{Este programa utiliza variables de entrada que determinan si las ranas estan o no croando y el estado siguiente}
{Este procedimiento sera llamado en otro procedimiento}
procedure condicion0(v1,v2,v3,v4:boolean; var q1,q2,q3,q4:boolean);
          begin
               If ((v2 = False) and (v3 = False) and (v4 = False)) then
                  begin
                       q1:=True;
                  end
               else q1:=False;

               If ((v1 = False) and (v3 = False) and (v4 = False)) then
                  begin
                       q2:=True;
                  end
               else q2:=False;

               If ((v1 = False) and (v2 = False) and (v4 = False)) then
                  begin
                       q3:=True;
                  end
               else q3:=False;

               If ((v1 = False) and (v2 = False) and (v3 = False)) then
                  begin
                       q4:=True;
                  end
               else q4:=False;
          end;

{Este procedimiento sirve para la condiciones de una rana vecina croando}
{Este programa utiliza variables de entrada que determinan si las ranas estan o no croando y el estado siguiente}
{Este procedimiento sera llamado en otro procedimiento}
procedure condicion1(v1,v2,v3,v4:boolean; var x1,x2,x3,x4:boolean);
          begin
               If (((v2=True)and(v3=False)and(v4=False))or((v2=False)and(v3=True)and(v4=False))or
               ((v2=False)and(v3=False)and(v4=True))) then
                       x1:=True
               else x1:=False;

               If (((v1=True)and(v3=False)and(v4=False))or((v1=False)and(v3=True)and(v4=False))or
               ((v1=False)and(v3=False)and(v4=True))) then
                       x2:=True
               else x2:=False;

               If (((v2=True)and(v1=False)and(v4=False))or((v2=False)and(v1=True)and(v4=False))or
               ((v2=False)and(v1=False)and(v4=True))) then
                       x3:=True
               else x3:=False;

               If (((v2=True)and(v3=False)and(v1=False))or((v2=False)and(v3=True)and(v1=False))or
               ((v2=False)and(v3=False)and(v1=True))) then
                       x4:=True
               else x4:=False;
          end;

{Este procedimiento sirve para la condiciones de dos ranas vecinas croando}
{Este programa utiliza variables de entrada que determinan si las ranas estan o no croando y el estado siguiente}
{Este procedimiento sera llamado en otro procedimiento}
procedure condicion2(v1,v2,v3,v4:boolean; var y1,y2,y3,y4:boolean);
          begin
               If (((v2=True)and(v3=True)and(v4=False))or((v2=True)and(v3=false)and(v4=True))or
               ((v2=False)and(v3=True)and(v4=True))) then
                       y1:=True
               else y1:=False;

               If (((v1=True)and(v3=True)and(v4=False))or((v1=True)and(v3=False)and(v4=True))or
               ((v1=False)and(v3=True)and(v4=True))) then
                       y2:=True
               else y2:=False;

               If (((v2=True)and(v1=True)and(v4=False))or((v2=True)and(v1=False)and(v4=True))or
               ((v2=False)and(v1=True)and(v4=True))) then
                       y3:=True
               else y3:=False;

               If (((v2=True)and(v3=True)and(v1=False))or((v2=True)and(v3=False)and(v1=True))or
               ((v2=False)and(v3=True)and(v1=True))) then
                       y4:=True
               else y4:=False;
          end;

{Este procedimiento sirve para la condiciones de tres ranas vecinas croando}
{Este programa utiliza variables de entrada y de entrada-salida que determinan
si las ranas estan croando y el estado siguiente}
{Este procedimiento sera llamado en otro procedimiento}
procedure condicion3(v1,v2,v3,v4:boolean; var z1,z2,z3,z4:boolean);
          begin
               If ((v2 = True) and (v3 = True) and (v4 = True)) then
                  begin
                       z1:=True;
                  end
               else z1:=False;

               If ((v1 = True) and (v3 = True) and (v4 = True)) then
                  begin
                       z2:=True;
                  end
               else z2:=False;

               If ((v1 = True) and (v2 = True) and (v4 = True)) then
                  begin
                       z3:=True;
                  end
               else z3:=False;

               If ((v1 = True) and (v2 = True) and (v3 = True)) then
                  begin
                       z4:=True;
                  end
               else z4:=False;
          end;

{Esta funcion sirve para comprobar que si elijes mas de una condicion, si una rana esta croando croe, y no se contradigan entre
las distintas condiciones}
{Esta funcion tiene variables de entrada y salida booleanas, siendo cada una las ranas en cada condicion}
{Esta funcion sera llamada en un procedimiento posterior}
function comprobacion (var q,x,y,z:boolean):boolean;
          begin
               if ((q = True) or (x = True) or (y = True) or (z = True)) then
                  comprobacion:=True
               else comprobacion:=False;
          end;

{Este procedimiento sirve para dibujar el estado de las ranas por pantalla}
{Utilizamos un contador entero para ver en que turno estamos y los valores de croar o no de las ranas}
{Este procedimiento sera llamado en un procedimiento posterior}
procedure dibujar_condicion (var i:integer; var w1,w2,w3,w4:boolean);
          begin
               writeln;

               write(i,': ');

               If w1 = True then
                  write('C')
               else write('_');

               If w2 = True then
                  write('C')
               else write('_');

               If w3 = True then
                  write('C')
               else write('_');

               If w4 = True then
                  write('C')
               else write('_');

               readln;
          end;

{Este procedimiento sirve para detallar las condiciones que se utilizan para el programa}
{Las variables son de tipo Entrada-salida, son char}
{Este procedimiento sera llamado en un procedimiento posterior}
function condicion(i:integer):char;
          var
          resp:char;
          begin
               writeln;
               writeln('Desea que la condicin ',i,' rana(s) vecina(s) sea una condicion inicial?');
               writeln;
               writeln('Pulse S(Si) o N(No)): ');
               readln(resp);
               while NOT ((resp = 's') or (resp = 'S') or (resp = 'n') or (resp = 'N')) do
                     begin
                          writeln;
                          writeln('Por favor pulse S(Si) o N(No): ');
                          readln(resp);
                     end;

               condicion:=resp;
               end;

{Esta funcion determina si en 2 turnos se repite la misma situacion, y sera utilizado para anular el juego en ese caso}
{Esta funcion devuelve un booleano y utiliza variables tambien booleanas}
{Esta funcion sera llamada en un procedimiento posterior}
function repeticion_ranas(var v1,v2,v3,v4,w1,w2,w3,w4:boolean):boolean;
         begin
              If ((v1 = w1) and (v2 = w2) and (v3 = w3) and (v4 = w4)) then
                 repeticion_ranas:=True
              else repeticion_ranas:=False;
         end;

{Este procedimiento sirve para utilizar las condiciones elegidas y utilizar la funcion comprobacion(q,x,y,z)}
{Este procedimiento sera llamado en un procedimiento posterior}
procedure compro_cond(var v1,v2,v3,v4,w1,w2,w3,w4:boolean; var resp0,resp1,resp2,resp3:char;
          var i:integer; var x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,q1,q2,q3,q4:boolean);

          begin
               If ((resp0 = 's') or (resp0 = 'S')) then
                  condicion0(v1,v2,v3,v4,q1,q2,q3,q4);

               If ((resp1 = 's') or (resp1 = 'S')) then
                  condicion1(v1,v2,v3,v4,x1,x2,x3,x4);

               If ((resp2 = 's') or (resp2 = 'S')) then
                  condicion2(v1,v2,v3,v4,y1,y2,y3,y4);

               If ((resp3 = 's') or (resp3 = 'S')) then
                  condicion3(v1,v2,v3,v4,z1,z2,z3,z4);

               i:=i+1;
               w1:=comprobacion(q1,x1,y1,z1);
               w2:=comprobacion(q2,x2,y2,z2);
               w3:=comprobacion(q3,x3,y3,z3);
               w4:=comprobacion(q4,x4,y4,z4);
          end;


{Este procedimiento sirve para dibujar las ranas en los 20 turnos o cuando se repita 2 turnos seguidos,
utilizando procedimientos y funciones antes declaradas}
{Este procedimiento sera llamado en un procedimiento posterior}
procedure croar_ranas(var v1,v2,v3,v4,w1,w2,w3,w4,k:boolean; var resp0,resp1,resp2,resp3:char;
          var i:integer; var x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,q1,q2,q3,q4:boolean);

          begin
               i:=1;
               repeat
                compro_cond(v1,v2,v3,v4,w1,w2,w3,w4,resp0,resp1,resp2,resp3,i,x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,q1,q2,q3,q4);
                dibujar_condicion(i,w1,w2,w3,w4);
                k:=repeticion_ranas(v1,v2,v3,v4,w1,w2,w3,w4);
                v1:=w1; v2:=w2; v3:=w3; v4:=w4;
               until ((i=20) or (k=True));

               if i=20 then
               begin
                    writeln;
                    writeln('------------------------------------------------');
                    writeln(' Pulsa cualquier tecla para salir del juego');
                    writeln('------------------------------------------------');
                    readln;
               end;

               if k=True then
               begin
                    writeln;
                    writeln('-------------------------------------------------------------------');
                    writeln(' Se repiten dos turnos, pulsa cualquier tecla para salir del juego');
                    writeln('-------------------------------------------------------------------');
                    readln;
               end;

          end;

{Este es el procedimiento principal en el cual utilizaremos  procedimientos y funciones antes declaradas}
{Este procedimiento utiliza todas las variables que hemos utilizado durante todo el programa}
{Este procedimiento sera llamado en el programa principal}
procedure dibujo_programa(var v1,v2,v3,v4,w1,w2,w3,w4,k:boolean; var resp0,resp1,resp2,resp3:char;
          var i:integer; var x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,q1,q2,q3,q4:boolean);
          begin
             i:=0; resp0:=condicion(i);
             i:=1; resp1:=condicion(i);
             i:=2; resp2:=condicion(i);
             i:=3; resp3:=condicion(i);
             writeln;
             writeln('------------------------------------------------');
             writeln(' Pulsa cualquier tecla para iniciar el juego');
             writeln('------------------------------------------------');
             readln;
             w1:=v1; w2:=v2; w3:=v3; w4:=v4;
             ClrScr;
             writeln('--------------------------------------------------------------------------------');
             writeln('                           Ciclo Croador de las ranas');
             writeln('--------------------------------------------------------------------------------');
             i:=1;
             dibujar_condicion(i,w1,w2,w3,w4);
             v1:=w1; v2:=w2; v3:=w3; v4:=w4;
             croar_ranas(v1,v2,v3,v4,w1,w2,w3,w4,k,resp0,resp1,resp2,resp3,i,x1,x2,x3,x4,y1,y2,y3,y4,z1,z2,z3,z4,q1,q2,q3,q4);
          end;


{Estas son las variables del programa principal, ya que hay que declararlas aqui para no utilizar variables globales}
var
   R1,R2,R3,R4,S1,S2,S3,S4,T1,T2,T3,T4,U1,U2,U3,U4,V1,V2,V3,V4,A1,A2,A3,A4,a:Boolean;
   rep0,rep1,rep2,rep3:char;
   j:integer;

begin
     {Ensearemos una introduccion al programa}
     ClrScr;
     writeln('--------------------------------------------------------------------------------');
     writeln('                               Ranas croando');
     writeln('--------------------------------------------------------------------------------');
     writeln;
     writeln('Este es el juego de cuatro ranas croando en una charca.');
     writeln;
     writeln('Deseamos que le guste el juego.');
     writeln;

     writeln;
     writeln('Debe saber para no caer en error, que todas las ranas son vecinas entre si.');
     writeln;

     writeln;
     writeln('La posicion en el programa de las ranas es la siguiente:');
     writeln;
     writeln('R1-R2-R3-R4');

     writeln;
     writeln;
     writeln('------------------------------------------------');
     writeln(' Pulsa cualquier tecla para continuar');
     writeln('------------------------------------------------');
     writeln;

     readln;


     {preguntaremos al usuario sobre el estado inicial de cada rana, utilizando la funcion rana_inicial}
     ClrScr;
     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Rana 1');
     writeln('--------------------------------------------------------------------------------');
     writeln;
     R1:=rana_inicial;
     writeln;


     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Rana 2');
     writeln('--------------------------------------------------------------------------------');
     writeln;
     R2:=rana_inicial;
     writeln;

     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Rana 3');
     writeln('--------------------------------------------------------------------------------');
     writeln;
     R3:=rana_inicial;
     writeln;

     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Rana 4');
     writeln('--------------------------------------------------------------------------------');
     writeln;
     R4:=rana_inicial;

     writeln;
     writeln;
     writeln('------------------------------------------------');
     writeln(' Pulsa cualquier tecla para iniciar el juego');
     writeln('------------------------------------------------');
     writeln;

     readln;


     {Ahora utilizaremos el procedimiento principal del programa que es dibujo_programa}
     ClrScr;
     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Condiciones');
     writeln('--------------------------------------------------------------------------------');
     writeln;

     dibujo_programa (R1,R2,R3,R4,S1,S2,S3,S4,a,rep0,rep1,rep2,rep3,j,T1,T2,T3,T4,U1,U2,U3,U4,V1,V2,V3,V4,A1,A2,A3,A4);


     {utilizamos una breve finalizacion del programa para despedirnos del usuario y que no finalice de forma brusca}
     ClrScr;
     writeln;
     writeln('--------------------------------------------------------------------------------');
     writeln('                                 Fin');
     writeln('--------------------------------------------------------------------------------');
     writeln;

     writeln('Gracias por utilizar este programa.');
     writeln;
     writeln('Esperemos que se haya divertido.');
     writeln;
     writeln;
     writeln('------------------------------------------------');
     writeln(' Pulsa cualquier tecla para salir');
     writeln('------------------------------------------------');
     writeln;

     writeln;
     writeln;
     writeln('Programa realizado por Guillermo Minguillon Blasco y Javier Sancho Lalana.');


     readln;

end.