Program Ranas_croando;

 PROCEDURE BIENVENIDA;
 BEGIN
   writeln;
   writeln;
   writeln('         BIENVENIDO!!!!!!!!!!!!!!!!!');
   writeln;
   writeln('Vamos a jugar al juego de las ranas!');
   writeln;
 END;

 FUNCTION TOMA_DATOS (rana:char):char;
 {Esta funcin pide al usuario el estado inicial de cada rana}
 VAR
   resp:char;
 BEGIN
   Repeat
      write('Quieres que croe la rana ',rana,'? Escribe S (Si) o N (No):  ');
      readln(resp);
      resp:=upCase(resp);
   until ((resp='S') OR (resp='N'));
      If resp='S'
        then TOMA_DATOS:='C'
        else TOMA_DATOS:='_';
 END;

 PROCEDURE ESTADO_INICIAL_RANAS(VAR estadoA,estadoB,estadoC,estadoD:char);
 {Este procedimiento asigna el estado inicial de cada rana a una variable}
 BEGIN
    estadoA:=TOMA_DATOS('A');
    estadoB:=TOMA_DATOS('B');
    estadoC:=TOMA_DATOS('C');
    estadoD:=TOMA_DATOS('D');
    writeln
 END;

 FUNCTION CONDICIONES_INICIALES(vecinas:integer):char;
 {Pide al usuario las condiciones que debe cumplir cada rana para que croe}
 VAR
   condicion:char;
 BEGIN
   Repeat
     write('Si hay ',vecinas,' ranas vecinas croando, quieres que croe (S/N) ?');
     readln(condicion);
     condicion:=upCase(condicion);
   until ((condicion='S') OR (condicion='N'));
     CONDICIONES_INICIALES:=condicion;
 END;

 PROCEDURE CONDICIONES (VAR c0,c1,c2,c3:char);
 {Asigna las condiciones a variables}
 BEGIN
    c0:=CONDICIONES_INICIALES(0);
    c1:=CONDICIONES_INICIALES(1);
    c2:=CONDICIONES_INICIALES(2);
    c3:=CONDICIONES_INICIALES(3);
    writeln
 END;

 FUNCTION CROAR(estadoX:char):integer;
 {Transforma los caracteres C y _ en los enteros 1 y 0}
 BEGIN
   If estadoX='C'
     then CROAR:=1
     else CROAR:=0
 END;

 PROCEDURE CAMBIO_VARIABLES(estX,estY,estZ:integer;VAR est_t:char;c0,c1,c2,c3:char);
 {Compara el estado de las ranas vecinas y determina el nuevo estado}
 BEGIN
   CASE(estX+estY+estZ) OF
     0:If c0='S' then est_t:='C' else est_t:='_';
     1:If c1='S' then est_t:='C' else est_t:='_';
     2:If c2='S' then est_t:='C' else est_t:='_';
     3:If c3='S' then est_t:='C' else est_t:='_'
   END;
 END;

 PROCEDURE INTERCAMBIO(VAR estadoA,estadoB,estadoC,estadoD:char;est_a,est_b,est_c,est_d:char);
 {Intercambia las variables viejas y las nuevas de los estados}
 BEGIN
    estadoA:=est_a;
    estadoB:=est_b;
    estadoC:=est_c;
    estadoD:=est_d
 END;


 PROCEDURE COMPARAR_VARIABLES(VAR estadoA,estadoB,estadoC,estadoD:char;est_a,est_b,est_c,est_d:char;VAR cont:integer);
 {Compara los estados de un turno y el siguiente}
 BEGIN
   If((est_a=estadoA) AND (est_b=estadoB) AND (est_c=estadoC) AND (est_d=estadoD))
      then cont:=20
      else INTERCAMBIO(estadoA,estadoB,estadoC,estadoD,est_a,est_b,est_c,est_d);
 END;

 PROCEDURE RANAS(estadoA,estadoB,estadoC,estadoD,c0,c1,c2,c3:char);
 {Escribe los estados de las ranas en 20 turnos o hasta que se repiten en dos ocasiones consecutivas}
 VAR
   est_a,est_b,est_c,est_d:char;
   estA,estB,estC,estD,cont:integer;
 BEGIN
   writeln('  ABCD');
   writeln('1:',estadoA,estadoB,estadoC,estadoD);
   cont:=2;
   Repeat
     estA:=CROAR(estadoA);
     estB:=CROAR(estadoB);
     estC:=CROAR(estadoC);
     estD:=CROAR(estadoD);
     CAMBIO_VARIABLES(estB,estC,estD,est_a,c0,c1,c2,c3);
     CAMBIO_VARIABLES(estA,estC,estD,est_b,c0,c1,c2,c3);
     CAMBIO_VARIABLES(estA,estB,estD,est_c,c0,c1,c2,c3);
     CAMBIO_VARIABLES(estA,estB,estC,est_d,c0,c1,c2,c3);
     writeln(cont,':', est_a,est_b,est_c,est_d);
     COMPARAR_VARIABLES(estadoA,estadoB,estadoC,estadoD,est_a,est_b,est_c,est_d,cont);
     cont:=cont+1;
   until cont=21;
   writeln
 END;

FUNCTION REPETIR_PROGRAMA:char;
{Pregunta al usuario si desea volver a jugar}
 VAR
   repetir:char;
 BEGIN
   Repeat
     write('Quieres volver a jugar (S/N) ? ');
     readln(repetir);
     repetir:=upCase(repetir);
   until ((repetir='S') OR (repetir='N'));
   REPETIR_PROGRAMA:=repetir;
   writeln;
 END;


VAR
  estadoA,estadoB,estadoC,estadoD:char;
  c0,c1,c2,c3:char;

{Programa principal}
BEGIN
  BIENVENIDA;
  Repeat
    ESTADO_INICIAL_RANAS(estadoA,estadoB,estadoC,estadoD);
    CONDICIONES (c0,c1,c2,c3);
    RANAS(estadoA,estadoB,estadoC,estadoD,c0,c1,c2,c3);
  until REPETIR_PROGRAMA='N';
  writeln;
END.
