Program Charca_Simulator;

Uses
    CRT, DOS;

(*-----------------------------------------------------------------------*)

Procedure Pinta_Intro;

Begin
     Clrscr;
     gotoxy(30,10);
     writeln('CHARCA SIMULATOR 1.0');
End;

(*-----------------------------------------------------------------------*)

Procedure EleccionReglasDeCroado (var reglacero, reglauno, reglados, reglatres:boolean);

Var
   opcioncero, opcionuno, opciondos, opciontres:char;

Begin
     writeln;
     writeln;
     writeln('REGLAS DE CROADO');
     writeln('----------------');
     writeln;
     writeln;

     Repeat
       Begin
        write('La rana croa si ninguna vecina croa:     SI = s    NO = n    ');
        readln(opcioncero);
       End;
     Until (opcioncero='s') or (opcioncero='n');
     If opcioncero='s' then reglacero:=true
       Else reglacero:=false;

     Repeat
       Begin
        write('La rana croa si una vecina croa:         SI = s -- NO = n    ');
        readln(opcionuno);
       End;
     Until (opcionuno='s') or (opcionuno='n');
     If opcionuno='s' then reglauno:=true
       Else reglauno:=false;

     Repeat
       Begin
        write('La rana croa si dos vecinas croan:       SI = s -- NO = n    ');
        readln(opciondos);
       End;
     Until (opciondos='s') or (opciondos='n');
     If opciondos='s' then reglados:=true
       Else reglados:=false;

     Repeat
       Begin
        write('La rana croa si sus tres vecinas croan:  SI = s -- NO = n    ');
        readln(opciontres);
       End;
     Until (opciontres='s') or (opciontres='n');
     If opciontres='s' then reglatres:=true
       Else reglatres:=false;
End;

(*-------------------------------------------------------------------------*)

Procedure EleccionEstadosIniciales (var inicialA,inicialB,inicialC,inicialD:boolean);

Var
   a,b,c,d:char;

Begin
     writeln;
     writeln('ESTADOS INICIALES DE LAS RANAS:');
     writeln('-------------------------------');
     writeln;

     Repeat
       Begin
         write('Rana A croando?  SI=s   NO=n  ');
         readln(a);
       End;
     Until (a='s') or (a='n');
     If a='s' then inicialA:=true
       Else inicialA:=false;

     Repeat
       Begin
         write('Rana B croando?  SI=s   NO=n  ');
         readln(b);
       End;
     Until (b='s') or (b='n');
     If a='s' then inicialB:=true
       Else inicialB:=false;

     Repeat
       Begin
         write('Rana C croando?  SI=s   NO=n  ');
         readln(c);
       End;
     Until (c='s') or (c='n');
     If c='s' then inicialC:=true
       Else inicialC:=false;

     Repeat
       Begin
         write('Rana D croando?  SI=s   NO=n  ');
         readln(d);
       End;
     Until (d='s') or (d='n');
     If d='s' then inicialD:=true
       Else inicialD:=false;
End;

(*-------------------------------------------------------------------------*)

Procedure PintaRanaA (actualA:boolean; movimiento:integer);

Begin
    Clrscr;
    If actualA=true then
      Begin
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('                 TURNO: ',movimiento);
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('       ! CROAK !');
         writeln;
      End
    Else
      Begin
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('                 TURNO: ',movimiento);
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('       ! ----- !');
         writeln;
      End;
End;

(*-------------------------------------------------------------------------*)

Procedure PintaRanaB (actualB:boolean);

Begin
    If actualB=true then
      Begin
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('                                            ! CROAK !');
          writeln;
          writeln;
          writeln;
          writeln('                     .........');
          writeln('                    .         ....');
          writeln('                ....              .');
          writeln('                .                 .');
          writeln('                 .                 .');
          writeln('                .                 .');
          writeln('                .                .');
          write('                 .................');
          writeln;
       End
     Else
       Begin
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('                                            ! ----- !');
          writeln;
          writeln;
          writeln;
          writeln('                     .........');
          writeln('                    .         ....');
          writeln('                ....              .');
          writeln('                .                 .');
          writeln('                 .                 .');
          writeln('                .                 .');
          writeln('                .                .');
          write('                 .................');
          writeln;
       End;
End;

(*-------------------------------------------------------------------------*)

Procedure PintaRanaC (actualC:boolean);

Begin
    If actualC=true then
      Begin
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('       ! CROAK !');
         writeln;
      End
    Else
      Begin
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln;
         writeln('       ! ----- !');
         writeln;
      End;
End;

(*-----------------------------------------------------------------------*)

Procedure PintaRanaD (actualD:boolean);

Begin
    If actualD=true then
      Begin
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('                                       ! CROAK !');
          writeln;
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('           Pulse una tecla para el siguiente turno...');
      End
     Else
       Begin
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('                                       ! ----- !');
          writeln;
          writeln;
          writeln;
          writeln;
          writeln;
          writeln('           Pulse una tecla para el siguiente turno... ');
       End;
End;

(*-------------------------------------------------------------------------*)

Function CalculaVecinasQueCroan (uno,dos,tres:boolean):integer;

Begin
    If (uno and dos and tres) then
       CalculaVecinasQueCroan:=3;
    If (uno and dos and not tres) or (uno and tres and not dos) or
       (not uno and dos and tres) then
       CalculaVecinasQueCroan:=2;
    If (uno and not dos and not tres) or (not uno and dos and not tres) or
       (not uno and not dos and tres) then
       CalculaVecinasQueCroan:=1;
    If (not uno and not dos and not tres) then
       CalculaVecinasQueCroan:=0;
End;

(*-------------------------------------------------------------------------*)

Function CalculaSiguienteA (croasicero,croasiuna,croasidos,croasitres:boolean;
                           croaB,croaC,croaD:boolean):boolean;

Begin
   Case CalculaVecinasQueCroan(croaB,croaC,croaD) of
      0:CalculaSiguienteA:=croasicero;
      1:CalculaSiguienteA:=croasiuna;
      2:CalculaSiguienteA:=croasidos
      Else
        CalculaSiguienteA:=croasitres
    End;
End;

(*-------------------------------------------------------------------------*)

Function CalculaSiguienteB (croasicero,croasiuna,croasidos,croasitres:boolean;
                           croaA,croaC,croaD:boolean):boolean;

Begin
   Case CalculaVecinasQueCroan(croaA,croaC,croaD) of
      0:CalculaSiguienteB:=croasicero;
      1:CalculaSiguienteB:=croasiuna;
      2:CalculaSiguienteB:=croasidos
   Else
      CalculaSiguienteB:=croasitres;
   End;
End;

(*-------------------------------------------------------------------------*)

Function CalculaSiguienteC (croasicero,croasiuna,croasidos,croasitres:boolean;
                           croaA,croaB,croaD:boolean):boolean;

Begin
   Case CalculaVecinasQueCroan(croaA,croaB,croaD) of
      0:CalculaSiguienteC:=croasicero;
      1:CalculaSiguienteC:=croasiuna;
      2:CalculaSiguienteC:=croasidos
   Else
      CalculaSiguienteC:=croasitres;
   End;
End;

(*-------------------------------------------------------------------------*)

Function CalculaSiguienteD (croasicero,croasiuna,croasidos,croasitres:boolean;
                           croaA,croaB,croaC:boolean):boolean;

Begin
   Case CalculaVecinasQueCroan(croaA,croaB,croaC) of
      0:CalculaSiguienteD:=croasicero;
      1:CalculaSiguienteD:=croasiuna;
      2:CalculaSiguienteD:=croasidos
   Else
      CalculaSiguienteD:=croasitres;
   End;
End;


(*-------------------------------------------------------------------------*)


Var
   croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan:boolean;
   croaactualA,croaactualB,croaactualC,croaactualD:boolean;
   turno:integer;
   IgualMovimiento:boolean;
   croasiguienteA,croasiguienteB,croasiguienteC,croasiguienteD:boolean;
   pasaturnos:char;
   salir:char;


Begin   (*-- Del programa principal --*)
    Pinta_Intro;
    Repeat
       EleccionReglasDeCroado(croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan);
       EleccionEstadosIniciales(croaactualA,croaactualB,croaactualC,croaactualD);
       turno:=1;
       IgualMovimiento:=false;
       PintaRanaA(croaactualA,turno);
       PintaRanaB(croaactualB);
       PintaRanaC(croaactualC);
       PintaRanaD(croaactualD);
       Repeat
               readln(pasaturnos);

               croasiguienteA:=CalculaSiguienteA(croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan,
                                                 croaactualB,croaactualC,croaactualD);
               croasiguienteB:=CalculaSiguienteB(croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan,
                                                 croaactualA,croaactualC,croaactualD);
               croasiguienteC:=CalculaSiguienteC(croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan,
                                                 croaactualA,croaactualB,croaactualD);
               croasiguienteD:=CalculaSiguienteD(croasicerocroan,croasiunacroa,croasidoscroan,croasitrescroan,
                                                 croaactualA,croaactualB,croaactualC);
               If (croaactualA=croasiguienteA) and (croaactualB=croasiguienteB) and
                  (croaactualC=croasiguienteC) and (croaactualD=croasiguienteD) then
                       IgualMovimiento:=true;
               turno:=turno+1;
               croaactualA:=croasiguienteA;
               croaactualB:=croasiguienteB;
               croaactualC:=croasiguienteC;
               croaactualD:=croasiguienteD;
               PintaRanaA(croaactualA,turno);
               PintaRanaB(croaactualB);
               PintaRanaC(croaactualC);
               PintaRanaD(croaactualD);
       Until (turno=20) or (IgualMovimiento);
       writeln;
       writeln;
       writeln;
       write('      DESEA UNA NUEVA SIMULACION ?     SI: cualq tecla   NO: n ');
       readln(salir);
    Until (salir='n') or (salir='N')
End.