{Javier Merino Galdiano
 G05 (Martes de 8 a 11h)
 Puesto 2}

PROGRAM Ranas;

 CONST
      MaxTurnos = 20;

 {------------------------PROCEDIMIENTOS y FUNCIONES------------------------}

 PROCEDURE CaseOf1 (Cont: integer; Condic: char; VAR x, y, z, t: integer);

 {(9)}

 BEGIN
      CASE Cont OF
           0: IF Condic = 'c'
                THEN x:= 1
                ELSE x:= 0;
           1: IF Condic = 'c'
                THEN y:= 1
                ELSE y:= 0;
           2: IF Condic = 'c'
                THEN z:= 1
                ELSE z:= 0;
           3: IF Condic = 'c'
                THEN t:= 1
                ELSE t:= 0;
      END;
 END;

                         {--------------------------}

 PROCEDURE CaseOf2 (Cont, Condic0, Condic1, Condic2, Condic3: integer; VAR x: integer);

 {(10)}

 BEGIN
      CASE Cont OF
           0: IF Condic0 = 1
                THEN x:= 1
                ELSE x:= 0;
           1: IF Condic1 = 1
                THEN x:= 1
                ELSE x:= 0;
           2: IF Condic2 = 1
                THEN x:= 1
                ELSE x:= 0;
           3: IF Condic3 = 1
                THEN x:= 1
                ELSE x:= 0;
      END;
 END;

                         {--------------------------}

 PROCEDURE CondicCroaCalla (VAR a, b, c, d: integer);

 {(4) Este PROCEDIMIENTO sirve para pedirle al usuario las condiciones que se
      van a tomar para determinar si una rana croar o callar en el siguiente
      turno dependiendo de lo que hayan hecho sus vecinas en el turno anterior.}

  VAR
     ContVecinas: integer;
     RespCS: char;

  BEGIN
       FOR ContVecinas:= 0 TO 3 DO
          BEGIN

               write (' Si la rana tiene ', ContVecinas, ' vecinas croando,');
               writeln (' qu har en el siguiente turno?');
               write ('  CROAR (c) o se mantendr en SILENCIO (s): ');
               readln (RespCS);
               WHILE ((RespCS <> 'c') AND (RespCS <> 's')) DO
                    BEGIN
                         write ('  Introduzca "c" o "s": ');
                         readln (RespCS);
                    END;
               writeln;

               CaseOf1 (ContVecinas, RespCS, a, b, c, d);
          END;
  END;

                         {--------------------------}

 PROCEDURE PrimerTurno (VAR a1, b1, c1, d1: integer);

 {(5) Este PROCEDIMIENTO sirve para pedirle al usuario que inicialice las
      acciones de las 4 ranas. Esto quiere decir que se le va a pedir que
      diga, rana por rana, si croa o calla en el primer turno.}

  VAR
     ContRanas: integer;
     RespCS: char;

  BEGIN
       FOR ContRanas:= 0 TO 3 DO
          BEGIN
               writeln (' Qu quiere que haga la rana "', Chr (ContRanas + 65), '" en el primer turno?');
               write ('  que CROE (c) o que se mantenga en SILENCIO (s): ');
               readln (RespCS);
               WHILE ((RespCS <> 'c') AND (RespCS <> 's')) DO
                    BEGIN
                         write ('  Introduzca "c" o "s": ');
                         readln (RespCS);
                    END;
               writeln;

               CaseOf1 (ContRanas, RespCS, a1, b1, c1, d1);
          END;
  END;

                         {--------------------------}

 PROCEDURE SiguienteTurno (a, b, c, d, a1, b1, c1, d1: integer; VAR a2, b2, c2, d2: integer);

 {(6) Este PROCEDIMIENTO sirve para calcular las acciones de las 4 ranas en el
      turno siguiente. Esto quiere decir que nos va a calcular, rana por rana,
      si croa o calla en el siguiente turno.}

  VAR
     numVecinas: integer;

  BEGIN
       numVecinas:= b1 + c1 + d1;
       CaseOf2 (numVecinas, a, b, c, d, a2);

       numVecinas:= a1 + c1 + d1;
       CaseOf2 (numVecinas, a, b, c, d, b2);

       numVecinas:= a1 + b1 + d1;
       CaseOf2 (numVecinas, a, b, c, d, c2);

       numVecinas:= a1 + b1 + c1;
       CaseOf2 (numVecinas, a, b, c, d, d2);

  END;

                         {--------------------------}

 FUNCTION ComparaTurnos (a1, b1, c1, d1, a2, b2, c2, d2: integer): boolean;

 {(7) Esta FUNCIN me compara los valores de ranaA1, ranaB1, ranaC1, ranaD1
      con los de ranaA2, ranaB2, ranaC2, ranaD2 respectivamente. Si ranaA1 =
      ranaA2, ranaB1 = ranaB2, ranaC1 = ranaC2 y ranaD1 = ranaD2, el programa
      finalizar.}

  BEGIN
       IF ((a1 = a2) AND (b1 = b2) AND (c1 = c2) AND (d1 = d2))
         THEN ComparaTurnos:= TRUE
         ELSE ComparaTurnos:= FALSE;
  END;

                         {--------------------------}

 FUNCTION PintaCS (x: integer): char;

 {(8) Esta FUNCIN toma los valores enteros de ranaA1, ranaB1, ranaC1, ranaD1
      o los de ranaA2, ranaB2, ranaC2, ranaD2 para transformarlos en
      caracteres 'c' (CROA) o ' ' (SILENCIO) para la representacin grfica
      de las acciones de las ranas.}

  BEGIN
       IF x = 1
         THEN PintaCS:= 'C'
         ELSE PintaCS:= '_';
  END;

 {----------------------------PROGRAMA PRINCIPAL----------------------------}

 VAR
    ContTurno: integer;
    Resp: char;
    vecinas0, vecinas1, vecinas2, vecinas3, ranaA1, ranaB1, ranaC1, ranaD1, ranaA2, ranaB2, ranaC2, ranaD2: integer;
    auxTurnos: boolean;


 BEGIN
      {(1) Introduccin.}
      writeln ('____________________________________________________');
      writeln;
      writeln ('Este programa reproduce un juego que emula el CROADO DE 4 RANAS.');
      writeln ('                                              -----------------');
      writeln;

      {Aqu podra hacer que sacara por pantalla un pequeo resumen del
       funcionamiento del juego para que el usuario sepa de que trata, pero
       no lo he hecho ya que podran ser excesivas lneas y todos tenemos el
       enunciado.}

      REPEAT
            {(2) Este REPEAT se pone para que el usuario ejecute el programa
                 todas las veces que quiera.}


            {(3)Cuerpo del PROGRAMA PRINCIPAL.}

            {(3')}
            ContTurno:= 1;
            CondicCroaCalla (vecinas0, vecinas1, vecinas2, vecinas3);
            PrimerTurno (ranaA1, ranaB1, ranaC1, ranaD1);

            writeln;
            writeln;
            writeln ('Ranas:      ABCD');
            writeln ('            ----');
            writeln;
            writeln ('Turno 0', ContTurno, ':   ', PintaCS (ranaA1), PintaCS (ranaB1), PintaCS (ranaC1), PintaCS (ranaD1));

            REPEAT
                  {(3'')}
                  BEGIN
                       ContTurno:= ContTurno + 1;

                       SiguienteTurno (vecinas0, vecinas1, vecinas2, vecinas3, ranaA1, ranaB1,
                                       ranaC1, ranaD1, ranaA2, ranaB2, ranaC2, ranaD2);

                       auxTurnos:= ComparaTurnos (ranaA1, ranaB1, ranaC1, ranaD1, ranaA2, ranaB2, ranaC2, ranaD2);

                       IF ContTurno < 10
                         THEN writeln ('Turno 0', ContTurno, ':   ',
                                       PintaCS (ranaA2), PintaCS (ranaB2), PintaCS (ranaC2), PintaCS (ranaD2))
                         ELSE writeln ('Turno ', ContTurno, ':   ',
                                       PintaCS (ranaA2), PintaCS (ranaB2), PintaCS (ranaC2), PintaCS (ranaD2));

                       ranaA1:= ranaA2;
                       ranaB1:= ranaB2;
                       ranaC1:= ranaC2;
                       ranaD1:= ranaD2;
                  END;
            UNTIL ((auxTurnos = TRUE) OR (ContTurno = MaxTurnos));
            writeln;

            {(2') Aqu el programa nos da la opcin de volver a ejecutarse o
                  finalizarlo.}
            write (' Quiere volver a jugar? SI (s), NO (n): ');
            readln (Resp);
            WHILE ((Resp <> 's') AND (Resp <> 'n')) DO
                 BEGIN
                      write ('  Introduzca "s" o "n": ');
                      readln (Resp);
                 END;
            writeln ('____________________________________________________');
            writeln;
      UNTIL Resp = 'n';
 END.