Program Ranas_croando;
Uses
CRT;


 {Muestra el titulo del programa}
 Procedure titulo;
   begin
     gotoxy (16,10);
     writeln ('************************************************');
     gotoxy (16,11);
     writeln ('**************-JUEGO DE LAS RANAS-**************');
     gotoxy (16,12);
     writeln ('************************************************');
   end;


 {Procedimiento que asigna a la variable "Estado" un 1 si queremos que la
  rana croe o un 0 si queremos que no croe dependiendo del parmetro que se
  le pase}
 Procedure LeerEstado (var Estado:integer);
   begin
      {$I-}
        readln (Estado);
        while (IOResult<>0) or ((Estado<>0) and (Estado<>1)) do
          begin
            writeln ('Esa tecla no es correcta.');
            writeln ('Tiene que ser un 1 para que croe o un 0 para que no croe.');
            readln (Estado);
          end;
      {$I+}
   end;


 {Procedimiento que muestra en la pantalla el resultado de las ranas, si croa
  pintara una" C" y si no croa pintara un "_", dependiendo de si toma el valor
  de un 1 (croa) o un 0(no croa)}
 Procedure Mostrar (rana1,rana2,rana3,rana4:integer);
   begin

     case rana1 of
       1:write('C');
       0:write('_');
     end;

     case rana2 of
       1:write('C');
       0:write('_');
     end;

     case rana3 of
       1:write('C');
       0:write('_');
     end;

     case rana4 of
       1:write('C');
       0:write('_');
     end;

   end;


 {Procedimiento que asigna a las variables croaSicroa0,croaSicroa1,
  croaSicroa2,croaSicroa3 un 1 o un 0 dependiendo de las vecinas que
  queramos que tengan croando. En este procedimiento se llama al
  procedimiento LeerEstado que es quien asigna ese valor a dichas variables}
 Procedure QueCondiciones (var croaSicroa0,croaSicroa1,croaSicroa2,
                           croaSicroa3:integer);
   begin
    clrscr;
     writeln ('Quieres que croe cuando tenga 0 ranas vecinas croando?');
     writeln ('Pulsa un 1 para que croe o un 0 para que no croe.');
     LeerEstado(croaSicroa0);
     writeln;
     writeln ('Y con 1 rana vecina? Pulsa 1 para que croe o 0 para que no croe.');
     LeerEstado(croaSicroa1);
     writeln;
     writeln ('Y con 2 ranas vecinas? Pulsa 1 para que croe o 0 para que no croe.');
     LeerEstado(croaSicroa2);
     writeln;
     writeln ('Y con 3 ranas vecinas? Pulsa 1 para que croe o 0 para que no croe.');
     LeerEstado(croaSicroa3);
   end;


 {Procedimiento que inicializa todas las ranas (ranaA,ranaB,ranaC,ranaD). En
  este procedimiento se llama al procedimienro LeerEstado que es quien
  asigna un 1 o un 0 a dichas variables, dependiendo de si croa o no croa}
 Procedure Inicializacion (var rana1,rana2,rana3,rana4:integer);
   begin
     writeln ('Como quieres que este la rana A? "que croe o no croe"');
     writeln ('Pulsa un 1 para que croe o un 0 para que no croe.');
     LeerEstado(rana1);
     writeln;
     writeln ('Y la rana B? Pulsa un 1 para que croe o un 0 para que no croe.');
     LeerEstado(rana2);
     writeln;
     writeln ('Y la rana C? Pulsa un 1 para que croe o un 0 para que no croe.');
     LeerEstado(rana3);
     writeln;
     writeln ('Y la rana D? Pulsa un 1 para que croe o un 0 para que no croe.');
     LeerEstado(rana4);
   end;


 {Procedimiento que segn el nmero de vecinas que queramos que esten croando
  y utilizando los valores que tengan las ranas en la partida actual, asigna
  un 1 a la rana de la partida siguiente (que croe) o un 0 (que no croe)}
 Procedure Condiciones (rana1,rana2,rana3:integer;
                        croaSicroa0,croaSicroa1,croaSicroa2,croaSicroa3:integer;
                        var ranaSigTurno:integer);
   begin
     ranaSigTurno:=0;
     {Dependiendo de cuanto sumen las ranas vecinas sabremos el nmero de
      vecinas que tiene cada rana}

      case rana1+rana2+rana3 of

        0: If croaSicroa0=1 then  {Si hemos dicho que croan con 0 vecinas}
               ranaSigTurno:=1;   {se asignar un 1 a la rana del siguiente turno}

        1: If croaSicroa1=1 then  {Si croan con una}
               ranaSigTurno:=1;

        2: If croaSicroa2=1 then  {Si croan con dos}
               ranaSigTurno:=1;

        3: If croaSicroa3=1 then  {Si croan con tres}
               ranaSigTurno:=1;
      end;
   end;


 {Procedimiento que asigna los valores de las ranas de la partida actual a la
  anterior para luego compararlos en la siguiente partida con los nuevos
  valores que obtengamos}
 Procedure Asignar (var rana1,rana2,rana3,rana4:integer;
                    ranaSigturno1,ranaSigturno2,ranaSigturno3,
                    ranaSigturno4:integer);
  begin
    rana1:=ranaSigturno1;
    rana2:=ranaSigturno2;
    rana3:=ranaSigturno3;
    rana4:=ranaSigturno4;
  end;


 {Procedimiento que comprueba si en dos turnos seguidos el estado de las
  ranas no ha cambiado. Si este no cambia en dos turnos la partida terminar}
 Procedure dosTurnosIguales (rana1,rana2,rana3,rana4:integer;
                             ranaSigTurno1,ranaSigTurno2,ranaSigTurno3,ranaSigTurno4:integer;
                             i:integer;
                             var contador,iultima:integer);
   begin
     {Comprobamos si las ranas del turno anterior estan en las mismas
     condiciones que las actuales}
     If ((rana1=ranaSigTurno1) and (rana2=ranaSigTurno2) and
        (rana3=ranaSigTurno3) and (rana4=ranaSigTurno4))

        then

          If (i=iultima+1) then  {Si los turnos son seguidos}
               begin
                 contador:=contador+1;  {Contamos cuantos turnos son seguidos}
                 iultima:=i;
               end
             else    {Si el turno no es seguido}
               begin
                 contador:=0;
                 contador:=1;
                 iultima:=i;
               end;
   end;


 {Funcion que devuelve un caracter, una n o N si queremos salir del
  programa o cualquier tecla para volver a jugar otra partida}
 Function otro (fin:char):char;
   begin
     writeln ('La patida ha terminado. Quieres jugar otra vez?');
     writeln ('Pulsa cualquier tecla para volver a jugar de nuevo o');
     writeln ('una "n" o "N" para salir del programa.');
     read (fin);
     otro:=upcase(fin);  {A la funcion "otro" le asignamos el valor que obtenga fin}
   end;


 {Procedimiento en el cual la variable contador recibe un valor, si este es
  igual a dos mostrara un mensaje y si este es distinto de dos mostrara otro
  distinto}
 Procedure mensaje (contador:integer);
   begin
     If contador=2 then  {Si hay dos turnos iguales}
          begin
            writeln ('Jugada finalizada.');
            writeln ('En los dos ultimos turnos las ranas no han cambiado de estado.');
            writeln ('Pulsa intro para continuar.');
          end
       else   {Cuando se acaben los 20 turnos}
          begin
            writeln ('Jugada finalizada.');
            writeln ('Se han terminado los 20 turnos.');
            writeln ('Pulsa intro para continuar.');
          end;
   end;


{Variables del programa principal}
var

 ranaA,ranaB,ranaC,ranaD:integer;
 ranaSigTurnoA,ranaSigTurnoB,ranaSigTurnoC,ranaSigTurnoD:integer;
 croaSicroa0,croaSicroa1,croaSicroa2,croaSicroa3:integer;
 otros:char;
 i,iultima,cont:integer;
 fin:char;


{Programa principal}
begin
 clrscr;
 titulo; {Muestra el titulo del programa}
 readln;
  repeat
     clrscr;
     {Inicializamos las variables}
     ranaA:=0; ranaB:=0; ranaC:=0; ranaD:=0;
     ranaSigTurnoA:=0; ranaSigTurnoB:=0; ranaSigTurnoC:=0; ranaSigTurnoD:=0;
     otros:=' ';
     i:=1;
     cont:=0;
     iultima:=1;

     {Llamada a procedimientos y funciones}
     Inicializacion(ranaA,ranaB,ranaC,ranaD);
     QueCondiciones(croaSicroa0,croaSicroa1,croaSicroa2,croaSicroa3);
     clrscr;
     writeln ('COMIENZA LA PARTIDA');
     writeln;
     write (i,': '); {Para saber en que turno estamos}
     Mostrar(ranaA,ranaB,ranaC,ranaD);
     readln;
     i:=2;
     Repeat

          Condiciones(ranaB,ranaC,ranaD,croaSicroa0,croaSicroa1,croaSicroa2,
                      croaSicroa3,ranaSigTurnoA);
          Condiciones(ranaA,ranaC,ranaD,croaSicroa0,croaSicroa1,croaSicroa2,
                      croaSicroa3,ranaSigTurnoB);
          Condiciones(ranaA,ranaB,ranaD,croaSicroa0,croaSicroa1,croaSicroa2,
                      croaSicroa3,ranaSigTurnoC);
          Condiciones(ranaA,ranaB,ranaC,croaSicroa0,croaSicroa1,croaSicroa2,
                      croaSicroa3,ranaSigTurnoD);
          write (i,': '); {Para saber en que turno estamos}
          Mostrar(ranaSigturnoA,ranaSigTurnoB,ranaSigTurnoC,ranaSigTurnoD);
          readln;
          dosTurnosIguales(ranaA,ranaB,ranaC,ranaD,ranaSigTurnoA,ranaSigTurnoB,
                           ranaSigTurnoC,ranaSigTurnoD,i,cont,iultima);
          Asignar(ranaA,ranaB,ranaC,ranaD,ranaSigturnoA,ranaSigturnoB,
                  ranaSigturnoC,ranaSigturnoD);
          i:=i+1; {Le sumamos 1 al valor que tenga la i para el siguiente turno}

     Until (i>20) or (cont=2); {Se repite hasta 20 turnos o dos turnos iguales}
     writeln;

     mensaje(cont); {Muestra un mensaje de porque se ha terminado la partida}
     readln;

     clrscr;
     otros:=otro(fin); {Llamada a la funcion "otro" que nos pregunta si
                        queremos realizar otra partida}

  until (otros='N'); {El programa se repite hasta que pulsamos una n o N}

  readln;
  writeln;
  writeln ('Pulsa intro para salir del programa');
  readln;
end.