
PROGRAM Las_Ranas;

{**PIDE LAS RANAS QUE CROAN AL INICIO Y ALMACENA**

{Pide al usuario las ranas que croan al inicio

     PARAMETROS:
       Rana :rana de la que queremos obtener si croa o no (S/N)

     DEVUELVE:
       croa :Si la rana croara o no S/N}

FUNCTION PideInicio1rana (Rana:char):char;

VAR
     croa: char;

BEGIN
     REPEAT
     WRITELN ('En el primer turno quieres que croe la rana ', rana ,' (S/N)?');
     READLN(croa);
     UNTIL (croa='S') or (croa='N');
     Pideinicio1rana:=croa;
end;

{Almacena las ranas que croan al inicio segn lo indicado por el usuario}

Procedure PideIniciotodas (VAR A,B,C,D:char);

BEGIN
     A:=PideInicio1rana('A');
     B:=PideInicio1rana('B');
     C:=PideInicio1rana('C');
     D:=PideInicio1rana('D');

END;

{**PIDE CONDICIONES DE JUEGO Y ALMACENA**}

{**PIDE CONDICIONES DE JUEGO**}
{Pide al usuario las condiciones de juego,

PARAMETROS:
     N: Si la rana croara cuando croan otras ranas

DEVUELVE:
     CROASICROANN: Croa la rana cuando las N ranas croan}

FUNCTION PideCondicionescroa (N:integer):char;

VAR
   CroaSicroanN:char;

BEGIN
  REPEAT
  WRITELN ('Cuando ', N, ' ranas vecinas hayan croado (S/N)?');
  READLN(CroasicroanN);
  UNTIL (CroasicroanN='S') or (CroasicroanN='N');
  PideCondicionescroa:=CroaSicroanN;
end;

{**ALMACENA CONDICIONES DE JUEGO**}

Procedure Almacenacondicion (var E,F,G,H:Char);

BEGIN
   E:=PideCondicionescroa (0);
   F:=PideCondicionescroa (1);
   G:=PideCondicionescroa (2);
   H:=PideCondicionescroa (3);

END;

{**JUEGO**}

{**Funcion que nos cuenta cuantas ranas vecinas estan croando**

PARAMETROS:
     RANAVECINA: Estado inicial de las ranas.

DEVUELVE:
     CONTADOR: Numero de ranas vecinas que croan}

  Function cuentaranascroan (ranavecina1,ranavecina2,ranavecina3:char):integer;

  VAR
	contador:integer;
  BEGIN
	contador:=0;
	IF ranavecina1='S' then contador:=contador+1;
	IF ranavecina2='S' then contador:=contador+1;
	IF ranavecina3='S' then contador:=contador+1;
	cuentaranascroan:=contador;
  end;

{**Funcion que determina si la rana debe croar o no segun lo obtenido
en la funcin cuentaranascroan**}

  Function RanaSigturn (croasicroan0,croasicroan1,croasicroan2,croasicroan3,
                        ranavecina1,ranavecina2,ranavecina3: char): char;

  VAR
	ranascroan:integer;
	croasigturn:char;
  BEGIN
	ranascroan:=cuentaranascroan(ranavecina1,ranavecina2,ranavecina3);	
	

	IF ranascroan=0 THEN
	BEGIN
	  IF croasicroan0='S' then croasigturn:='S'
	  ELSE croasigturn:='N';
	END;
	IF ranascroan=1 THEN
	BEGIN
	  IF croasicroan1='S' then croasigturn:='S'
	  ELSE croasigturn:='N';
	END;
	IF ranascroan=2 THEN
	BEGIN
	  IF croasicroan2='S' then croasigturn:='S'
	  ELSE croasigturn:='N';
	END;
	IF ranascroan=3 THEN
	BEGIN
	  IF croasicroan3='S' then croasigturn:='S'
	  ELSE croasigturn:='N';
	END;
	RanaSigturn:=croasigturn;

  END;

{**Procedimiento que nos pinta una linea del estado de las ranas**}

Procedure Lineas (ranaA,ranaB,ranaC,ranaD: char; contador: integer);

  VAR
     i:integer;

  BEGIN

    write (contador, ' ');
    If ranaA='S' then write('c')
    else write('_');
    If ranaB='S' then write('c')
    else write('_');
    If ranaC='S' then write('c')
    else write('_');
    If ranaD='S' then write('c')
    else write('_');
    writeln;
  END;

{**Procedimiento que nos pinta por repeticin cada una de las lineas
de estado de ranas**}

PROCEDURE Jugar (ranaAactual,ranaBactual,ranaCactual,ranaDactual:char;
                 croasicroan0,croasicroan1,croasicroan2,croasicroan3:char);

VAR
	ranaAsigturn:char;
	ranaBsigturn:char;
	ranaCsigturn:char;
	ranaDsigturn:char;
	contador:integer;
	turnosiguales:boolean;

BEGIN
	
	contador:=1;
	turnosiguales:=false;
	Lineas(ranaAactual,ranaBactual,ranaCactual,ranaDactual,contador);
	contador:=contador+1;
	while (contador<=20) AND (turnosiguales=false) do 
		BEGIN
		ranaAsigturn:=RanaSigturn(croasicroan0,croasicroan1,croasicroan2,croasicroan3,ranaBactual,ranaCactual,ranaDactual);
		ranaBsigturn:=RanaSigturn(croasicroan0,croasicroan1,croasicroan2,croasicroan3,ranaAactual,ranaCactual,ranaDactual);
		ranaCsigturn:=RanaSigturn(croasicroan0,croasicroan1,croasicroan2,croasicroan3,ranaAactual,ranaBactual,ranaDactual);
		ranaDsigturn:=RanaSigturn(croasicroan0,croasicroan1,croasicroan2,croasicroan3,ranaAactual,ranaBactual,ranaCactual);
		lineas(ranaAsigturn,ranaBsigturn,ranaCsigturn,ranaDsigturn,contador);
		contador:=contador+1;
		IF ((ranaAactual=ranaAsigturn) and (ranaBactual=ranaBsigturn) and (ranaCactual=ranaCsigturn) and (ranaDactual=ranaDsigturn))
                then turnosiguales:=true else turnosiguales:=false;
		ranaAactual:=ranaAsigturn;
		ranaBactual:=ranaBsigturn;
		ranaCactual:=ranaCsigturn;
		ranaDactual:=ranaDsigturn;
		END;

END;


{***PROGRAMA PRINCIPAL***}


VAR
  Rana: char;
  N:integer;
  RanaAactual: Char;
  RanaBactual: Char;
  RanaCactual: Char;
  RanaDactual: Char;
  i,j: integer;
  contador:integer;
  Croasicroan0: char;
  Croasicroan1: char;
  Croasicroan2: char;
  Croasicroan3: char;
  repetir:char;

BEGIN
     
     
     WRITELN ('*************************************');
     WRITELN ('******* Programa de las ranas *******');
     WRITELN ('*************************************');
     WRITELN;

  {**PROGRAMA POR MODULOS**}
     REPEAT
	Pideiniciotodas(ranaAactual, ranaBactual,ranaCactual,ranaDactual);
	Writeln ('Has elegido:');
	writeln ('Rana A Inicio: ',ranaAactual);
	writeln ('Rana B Inicio: ',ranaBactual);
	writeln ('Rana C Inicio: ',ranaCactual);
	writeln ('Rana D Inicio: ',ranaDactual);
	WRITELN;
	WRITELN ('Tienes que determinar en los siguientes turnos cuando');
	WRITELN ('quieres que croe cada rana');
	WRITELN;
	Almacenacondicion(Croasicroan0,croasicroan1,croasicroan2,croasicroan3);
	Writeln;
	Writeln ('Has elegido estas condiciones de juego:');
	Writeln;
	writeln ('Croa si croan 0 ranas: ',croasicroan0);
	writeln ('Croa si croa  1 rana : ',croasicroan1);
	writeln ('Croa si croan 2 ranas: ',croasicroan2);
	writeln ('Croa si croan 3 ranas: ',croasicroan3);
	writeln;
	Writeln('Empieza el juego.');
        Writeln('  ABCD ');
	Jugar(ranaAactual,ranaBactual,ranaCactual,ranaDactual,croasicroan0,croasicroan1,croasicroan2,croasicroan3);
	REPEAT
	Writeln('Quieres jugar otra partida (S/N)?');
	Readln(repetir);
	UNTIL (repetir='S') or (repetir='N');
     UNTIL repetir='N';
end.

