{-----------------------------------------------------------------------------}
{Nombre: Marta Saz Sancho                                                     }
{Programa: Practica 2 de diseo, Programacion modular. Ranas Croando          }
{Fecha: 28-11-08                                                              }
{-----------------------------------------------------------------------------}
program diseno2;

uses
    crt;

{-----------------------------------------------------------------------------}
{Funcion que dado un parametro de tipo cadena, que se mostrara al usuario,    }
{devolvera un valor booleano en funcion de si ha introducido S o N.           }
{devuelve True si introdujo S, false si introdujo N. En cualquier otro caso   }
{hace que el usuario vuelva a introducir un caracter por teclado.             } 
{-----------------------------------------------------------------------------}
function ObtenerBooleano(cadena: string):boolean;
var
      caracter: char;
begin
      
      write(cadena);
      readln(caracter);

      while((caracter<>'S')and(caracter<>'s')and(caracter<>'N')and(caracter<>'n')) do
      begin
         write(cadena);
         readln(caracter);
      end;
      writeln;

      if ((caracter='S')or(caracter='s')) then
      begin
        ObtenerBooleano := true;
      end
      else
      begin
        ObtenerBooleano := false;
      end;

end;
{-----------------------------------------------------------------------------}
{Procedimiento que pide al usuario el estado de una rana y las condiciones en }
{las que estas croan. La variable de entrada rana es una cadena que indica al }
{usuario la rana de la que se esta tratando. Las variables booleanas          }
{ceroVecinas, unaVecina, dosVecinas, tresVecinas son parametros de salida     }
{sobre los que se indicara si se croara en el siguiente turno con el numero   }
{de vecinas indicado.                                                         }
{El parametro de salida croando indicara si la rana comienza croando.         }
{Se utiliza la funcion ObtenerBooleano para asignar el valore a las variables }
{-----------------------------------------------------------------------------}
procedure CondicionesIniciales(rana: string; var croando, ceroVecinas, unaVecina, dosVecinas, tresVecinas:boolean);

begin

     writeln('--------------------------------------------------------------');
     writeln('Indique si la rana ' + rana + ' esta croando');
     croando := ObtenerBooleano('Pulse S para Si, N para No: ');

     writeln('La rana ' + rana + ' croara si tiene 0 vecinas croando?');
     ceroVecinas := ObtenerBooleano('Pulse S para Si, N para No: ');

     writeln('La rana ' + rana + ' croara si tiene 1 vecinas croando?');
     unaVecina := ObtenerBooleano('Pulse S para Si, N para No: ');

     writeln('La rana ' + rana + ' croara si tiene 2 vecinas croando?');
     dosVecinas := ObtenerBooleano('Pulse S para Si, N para No: ');

     writeln('La rana ' + rana + ' croara si tiene 3 vecinas croando?');
     tresVecinas := ObtenerBooleano('Pulse S para Si, N para No: ');

end;
{-----------------------------------------------------------------------------}
{Procedimiento que dado el estado de croando de una rana, pinta por pantalla  }
{una C si croa y un _ sino.                                                   }
{-----------------------------------------------------------------------------}
procedure PintaRana(rana: boolean);
begin

     if(rana = true) then
     begin
        write('C');
     end
     else
     begin
        write('_');
     end;

end;
{-----------------------------------------------------------------------------}
{Procedimiento en el que se pasa a las variables de entrada booleanas el      }
{estado de croando de las ranas y las pinta por pantalla.                     }
{-----------------------------------------------------------------------------}
procedure PintaRanas (ranaA, ranaB, ranaC, ranaD: boolean);
begin

     PintaRana(ranaA);
     PintaRana(ranaB);
     PintaRana(ranaC);
     PintaRana(ranaD);
     writeln;   

end;
{-----------------------------------------------------------------------------}
{Funcion que dados tres parametros de entrada booleanos, que corresponderan   }
{a las vecianas de una rana dada que estan croando, devuelve en numero de     }
{ellas que estan a true, es decir, que estan croando.                         }
{-----------------------------------------------------------------------------}
function NumeroVecinasCroando(vecina1, vecina2, vecina3: boolean):integer;
begin

     if((vecina1=false)and(vecina2=false)and(vecina3=false))then
         NumeroVecinasCroando := 0;

     if((vecina1=false)and(vecina2=false)and(vecina3=true))then
         NumeroVecinasCroando := 1;
 
     if((vecina1=false)and(vecina2=true)and(vecina3=false))then
         NumeroVecinasCroando := 1;

     if((vecina1=false)and(vecina2=true)and(vecina3=true))then
         NumeroVecinasCroando := 2;
 
     if((vecina1=true)and(vecina2=false)and(vecina3=false))then
          NumeroVecinasCroando := 1;

     if((vecina1=true)and(vecina2=false)and(vecina3=true))then
         NumeroVecinasCroando := 2;

     if((vecina1=true)and(vecina2=true)and(vecina3=false))then
         NumeroVecinasCroando := 2;

     if((vecina1=true)and(vecina2=true)and(vecina3=true))then
         NumeroVecinasCroando := 3;

end;
{-----------------------------------------------------------------------------}
{funcion que dado el numero de vecinas de una rana que estan croando          }
{(numVecinasCroando), y las condiciones bajo las que esta rana croara en el   }
{siguiente estado (CroaSi0Vecinas,CroaSi1Vecina,CroaSi2Vecinas,CroaSi3Vecinas)}
{devuelve un booleano que indica si esta rana croa en el siguiente turno.     } 
{-----------------------------------------------------------------------------}
function ActualizarEstadoDeRana(CroaSi0Vecinas, CroaSi1Vecina,
                                CroaSi2Vecinas, CroaSi3Vecinas:boolean;
                                numVecinasCroando: integer):boolean;
begin

    ActualizarEstadoDeRana := false;

    if ((numVecinasCroando = 0)and(CroaSi0Vecinas))then
    begin
         ActualizarEstadoDeRana := true;
    end;

    if ((numVecinasCroando = 1)and(CroaSi1Vecina))then
    begin
         ActualizarEstadoDeRana := true;
    end;

    if ((numVecinasCroando = 2)and(CroaSi2Vecinas))then
    begin
         ActualizarEstadoDeRana := true;
    end;

    if ((numVecinasCroando = 3)and(CroaSi3Vecinas))then
    begin
         ActualizarEstadoDeRana := true;
    end;     

end;
{-----------------------------------------------------------------------------}
{Procedimiento si parametros que ejecuta una partida de la rana. Contiene un  }
{bucle que finalizara la partida en caso de que el numero de turnos sea mayor }
{de 20 o si un estado se repite en dos turnos segidos.                        }
{En primer lugar se obtienen las condiciones iniciales de cada rana. Despues  }
{dentro del bucle, se obtiene para cada rana el numero de vecinas que tiene   }
{croando y despues se actualiza el estado en fucion de esto y de las condicio-}
{es de croado de cada una. Para esto se llama primero al procedimiento        }
{CondicionesIniciales, y despues en el bucle a las funciones                  }
{NumeroDeVecinasCroando y ActualizarEstadoDeRana.                             }
{-----------------------------------------------------------------------------}
procedure PartidaRanasCroando;

var
   ACroaSi0Vec:boolean;        {Condiciones bajo las que croa la rana A}
   ACroaSi1Vec:boolean;
   ACroaSi2Vec:boolean;
   ACroaSi3Vec:boolean;

   BCroaSi0Vec:boolean;        {Condiciones bajo las que croa la rana B}
   BCroaSi1Vec:boolean;
   BCroaSi2Vec:boolean;
   BCroaSi3Vec:boolean;

   CCroaSi0Vec:boolean;        {Condiciones bajo las que croa la rana C}
   CCroaSi1Vec:boolean;                                               
   CCroaSi2Vec:boolean;
   CCroaSi3Vec:boolean;

   DCroaSi0Vec:boolean;        {Condiciones bajo las que croa la rana D}
   DCroaSi1Vec:boolean;
   DCroaSi2Vec:boolean;
   DCroaSi3Vec:boolean;

   croaA:boolean;              {indica si croa A en el turno actual}
   croabaA:boolean;            {almacena si croaba en el turno anterior}

   croaB:boolean;              {indica si croa A en el turno actual}
   croabaB:boolean;            {almacena si croaba en el turno anterior}

   croaC:boolean;              {indica si croa A en el turno actual}
   croabaC:boolean;            {almacena si croaba en el turno anterior}

   croaD:boolean;              {indica si croa A en el turno actual}
   croabaD:boolean;            {almacena si croaba en el turno anterior}

   numVecDeACroando: integer;  {numero de vecinas de cada rana}
   numVecDeBCroando: integer;
   numVecDeCCroando: integer;
   numVecDeDCroando: integer;
   
   i: integer;                 {variable que indica el turno}

begin

     {Obtengo condiciones iniciales}
     CondicionesIniciales('A', croaA, ACroaSi0Vec, ACroaSi1Vec, ACroaSi2Vec, ACroaSi3Vec);
     CondicionesIniciales('B', croaB, BCroaSi0Vec, BCroaSi1Vec, BCroaSi2Vec, BCroaSi3Vec);
     CondicionesIniciales('C', croaC, CCroaSi0Vec, CCroaSi1Vec, CCroaSi2Vec, CCroaSi3Vec);
     CondicionesIniciales('D', croaD, DCroaSi0Vec, DCroaSi1Vec, DCroaSi2Vec, DCroaSi3Vec);

     writeln('ABCD');
     PintaRanas(croaA, CroaB, CroaC, CroaD);

     i:=1;
     repeat
     begin

         {obtengo numero de vecianas de cada rana, indicado por el nombre de la variable}
         numVecDeACroando := NumeroVecinasCroando(croaB, croaC, croaD);
         numVecDeBCroando := NumeroVecinasCroando(croaA, croaC, croaD);
         numVecDeCCroando := NumeroVecinasCroando(croaA, croaB, croaD);
         numVecDeDCroando := NumeroVecinasCroando(croaA, croaB, croaC);

         {almaceno el estado de croado anterior}
         croabaA := croaA;
         croabaB := croaB;
         croabaC := croaC;
         croabaD := croaD;

         {actualizo el estado de croado de cada rana}
         croaA := ActualizarEstadoDeRana(ACroaSi0Vec, ACroaSi1Vec, ACroaSi2Vec, ACroaSi3Vec, numVecDeACroando);
         croaB := ActualizarEstadoDeRana(BCroaSi0Vec, BCroaSi1Vec, BCroaSi2Vec, BCroaSi3Vec, numVecDeBCroando);
         croaC := ActualizarEstadoDeRana(CCroaSi0Vec, CCroaSi1Vec, CCroaSi2Vec, CCroaSi3Vec, numVecDeCCroando);
         croaD := ActualizarEstadoDeRana(DCroaSi0Vec, DCroaSi1Vec, DCroaSi2Vec, DCroaSi3Vec, numVecDeDCroando);

         {Pinto el nuevo estado}
         PintaRanas(croaA, CroaB, CroaC, CroaD);

         i:=i+1;
     end;
     until((i>20)or((croaA=croabaA)and(croaB=croabaB)and(croaC=croabaC)and(croaD=croabaD)));


end;
{-----------------------------------------------------------------------------}
{procedimiento sin parametros que en un bucle ejecuta una partida de ranas    }
{croando y que al finalizar esta pide al usuario si desea jugar una nueva     }
{partida. Para esto se utiliza la funcion ObtenerBooleano.                    } 
{-----------------------------------------------------------------------------}
procedure JuegoRanasCroando;

var
     seguir: boolean;

begin

     seguir := true;
     while (seguir = true) do
     begin
          PartidaRanasCroando;
          writeln;
          seguir := ObtenerBooleano('Desea Volver a Jugar S o N: ');
     end;

     clrscr;

end;
{-----------------------------------------------------------------------------}
{Llamada al procedimiento principal JuegoRanasCroando.
{-----------------------------------------------------------------------------}
begin
 clrscr;
 JuegoRanasCroando;
end.