program rana_croando;

type  tranas=(ranaA,ranaB,ranaC,ranaD); {nombramos todas las ranas}
const primeraRana:tranas=ranaA;    {la rana A siempre sera la primera rana}
const ultimaRana:tranas=ranaD;     {la rana D siempre sera la ultima rana}

type testado=(croando,callada);  {como estara la rana, croando"c", callada"_"}
type tcharca=array [ranaA..ranaD] of testado; {almacenar el estado de la partida, es decir de las ranas}
type tnumvecinos=array[ranaA..ranaD] of integer; {almacenar con cuantas vecina croa cada rana}


function ranasString(rana:tranas):string; {traduccion de rana a pantalla}
begin

   if rana=ranaA then ranasString:='Rana A'
   else if rana=ranaB then ranasString:='Rana B'
   else if rana=ranaC then ranasString:='Rana C'
   else if rana=ranaD then ranasString:='Rana D';

end;

procedure pintaCharca(charca:tcharca;i:integer);  {que hace cada rana en cada tirada}
var r:tranas;
begin
   write(i,':');
   for r:=primeraRana to ultimaRana do
   begin
      if charca[r]=croando then write('C')
      else write('_');
   end;
   writeln('');
end;


procedure pedirEstadoCharca(var charca:tcharca); {como empieza cada rana en cada partida}
var r:tranas;
    c:string[2];
begin

   for r:=primeraRana to ultimaRana do
   begin
      writeln('La ',ranasString(r),' empieza croando? s/n');

      readln(c);
      while (c<>'s') and (c<>'n') do
   begin
   write('Escribe el caracter "s" o "n": ');

   readln(c);
   end;
      if c='s' then charca[r]:=croando
      else charca[r]:=callada;
   end;

end;

procedure pedirNumVecinos(var anumvecinos:tnumvecinos);

{$I-}
var r:tranas;
    numVecinos:integer;
begin

   for r:=primeraRana to ultimaRana do

   begin
      writeln('Con cuantos vecinos croa la ',ranasString(r),' (0,1,2,3)?');
begin
   write('introduzca el numero de vecinos entre 0 y 3: ');

   readln(numVecinos);
   While IOResult<>0 do
         begin
         write('Valor erroneo. Introduce nuevamente un numero entre 0 y 3: ');

         readln(numVecinos);
         end;
   while (numVecinos<>0) and (numVecinos<>1) and (numVecinos<>2) and (numVecinos<>3) or (numVecinos<0) do
   begin
   write('introduzca el numero de vecinos entre 0 y 3: ');

   readln(numVecinos);
   While IOResult<>0 do
         begin
         write('Valor erroneo. Introduce nuevamente un numero entre 0 y 3: ');

         readln(numVecinos);
         end;
      end;
      anumvecinos[r]:=numVecinos;
   end;
{$I+}
end;
end;

function numVecinosCroando(charca:tcharca;rana:tranas):integer;
{cuenta las ranas que croan o no en cada turno}
var r:tranas;
    num:integer;
begin
   num:=0;
   for r:=primeraRana to ultimaRana do
   begin
      if (rana<>r) and (charca[r]=croando) then inc(num);
   end;
   numVecinosCroando:=num;
end;

procedure siguienteEstadoCharca(var charca:tcharca;numVecinos:tnumvecinos;var hacambiado:boolean);
{pasa al siguiente turno dado un estado y el numero de vecinos con los que croa cada rana}
var charcatemp:tcharca;
    r:tranas;
begin
   hacambiado:=false;
   for r:=primeraRana to ultimaRana do
   begin
      if numVecinosCroando(charca,r)>=numVecinos[r] then charcatemp[r]:=croando
      else charcatemp[r]:=callada;
      if charca[r]<>charcatemp[r] then hacambiado:=true;
   end;
   for r:=primeraRana to ultimaRana do
   begin
      charca[r]:=charcatemp[r];
   end;
end;

procedure realizaTurnos(charca:tcharca;numVecinos:tnumvecinos);
{Bucle de turnos.Controla que no pase de 20 incluido el inicial y que este cambiando el estado}
var total:integer;
    hacambiado:boolean;
begin

   total:=1;
   hacambiado:=true;

   while (total<=19) and (hacambiado) do
   begin
      siguienteEstadoCharca(charca,numVecinos,hacambiado);
      pintaCharca(charca, total);
      inc(total);

   end;

end;




procedure principal;

var otravez:string[2];
    charca:tcharca;
    numVecinos:tnumvecinos;       {numero de vecinos que croa 0,1,2,3}

begin
    otravez:='s';

  while otravez='s' do


  while otravez='s' do
  begin
   {$I-}
   pedirEstadoCharca(charca);
   pedirNumVecinos(numVecinos);
   write('Inicial: ');
   pintaCharca(charca, 1);
   realizaTurnos(charca,numVecinos);
   writeln('Otra vez? (s/n)');
   readln(otravez);
   While IOResult<>0 do
         begin
         write('Valor erroneo. Introduce el caracter "s" o "n": ');

         readln(otravez);
         end;

   writeln;
   while (otravez<>'s') and (otravez <> 'n') do
   begin
   write('Escribe el caracter "s" o "n": ');

   readln(otravez);
   end;

   {$I+}
  end;
end;

begin
   principal;


end.
