Program Ranas;
Uses crt;
Const
     Croa='C';
     NoCroa='_';

{Funcin que devolver un booleano, el cual nos dir si va a croar en primer turno
la rana que le pasemos como parmetro.}
Function CroaPrimerTurno(rana:char;fila:byte):boolean;
Var croa:char;
Begin
     write('La rana ', rana ,' va a croar en el primer turno? (S/N):');
     Repeat
           GotoXY(48,fila);
           croa:=upcase(readkey);
           GotoXY(48,fila);
           If(croa<>'S') or (croa<>'N') then write(' ');
           If(croa='S') or (croa='N') then writeln(croa);
     until (croa='S') or (croa='N');
     If(croa='S') then CroaPrimerTurno:=true
     else CroaPrimerTurno:=false;
End;

{Funcin con la cual nos definimos las reglas de juego.}
Function reglas(fila:byte):byte;
Var opcion:char; error,valor:integer;
Begin
     writeln('Introduca las condiciones de croado de las ranas:');
     writeln('Para 0 ranas vecinas introduzca 0.');
     writeln('Para 1 rana vecinas introduzca 1.');
     writeln('Para 2 ranas vecinas introduzca 2.');
     writeln('Para 3 ranas vecinas introduzca 3.');
     writeln('Para 1  2 ranas vecinas introduzca 4.');
     writeln('Para 2  3 ranas vecinas introduzca 5.');
     Repeat
           GotoXY(52,fila);
           opcion:=readkey;
           val(opcion,valor,error);
           GotoXY(52,fila);
           If(valor<0) or (valor>5) or (error<>0) then write(' ')
           else writeln(valor);
     until ((valor>=0) and (valor<=5)) and (error=0);
     reglas:=valor;
End;

{Procedimiento que determina para cada uno de los casos posibles si la rana va a croar
o no en el siguiente turno.}
Procedure DefineReglas(A,B,C,D:boolean;var AA:boolean; var BB:boolean; var CC:boolean;
                       var DD:boolean; reglas:byte);
Begin
     Case reglas of
       1:Begin
           If B or C or D then AA:=true;
           If A or C or D then BB:=true;
           If A or B or D then CC:=true;
           If A or B or C then DD:=true;
         End;
       2:Begin
           If (B and C) or (B and D) or (C and D) then AA:=true;
           If (A and C) or (C and D) or (A and D) then BB:=true;
           If (A and B) or (B and D) or (A and D) then CC:=true;
           If (A and B) or (B and C) or (A and C) then DD:=true;
         End;
       3:Begin
           If (B and C and D) then AA:=true;
           If (A and C and D) then BB:=true;
           If (A and B and D) then CC:=true;
           If (A and B and C) then DD:=true;
         End;
       4:Begin
           If B or C or D then AA:=true;
           If A or C or D then BB:=true;
           If A or B or D then CC:=true;
           If A or B or C then DD:=true;
         End;
       5:Begin
           If (B and C) or (B and D) or (C and D) then AA:=true;
           If (A and C) or (C and D) or (A and D) then BB:=true;
           If (A and B) or (B and D) or (A and D) then CC:=true;
           If (A and B) or (B and C) or (A and C) then DD:=true;
         End;
     End;
End;

{Procedimiento que contempla si se cumple la condicin de que el juego termine antes o tras
20 turnos, o si durante dos turnos seguidos las ranas no cambian su comportamiento.}
Procedure CroaRanas(A,B,C,D:boolean;reglas:byte;turno:byte);
Var
    AA,BB,CC,DD:boolean;
Begin
  If(turno=1) then clrscr;
  If(turno<21) then
  Begin
     AA:=false; BB:=false; CC:=false;DD:=false;
     If A=true then write(Croa) else write(NoCroa);
     If B=true then write(Croa) else write(NoCroa);
     If C=true then write(Croa) else write(NoCroa);
     If D=true then writeln(Croa) else writeln(NoCroa);

     DefineReglas(A,B,C,D,AA,BB,CC,DD,reglas);

     If (A<>AA) or (B<>BB) or (C<>CC) or (D<>DD) then
         CroaRanas(AA,BB,CC,DD,reglas,turno+1);
  End;
End;

{Funcin que pregunta al usuario si quiere volver a jugar.}
Function repetir:boolean;
Var
    opcion:char;
Begin
     GotoXY(1,24);
     write('Desea volver a jugar al juego de las ranas (S/N):');
     Repeat
           GotoXY(50,24);
           opcion:=upcase(readkey);
           GotoXY(50,24);
           If(opcion<>'S') or (opcion<>'N') then write(' ');
     until (opcion='S') or (opcion='N');
     If(opcion='S') then repetir:=true
     else repetir:=false;
End;

{Procedimiento que dibuja el encabezado introductorio del programa.}
Procedure Cabecera;
Begin
     writeln('***********************************************');
     writeln('***********************************************');
     writeln('**                                           **');
     writeln('**         JUEGO DE LAS RANAS                **');
     writeln('**                                           **');
     writeln('***********************************************');
     writeln('***********************************************');

End;

{Procedimiento con el que finaliza el programa.}
Procedure Pie;
Begin
     clrscr;
     writeln('Practica realizada por: Carlos Suarez Marquina,Laura Pelayo Abascal');
     writeln('Asignatura: Fundamentos de informtica.');
     writeln('Ingeniera Tcnica Industrial, especialidad Qumica Industrial.');
     writeln('Curso 2008-2009');
     GotoXY(1,24);
     writeln('Pulse la tecla INTRO para salir...');
     readln;
End;

{Cuerpo del programa principal}
Begin
  Repeat
     clrscr;
     Cabecera;
     CroaRanas(CroaPrimerTurno('A',8),
               CroaPrimerTurno('B',9),
               CroaPrimerTurno('C',10),
               CroaPrimerTurno('D',11),
               reglas(12),1);
  until repetir=false;
  Pie;
End.

