Program ranas;


{Pedimos estado inicial de la charca}

 Procedure piderana(var rana:char);
  {Este procedimiento pedir el estado actual (croa o no croa) de cada rana inicialmente}
  {tenemos una variable de salida,rana, por lo que la pasamos por referencia}
   Begin
   {Activamos I/O checking, habilitando el sistema de interrupciones de E/S para asegurarnos}
   {de que no hay entradas errneas, para eso IOresult debe ser diferente de 0}
   {$I-}
    writeln('Qu esta haciendo la rana? croa o no croa? (C/_)');
    readln(rana);
    While (IOResult<>0) or ((rana<>'C') and (rana<>'_')) do
      begin
        writeln('Valor incorrecto.Introduce C o _');
        readln(rana)
      end;
   {$I+}
   end;


 Procedure pidecharca(var A,B,C,D:char);

 {En este procedimiento llamamos al procedimiento anterior 4 veces; una para cada rana}
 {de esta manera, tendremos el estado inicial de la charca}
 {Tenemos variables 4 variables de salida y las pasamos por referencia}
   Begin
    piderana(A);
    piderana(B);
    piderana(C);
    piderana(D)
   end;




{Pedimos reglas de la charca}

 procedure leeregla(Var caso:boolean);
 {En este procedimiento nos aseguramos que el usuario responde correctamente}
 {cuando le pedimos las condiciones del juego}
 {Le pasamos por referencia una variable booleana de salida, caso, que valdr}
 {verdadero si para ese caso la rana tiene que croar en el siguiente turno}
   Var
   {Esta variable es propia del procedimiento por lo que la declaramos aparte}
   {En funcin de su valor, caso obtendr el valor de verdadero o falso}
   respuesta:char;

   Begin
      readln(respuesta);
      while not ((respuesta='s') or (respuesta='S') or (respuesta='n') or (respuesta='N')) Do
         begin
            writeln('No te entiendo.');
            readln(respuesta)
         end;
       If (respuesta='s') or (respuesta='S') then
        caso:=true
        Else
         caso:=false
   end;



 Procedure pidereglas (Var caso0,caso1,caso2,caso3:boolean);
  {En este procedimiento llamamos 4 veces al procedimiento anterior, una vez por cada caso}
  {posible para el juego. Como se pueden dar varios casos a la vez, guardamos cada uno en una variable}
  {Cada una de estas 4 variables son de salida por lo que las pasamos por referencia}
   Begin

      writeln('Con 0 vecinas croando va a croar en el siguiente turno? (S/N)');
      leeregla(caso0);
      writeln('Con 1 vecina croando va a croar en el siguiente turno? (S/N)');
      leeregla(caso1);
      writeln('Con 2 vecinas croando va a croar en el siguiente turno?(S/N)');
      leeregla(caso2);
      writeln('Con 3 vecinas croando va a croar en el siguiente turno? (S/N)');
      leeregla(caso3)
   end;

 procedure calcularana(Var rana:char; j:integer; caso:boolean; n:integer);
    {Esto nos calcular el valor de una rana en el turno siguiente en funcin de lo que hacen}
    {sus vecinas en el turno anterior. Para ello le pasamos el nmero de ranas que croaban}
    {en el turno anterior (j) y lo compara con las ranas que deberian croar en el caso dado (n)}
    {A este procedimiento le pasamos una variable de salida, rana que la pasamos por referencia}
    {el resto de variables son slo de entrada por lo que las pasaremos por valor}


     Begin

      If (caso=true) and (j=n) then
        rana:='C'

     end;

 procedure calculasiguienteturnorana(Var rana1:char; vecina1,vecina2,vecina3:char; caso0,caso1,caso2,caso3:boolean);
    {Calcula el valor de una de las ranas en el turno siguiente}
     Var
      i:integer;

     Begin
      {almacenamos en el contador el nmero de ranas vecinas de una rana dada que croaban en el turno anterior}
      i:=0;
      If vecina1='C' then i:=i+1;
      If vecina2='C' then i:=i+1;
      If vecina3='C' then i:=i+1;
      {Inicializamos el valor de rana en "no croa". LLamamos al procedimiento anterior para cada caso}
      {Si  el valor del caso que le pasamos por valor es true (dato pedido al usuario)  y el valor }
      {terico del nmero de ranas vecinas que deben croar en cada caso es el mismo que el que hemos}
      {almacenado en el contador y que tambin se lo pasamos por valor, rana cambiara su valor a 'C'}
      {sino seguir valiendo '_'}
      rana1:='_';
      calcularana(rana1,i,caso0,0);
      calcularana(rana1,i,caso1,1);
      calcularana(rana1,i,caso2,2);
      calcularana(rana1,i,caso3,3)
     end;






 procedure calculasiguienteturnocharca(var A0,B0,C0,D0:char; caso0,caso1,caso2,caso3:boolean; Var A1,B1,C1,D1:char);
    {Clcula el valor de las 4 ranas en el turno siguiente, pasndole por referencia cada una de las ranas de la charca}
    {en el turno siguiente y por valor las vecinas en el turno anterior de cada una y las reglas de la charca}

   Begin

    calculasiguienteturnorana(A1,B0,C0,D0,caso0,caso1,caso2,caso3);
    calculasiguienteturnorana(B1,A0,C0,D0,caso0,caso1,caso2,caso3);
    calculasiguienteturnorana(C1,B0,A0,D0,caso0,caso1,caso2,caso3);
    calculasiguienteturnorana(D1,B0,C0,A0,caso0,caso1,caso2,caso3)
   end;


 procedure escribeturno(j:integer; A0,B0,C0,D0:char);
  {Procedimiento que nos mostrar por pantalla cada uno de los turnos del juego}
    Begin
      writeln(j,': ',A0,' ',B0,' ',C0,' ',D0)
    end;



{Declaramos las variables del programa principal}

 VAR
 A0,A1,B0,B1,C0,C1,D0,D1:char;
 caso0,caso1,caso2,caso3:boolean;
 i:integer;
 salir:boolean;
 c:char;

 Begin


    Repeat
       salir:=false;
       i:=1;
       pidecharca(A0,B0,C0,D0);
       A1:=A0; B1:=B0; C1:=C0; D1:=D0;
       pidereglas(caso0,caso1,caso2,caso3);
       writeln('   A B C D');
       repeat
           A0:=A1;B0:=B1;C0:=C1;D0:=D1;
           escribeturno(i,A0,B0,C0,D0);
           calculasiguienteturnocharca(A0,B0,C0,D0,caso0,caso1,caso2,caso3,A1,B1,C1,D1);
           i:=i+1;

       Until (i>20) or ((A0=A1) and (B0=B1) and (C0=C1) and (D0=D1));

       repeat
           writeln('Quieres volver a jugar? (S/N)');
            readln(c);
       until (c='s') or (c='S') or (c='n') or (c='N');
       If (c='n') or (c='N') then salir:=true
    Until (salir)


End.