                       { *JUEGO DE LAS RANAS* }
{  Las ranas croan en funcin de lo que hacen sus vecinas. }

{La explicacin de cada mdulo y de sus parmetros se encuentran en el
txt adjunto.}

{---------------------------------------------------------------------}
Program Ranas;

uses crt;

procedure Comprueba_letra(var k:char);
   begin
      {$I-}
      textcolor(10);   write('S');
      textcolor(15);   write('=S / ');
      textcolor(12);   write('N');
      textcolor(15);   write('=No?: ');
      k:=readkey;
      while (IOResult<>0) or ((k<>'s') and (k<>'n')
                          and (k<>'S') and (k<>'N')) do
         begin
            writeln;
            write('     Te has equivocado. Corrige: ');
            k:=readkey;
         end;
      If (k='s') or (k='S') then begin
         textcolor(10);   writeln('S') end
      else begin
         textcolor(12);   writeln('No'); end;
      {$I+}
   end;
{Es llamado por los mdulos "Rana_croa" y "Hay_regla" y por el programa principal}
{---------------------------------------------------------------------}

function Rana_croa(r:char):byte;
   var k:char;
   begin
      Rana_croa:=0;
      textcolor(15);   write('    Croa la rana ');
      textcolor(5);   write(r);
      textcolor(15);   write(' ? ');
      Comprueba_letra(k);
      If (k='s') or (k='S') then Rana_croa:=1;
   end;
{Es llamada por el mdulo "Pedir_ranas"}
{Hace uso del mdulo "Comprueba_letra"}
{---------------------------------------------------------------------}

procedure Pedir_ranas(var A,B,C,D:byte);
   begin
      A:=Rana_croa('A');
      B:=Rana_croa('B');
      C:=Rana_croa('C');
      D:=Rana_croa('D');
   end;
{Es llamado por el programa principal}
{Hace uso del mdulo "rana_croa"}
{---------------------------------------------------------------------}

function Hay_regla(caso:char):boolean;
   var k:char;
   begin
      Hay_regla:=false;
      write('    ');
      textcolor(9);   write(caso);
      textcolor(15);   write(' ranas vecinas croando?: ');
      Comprueba_letra(k);
      If (k='s') or (k='S') then Hay_regla:=true;
   end;
{Es llamado por el mdulo "Pedir_reglas"}
{Hace uso del mdulo "Comprueba_letra"}
{---------------------------------------------------------------------}

procedure Pedir_reglas(var R0,R1,R2,R3:boolean);
   begin
      textcolor(15);
      writeln('    Croar cada rana si tiene... ');
      writeln;
      R0 := Hay_regla('0');
      R1 := Hay_regla('1');
      R2 := Hay_regla('2');
      R3 := Hay_regla('3');
   end;
 {Es llamado por el programa principal}
 {Hace uso del mdulo "Hay_regla"}
{---------------------------------------------------------------------}

function Calcula_turno(v1,v2,v3:byte;R0,R1,R2,R3:boolean):byte;
   begin
      Calcula_turno:=0;
      If R0 and (v1+v2+v3=0) then Calcula_turno:=1;
      If R1 and (v1+v2+v3=1) then Calcula_turno:=1;
      If R2 and (v1+v2+v3=2) then Calcula_turno:=1;
      If R3 and (v1+v2+v3=3) then Calcula_turno:=1;
   end;
{Es llamado por el mdulo "Siguiente_turno"}
{--------------------------------------------------------------------}

procedure Intercambiar(var rana:byte; var rana2:byte);
   var aux:byte;
   begin
      aux:=rana;
      rana:=rana2;
      rana2:=aux;
   end;
{Es llamado por el mdulo "Siguiente_turno"}
{--------------------------------------------------------------------}

function Cambia_estado_rana(rana,rana2:byte):boolean;
   begin
      Cambia_estado_rana:=true;
      If rana<>rana2 then Cambia_estado_rana:=false;
   end;
{Es llamado por el mdulo "Hay_cambio"}
{---------------------------------------------------------------------}

 function Hay_cambio(A,B,C,D,A2,B2,C2,D2:byte):boolean;
    begin
       Hay_cambio:=true;
       if (Cambia_estado_rana(A,A2) and Cambia_estado_rana(B,B2) and
           Cambia_estado_rana(C,C2) and Cambia_estado_rana(D,D2)) then
          Hay_cambio:=false;
    end;
{Es llamada por el programa principal}
{Hace uso del mdulo "Cambia_estado_rana"}
{--------------------------------------------------------------------}

procedure Siguiente_turno(var A2,B2,C2,D2,A,B,C,D:byte; R0,R1,R2,R3:boolean);
   begin
      A2:=Calcula_turno(B,C,D,R0,R1,R2,R3);
      B2:=Calcula_turno(A,C,D,R0,R1,R2,R3);
      C2:=Calcula_turno(A,B,D,R0,R1,R2,R3);
      D2:=Calcula_turno(A,B,C,R0,R1,R2,R3);

      Intercambiar(A,A2);
      Intercambiar(B,B2);
      Intercambiar(C,C2);
      Intercambiar(D,D2);
   end;
{Es llamada por el programa principal}
{Hace uso de los mdulos "Calcula_turno" e "Intercambiar"
{---------------------------------------------------------------------}

procedure Mostrar_rana(R:char; rana:byte);
   begin
      textcolor(5);   write('    ',R);
      textcolor(15);   write(': ');
      If rana=1 then begin
         textcolor(10);   write('Croac'); end
      else begin
         textcolor(4);   write(' ___ '); end
   end;
{Es llamado por el mdulo "Mostrar"}
{---------------------------------------------------------------------}
procedure Mostrar(var A,B,C,D,i:byte);
   begin
      textcolor(11);   writeln('    -------Turno ',i,'-------');
           If i=1 then writeln('      (Estado inicial)');
      textcolor(10);
      Mostrar_rana('A',A);
      Mostrar_rana('B',B);
      writeln;
      Mostrar_rana('C',C);
      Mostrar_rana('D',D);
      writeln;
   end;
{Es llamado por el programa principal}
{Hace uso del mdulo "Mostrar_rana"}
{--------------------------------------------------------------------}

{PROGRAMA PRINCIPAL}
var
   A,B,C,D,A2,B2,C2,D2,i:byte;
   R0,R1,R2,R3:boolean;
   k:char;

begin
   repeat
      clrscr;
      writeln;
      textcolor(9);    writeln('  * JUEGO DE LAS RANAS *');
      writeln;
      textcolor(14);   writeln(' -> Estado inicial:');
      writeln;
      Pedir_ranas(A,B,C,D);
      writeln;
      textcolor(14);   writeln(' -> Reglas de croar:');
      Pedir_reglas(R0,R1,R2,R3);
      writeln;

      textcolor(14);   writeln(' -> Representacin:');
      textcolor(15);   writeln('    Pulsa una tecla para pasar de turno.');
      writeln;

      i:=1;
      repeat
         Mostrar(a,b,c,d,i);
         Siguiente_turno(A2,B2,C2,D2,A,B,C,D,R0,R1,R2,R3);
         k:=readkey; writeln;
         i:=i+1;
      until (i=20) or (not Hay_cambio(A,B,C,D,A2,B2,C2,D2));
      mostrar(a,b,c,d,i);
      If not Hay_cambio(A,B,C,D,A2,B2,C2,D2) then begin
          writeln;
          textcolor(15);   write('     - Hay repeticin -'); end;
      k:=readkey;

      writeln; writeln;
      textcolor(15);   write('    Volver a jugar? ');
      Comprueba_letra(k);
   until (k<>'s') and (k<>'S');

   writeln;
   textcolor(14);
   writeln(' ____________________________________');
   writeln;
   writeln('  PROGRAMA REALIZADO POR LUIS LAMPLE ');
   writeln('               25/11/08              ');
   writeln(' ____________________________________');
   k:=readkey; writeln;

end.