Program Ranas; {Objetivo, simular un grupo de cuatro ranas croando alrededor de una
                charca durante una serie de turnos}

  Procedure Inicial (Var A,B,C,D:boolean);
  {Explicacin amplia y detallada en el fichero de texto; Sirve para saber que ranas
  van a croar en el turno inicial;Es llamado desde el programa principal}
   Var
    Croa:char; {Importante, no hara falta el IORESULT}
   Begin
    A:=False; B:=False; C:=False; D:=False;
    {Se va a emplear la estructura repetitiva REPEAT para cada rana}
    Repeat  Write ('La rana 1 croa? Pulse S para que croe o N para que no croe: ');
            readln (Croa);
    until (Croa ='S') or (Croa= 's') or (Croa= 'N') or (Croa= 'n');
     if(Croa='S') or (Croa='s') then A:=true;
     {Mayusculas y minusculas por una posible confusion del usuario}
    Repeat  Write  ('La rana 2 croa? Pulse S para que croe o N para que no croe: ');
            readln (Croa);
    until (Croa ='S') or (Croa= 's') or (Croa= 'N') or (Croa= 'n');
     if (Croa='S') or (Croa ='s') then B:=true;

    Repeat  Write  ('La rana 3 croa? Pulse S para que croe o N para que no croe: ');
            readln (Croa);
            Croa:= upCase(Croa) {Empleo del upCase porque se hace repetitivo poner todo
                                 el rato mayusculas y minusculas}
    until (Croa ='S') or (Croa= 'N');
     if (Croa='S') then C:=true;

    Repeat  Write  ('La rana 4 croa? Pulse S para que croe o N para que no croe: ');
            readln (Croa);
            Croa:= upCase(Croa)
    until (Croa ='S') or (Croa= 'N');
     if (Croa='S') then D:=true;
    writeln;
   end;

  Procedure condiciones (Var sihay0,sihay1,sihay2,sihay3:boolean);
  {Explicacin detallada y amplia en el fichero de texto;Sirve para interactuar con
  el usuario y que decida en que condiciones van a croar las ranas en los sucesivos
  turnos;Es llamado desde el programa principal}
   Var
    c:char; {importante, no hara falta el IORESULT}
   Begin
    sihay0:=False; sihay1:=False; sihay2:=False; sihay3:=False;
    writeln ('En que condiciones van a croar las ranas en el siguiente turno?');

    writeln ('Cuando hay 0 ranas vecinas croando, Croaran?');
    Repeat  write ('Pulse S para si o N para no: ');
     {De nuevo el empleo de la estructura REPEAT para cada caso}
            readln(c);
    until (c='S') or (c='s') or (c='N') or (c='n');
     if (c='S') or (c='s') then sihay0:=true;

    writeln ('Cuando hay 1 rana vecina croando, Croaran?');
    Repeat  write ('Pulse S para si o N para no: ');
            readln(c);
    until (c='S') or (c='s') or (c='N') or (c='n');
     if (c='S')  or (c='s') then sihay1:=true;

    writeln ('Cuando hay 2 ranas vecinas croando, Croaran?');
    Repeat  write ('Pulse S para si o N para no: '); readln(c);
            c:= upCase(c) {Empleo del upCase para no escribir tanto}
    until (c='S') or (c='N');
     if (c='S') then sihay2:=true;

    writeln ('Cuando hay 3 ranas vecinas croando, Croaran?');
    Repeat  write ('Pulse S para si o N para no: '); readln(c);
            c:= upCase(c)
    until (c='S') or (c='N');
     if (c='S') then sihay3:=true;
     writeln;
   end;

  Procedure Escribir(A,B,C,D:boolean);
  {Explicacin detallada y amplia en el fichero de texto;Sirve para representar en pantalla
  el croado y no croado de las ranas;Es llamado desde el programa principal}
   Begin
    IF A then write('C')
         else write('_');
    IF B then write('C')
         else write('_');
    IF C then write('C')
         else write('_');
    IF D then write('C')
         else write('_');
   end;

  Procedure VecinasCroando (A,B,C,D: boolean; Var VA,VB,VC,VD: integer);
  {Explicacion detallada en el fichero de texto;Sirve para calcular el numero de ranas vecinas
  que cada rana tiene croando a su alrededor;Es llamado en el sexto modulo 'SiguienteCaso'}
   Var
    vecinas: integer;
   Begin
    VA:=0; VB:=0; VC:=0; VD:=0;
    If A then
     begin
       VB:=VB+1; VC:=VC+1; VD:=VD+1;
     end;
    If B then
     begin
       VA:=VA+1; VC:=VC+1; VD:=VD+1;
     end;
    If C then
     begin
       VA:=VA+1; VB:=VB+1; VD:=VD+1;
     end;
    If D then
     begin
       VA:=VA+1; VB:=VB+1; VC:=VC+1;
     end;
   end;

  Procedure Siguiente (nA,nB,nC,nD:integer; c0,c1,c2,c3:boolean; Var SA,SB,SC,SD:boolean);
  {Explicacin detallada en el fichero de texto;Sirve para calcular que ranas van a croar
  en el siguiente turno;Es llamado en el sexto modulo 'SiguienteCaso'}
   Begin
    If (nA=0) and c0 or (nA=1) and c1 or (nA=2) and c2 or (nA=3) and c3
     then SA:=true else SA:=false;
    If (nB=0) and c0 or (nB=1) and c1 or (nB=2) and c2 or (nB=3) and c3
     then SB:=true else SB:=false;
    If (nC=0) and c0 or (nC=1) and c1 or (nC=2) and c2 or (nC=3) and c3
     then SC:=true else SC:=false;
    If (nD=0) and c0 or (nD=1) and c1 or (nD=2) and c2 or (nD=3) and c3
     then SD:=true else SD:=false;
   end;

  Procedure SiguienteCaso (RA,RB,RC,RD:boolean; Var SA,SB,SC,SD:boolean; C0,C1,C2,C3:boolean);
  {Explicacin de este sexto modulo en fichero de texto;Sirve para llamar a los anteriores
  cuarto modulo 'VecinasCroando' y quinto modulo 'Siguiente'}
   Var
    vecA,vecB,vecC,vecD:integer;
   Begin
    VecinasCroando (RA,RB,RC,RD,vecA,vecB,vecC,vecD);
    Siguiente (vecA,vecB,vecC,vecD,c0,c1,c2,c3,SA,SB,SC,SD);
   end;

 VAR
  RA,RB,RC,RD,SA,SB,SC,SD,C0,C1,C2,C3:boolean;
  contador:integer;{variable contador para cumplir la condicion de finalizacion tras 20 turnos}
  respuesta:char; {variable respuesta para hacer si quiere volver a jugar o no}
 {Se declaran todas las variables}
 Begin
 {inicio del cuerpo del programa principal}
  Repeat {Para preguntarle si quiere volver a jugar}
   Inicial(SA,SB,SC,SD); {Se llama desde el programa principal al modulo primero}
   Condiciones(C0,C1,C2,C3); {Se llama desde el programa principal al modulo segundo}
   Escribir(SA,SB,SC,SD); {se llama desde el programa principal al tercer modulo}
   writeln;
   Contador:=0; {Se inicializa la variable contador}
   Repeat
    RA:=SA;
    RB:=SB;
    RC:=SC;
    RD:=SD;
    SiguienteCaso (RA,RB,RC,RD,SA,SB,SC,SD,C0,C1,C2,C3); {Se llama al sexto modulo}
    Escribir(SA,SB,SC,SD);
    Contador:=Contador+1;
    writeln;
   until (contador=20) or (RA=SA) and (RB=SB) and (RC=SC) and (RD=SD);
   {contador igual a 20 para que finalice tras 20 turnos y aqui tambien se aborda la condicion
   de finalizacion de antes si dos turnos seguidos las ranas no cambian de comportamiento}
   writeln;
   writeln ('Desea volver a jugar?');
   Repeat {Para que lo pregunte por lo menos una vez hasta que se cumpla la condicin}
   write('Para volver a jugar pulse S o si no quiere jugar pulse N: ');
   readln (respuesta);
   respuesta:=upCase(respuesta) {De nuevo empleo de upCase para ahorrar codigo}
   until (respuesta='S') or (respuesta='N');
  until (respuesta='N'); {Condicion correspondiente al primer repeat del programa principal}
   writeln;
   writeln ('Pulse enter para salir');
   readln;
 END.

