PROGRAM juego_de_ranas;

USES crt;



PROCEDURE introduccion;
begin

writeln('Bienvenido al juego de las ranas!');
writeln;
writeln('Tenemos cuatro ranas alrededor de una charca,representadas con letras: A,B,C,D');
writeln('El jugador elegira si quiere que las ranas croen o no en el estado inicial.');
writeln('Tambien tendra que seleccionar varios criterios de juego:');
writeln('-si quiere que las ranas croen cuando 1,2,3 o ninguna rana vecina croe.');
writeln;
writeln('El desarrollo del juego tendra lugar segun como se hayan escogido estos crierios');
write('El juego finalizara tras 20 turnos a partir del estado inicial,');
writeln('o bien cuando un turno coincida con el anterior.');
writeln;
writeln('Pulse intro para comenzar con el juego.');
readln

end;


PROCEDURE estado_inicial(var E:integer;r:integer);
{con este rocedimiento se pide al usuario que identifique el estado
inicial de cada rana: 0(si no croa) o 1(si croa)}



begin
{$I-}
     repeat

           begin
                writeln('Escriba el estado inicial de la rana ', r,'a : 1{croe},0{no croe}');


                readln(E)
           end;
     until (IORESULT=0) and ((E=0) or (E=1))
{$I+}
end;




PROCEDURE elegir_criterio(var k:integer;numero:integer);
{con este procedimiento se le pregunta al usuario si quiere que
en los sucesivos turnos las ranas croen cuando tienen una rana
vecina croando,dos,tres o ninguna}


begin
{$I-}
     repeat
        begin
             if numero=1 then
                  writeln('Quiere que las ranas croen con ',numero,' vecina croando?Escriba 1{SI} o 0{NO}')
             else
                  writeln('Quiere que las ranas croen con ',numero,' vecinas croando?Escriba 1{SI} o 0{NO}');
             readln(k);
        end;
     until (IORESULT=0) and ((k=1) or (k=0))
end;




PROCEDURE dibuja_ranas(RA,RB,RC,RD:integer);
{este procedimiento es el encargado de dibujar el estado de las ranas
en cada uno de los turnos; si a una rana le correponde un 1(croa) se
dibujar una 'C';si le correponde un 0(no croa) dibujara un '_'}


begin
     if RA=1 then write('C') else write('_');
     if RB=1 then write('C') else write('_');
     if RC=1 then write('C') else write('_');
     if RD=1 then write('C') else write('_')
end;



PROCEDURE turnos(c1,c2,c3,c4:integer;var x:integer;y,z,t:integer);
{este procedimiento es el encargado de asignar un criterio de juego
de los que el usuario ha escogido en funcion de las ranas vecinas que
tenga cada una de las ranas}

begin
   case (y+z+t) of

     0:  x:=c1;
     1:  x:=c2;
     2:  x:=c3;
     3:  x:=c4

   end
end;



FUNCTION estado_igual(e,f,g,h,e1,f1,g1,h1:integer):boolean;
{esta funcion comprueba si el estado de cada una de las ranas
es igual al del turno anterior}

begin
     estado_igual:= ((e=e1) and (f=f1) and (g=g1) and (h=h1))
end;




VAR

a,b,c,d,a1,b1,c1,d1:integer;
criterio1,criterio2,criterio3,criterio4:integer;
numero,r,contador:integer;
t:char;
final:boolean;


BEGIN

clrscr;

introduccion;

clrscr;

repeat

      estado_inicial(a,1);
      estado_inicial(b,2);
      estado_inicial(c,3);
      estado_inicial(d,4);

clrscr;

       elegir_criterio(criterio1,0);
       elegir_criterio(criterio2,1);
       elegir_criterio(criterio3,2);
       elegir_criterio(criterio4,3);
clrscr;

       writeln('                ABCD');
       write('ESTADO INICIAL: ');
       dibuja_ranas(a,b,c,d);
       contador:=0;
       writeln;

       repeat

            contador:=contador+1;
            turnos(criterio1,criterio2,criterio3,criterio4,a1,b,c,d);
            turnos(criterio1,criterio2,criterio3,criterio4,b1,c,d,a);
            turnos(criterio1,criterio2,criterio3,criterio4,c1,d,a,b);
            turnos(criterio1,criterio2,criterio3,criterio4,d1,a,b,c);

            if contador>=10 then
               write('turno ',contador, ':       ')
            else write('turno ',contador, ':        ');
               dibuja_ranas(a1,b1,c1,d1);

            final:= estado_igual(a,b,c,d,a1,b1,c1,d1);
            if not final then
               begin
                a:=a1;
                b:=b1;
                c:=c1;
                d:=d1
               end;

            writeln;

       until (final or (contador>19));

writeln;

       repeat
             writeln('Desea comenzar a jugar otra vez? escriba S para volver a jugar o N para salir');
             readln(t);

             clrscr;
             t:=upcase(t);
       until (t='S') or (t='N');

until t='N'

end.









