program ranas;
{en este programa vamos a ver los sucesivos croados de cuatro ranas
durante varias rondas(maximo 20) a partir de su condicion inicial
y sus reglas de croado.}
procedure obtenervalorinicial(var x:integer);
{en este procedimiento vamos a introducir las condiciones iniciales
de nuestras 4 ranas llamandolo desde el programa principal cada vez
con cada rana. introducimos una variable entera que toma los valores
1 o 0 segun croe(1) o no(0). la funcion del bucle repeat evita que
se introduzcan mal los datos.}
begin{$I-}
     repeat
           write('introduce el estado de la rana');
           readln(x);
     until ((x=1)or(x=0))and(IOResult=0);
{$I+}
end;

procedure escribir(var croar:integer);
{con el procedimiento escribir conseguimos que nos muestre por pantalla
las sucesivas rondas escribiendo "C" o "_" segun croen o no las ranas,
esto lo conseguimos con el bucle if  then}
begin
     if croar=1 then write('C')
     else write('_');
end;

procedure condiciones(var x, y, z, t:integer);
{el procedimiento condiciones nos sirve para introducir las reglas de croado
PARA CADA RANA, ya que llamamos al procedimiento con las variables de
condicion 4 veces, una para cada rana. con esto conseguimos los instrumentos
necesarios para averiguar que hara cada rana en el siguiente turno, aunque
eso se calcula en otro procedimiento. el bucle repeat tiene la misma
finalidad que en el procedimiento obtenervalorinicial, asegurandonos
que x, y, z, t toman valores 1 o 0 es decir si croara o no en cada
uno de los casos.}
begin{$I-}
     repeat
           write('croa cuando croa 1?');readln(x);
           write('croa cuando croan 2?');readln(y);
           write('croa cuando croan 3?');readln(z);
           write('croa cuando crona 0?');readln(t);
     until (((x=1)or(x=0))and((y=0)or(y=1))and((z=0)or(z=1))and((t=0)or(t=1)))and(IOResult=0);
{$I+}
end;

procedure sigrana(var r1, q, w, e, p, or1, or2, or3:integer);
{este ultimo procedimiento nos calcula para cada rana si croara o no en
el siguiente turno. lo que he hecho es sumar cuantas ranas croan en el turno
anterior y se lo he asignado a una variable local del procedimiento
llamada cont, luego segun valga cont y mirando las condiciones de cada rana en
el bucle case of le asigno si croara o no con las variables de condicion q,w,e,p}
          var cont:integer;
begin
               cont:=or1+or2+or3;
               case cont of
                    1:r1:=q;
                    2:r1:=w;
                    3:r1:=e;
                    0:r1:=p;
               end;
end;

var
{pasemos ahora a explicar para que son cada una de las variables:
la variables rana(A,B,C,D)las utilizo para dar los valores iniciales de las
ranas y para pasarles el valor a escribir en cada ronda.
la variables rana(A1,B1,C1,D1)son variables auxiliares de las anteriores para
no sobreescribir valores, una vez calculadas todas, a las variables
rana(A,B,C,D)les asigno estos valores correspondientemente.
la variables de la forma rxcy r significa rana y c significa condicion
asi hay 4 condiciones para cada una de las ranas, por ejemplo r3c2 sera
la condicion de la rana 3(C) si croan 2 ranas vecinas, la condicion r1c0 sera
la condicion  de la rana 1(A) si croan 0 ranas vecinas, etc.
la variable i es un contador utilizado para que la primera vez no asigne
los valores rana(A1,B1,C1,D1) a los de rana(A,B,C,D) ya que la primera
vez son leidos de teclado.}

   ranaA, ranaB, ranaC, ranaD, i:integer;
   ranaA1, ranaB1, ranaC1, ranaD1:integer;
   r1c1, r1c2, r1c3, r1c0, r2c1, r2c2, r2c3, r2c0, r3c1, r3c2, r3c3, r3c0:integer;
   r4c1, r4c2, r4c3, r4c0:integer;

begin
     writeln('escribe los estados iniciales de las ranas A, B, C, D');
     writeln('si la rana croa escribe 1 sino escribe 0');
     {encabezamiento del programa para que lo muestre por pantalla}
     writeln('para la rana A');obtenervalorinicial(ranaA);condiciones(r1c1, r1c2, r1c3, r1c0);
     {en la linea anterior ponemos un encabezamiento escrito para saber
     que ahora le toca a la primera rana y llamamos a el procedimiento
     obtener valor inicial para introducir si croa inicialmente
     y al procedimiento condiciones para introducir sus condiciones de croado.
     seguidamente lo mismo para las otras 3 ranas}
     writeln('para la rana B');obtenervalorinicial(ranaB);condiciones(r2c1, r2c2, r2c3, r2c0);
     writeln('para la rana C');obtenervalorinicial(ranaC);condiciones(r3c1, r3c2, r3c3, r3c0);
     writeln('para la rana D');obtenervalorinicial(ranaD);condiciones(r4c1, r4c2, r4c3, r4c0);
     i:=0;
     {inicializamos la variable "i" a cero ya que la primera vez no tenemos
     que asignar los  valores a las ranas porque los hemos tomado por teclado}
          repeat
          {aqui comienza un bucle repeat para que en cada turno haga lo
          siguiente}
                if i<>0 then begin
                {con este bucle if asignamos los valores para escribirlos
                una vez cambiados salvo la primera vez que como i es igual
                a cero no entra en este bucle}
                             ranaA:=ranaA1;ranaB:=ranaB1;ranaC:=ranaC1;ranaD:=ranaD1;readln;
                             end;
                {llamamos al procedimiento escribir con cada una de las
                ranas para que con nuestro procedimiento escriba si croan o no}
                escribir(ranaA);escribir(ranaB);escribir(ranaC);escribir(ranaD);
                {ahora llamamos al procedimiento sigrana con la variable de
                siguiente turno de cada rana, las variables actuales de lo que
                hacen las demas ranas y las condiciones de la rana de la que
                queremos hallar su siguiente turno, esto para cada una de
                nuestras ranas}
                sigrana(ranaA1, r1c1, r1c2, r1c3, r1c0, ranaB, ranaC, ranaD);
                sigrana(ranaB1, r2c1, r2c2, r2c3, r2c0, ranaA, ranaC, ranaD);
                sigrana(ranaC1, r3c1, r3c2, r3c3, r3c0, ranaA, ranaB, ranaD);
                sigrana(ranaD1, r4c1, r4c2, r4c3, r4c0, ranaA, ranaB, ranaC);
                {a la variable i le sumamos 1 para que vaya contando los turnos
                que llevamos, ademas para que en el bucle if desde la segunda
                vez asigne los valores nuevos para ser escritos por pantalla}
                i:=i+1;
          until (i=20)or((ranaA=ranaA1)and(ranaB=ranaB1)and(ranaC=ranaC1)and(ranaD=ranaD1));
          {el bucle repeat se realizara hasta que llegue a 20 turnos o hasta
          que los croados de un turno sean los mismos en el anterior para cada
          rana}
     readln
     {readln para que no se vaya la pantalla hasta que pulsemos intro}
end.