{****************************************************************************}
{                                                                            }
{                                                                            }
{****************************************************************************}
program ranas;



function pide_estado_actual(num_rana:integer):boolean;
{Se pide por pantalla el estado inicial de las distintas ranas}
{Se programa para que acepte maysculas y minsculas}
var
  x: char;
begin
   repeat
     begin

        Write('Est croando la rana ', num_rana, '?' );
        readln(x);
     end;
     if not((x='S') or (x='s') or (x='N') or (x='n')) then
        writeln('Se ha equivocado , debe contestar s/S o n/N ');

   until ((x='S')or (x='s')or (x='N')or (x='n'));
   if ((x='S')or (x='s')) then
      pide_estado_actual:=true
   else
      pide_estado_actual:=false;
end;

procedure estado_actual(var r1, r2, r3, r4: boolean);
{procedimiento que pide por pantalla al usuario el estado actual de todas}
{las ranas. Utiliza la funcin pide_estado_actual}
begin
  r1:= pide_estado_actual (1);
  r2:= pide_estado_actual (2);
  r3:= pide_estado_actual (3);
  r4:= pide_estado_actual (4);
end;

{*****************************************************************}

function pide_condiciones_croar (num_rana, num_vecinos:integer):boolean;
{funcin que para una rana en concreto pide las condiciones en las que croar}
var
x:char;
begin
   repeat
     begin

        Write('La rana ', num_rana, ' croar cuando tenga ', num_vecinos, ' vecinos ? (S/N)' );
        readln(x);
     end;
     if not((x='S') or (x='s') or (x='N') or (x='n')) then
        writeln('Se ha equivocado , debe contestar s/S o n/N ');

   until ((x='S') or (x='s') or (x='N') or (x='n'));
   if ((x='S') or (x='s')) then
     pide_condiciones_croar:=true
   else
     pide_condiciones_croar:= false;
end;

procedure cond_vecinos(num_rana:integer; var vec0, vec1, vec2, vec3: boolean);
{Pide por pantalla al usuario las condiciones de croar para una rana en}
{concreto, num_rana. Utiliza la funcion pide_condiciones_croar}
begin
  vec0:= pide_condiciones_croar (num_rana, 0);
  vec1:= pide_condiciones_croar (num_rana, 1);
  vec2:= pide_condiciones_croar (num_rana, 2);
  vec3:= pide_condiciones_croar (num_rana, 3);
end;

{*****************************************************************}

function calcula_num_vecinos(var vec1,vec2,vec3:boolean):integer;
{En funcion del estado actual de los vecinos se calcula el nmero de vecinos}
{que una determinada rana tiene croando}
var
 x:integer;
begin
 x:=0;
 if vec1 = true then x:= x+1;
 if vec2 = true then x:= x+1;
 if vec3 = true then x:= x+1;
 calcula_num_vecinos := x;
end;

procedure halla_num_vecinos(var num_vec_r1, num_vec_r2, num_vec_r3, num_vec_r4: integer; var r1, r2, r3, r4: boolean) ;
{halla el nmero de vecinos que tiene croando cada una de las ranas. Para}
{ello utiliza la funcin calcula_num_vecinos}
begin
   num_vec_r1:= calcula_num_vecinos(r2, r3, r4);
   num_vec_r2:= calcula_num_vecinos(r1, r3, r4);
   num_vec_r3:= calcula_num_vecinos(r1, r2, r4);
   num_vec_r4:= calcula_num_vecinos(r1, r2, r3);
end;

{*****************************************************************}

function estado_sig(num_vec:integer; var cond0, cond1, cond2, cond3:boolean):boolean;
{Segn el nmero de vecinos y las condiciones de croa que se definieron al}
{principio del programa, esta funcion calcula el estado siguiente para una}
{determinada rana}
begin
   case num_vec of
    0:if cond0= true then
       estado_sig:=true
      else
       estado_sig:=false;
    1:if cond1= true then
       estado_sig:=true
      else
       estado_sig:=false;
    2:if cond2= true then
       estado_sig:=true
      else
       estado_sig:=false;
    3:if cond3= true then
       estado_sig:=true
      else
       estado_sig:=false;
   end;

end;

procedure estado_sig_ranaN(var est_sig:boolean; var vec:integer; var cond_0, cond_1, cond_2, cond_3: boolean);
{Procedimiento que modifica el estado siguiente de una determinada rana N}
{utilizando la funcin estado_sig que es la que realmente lo calcula}
begin
  est_sig:= estado_sig(vec, cond_0, cond_1, cond_2, cond_3);
end;

{*****************************************************************}

procedure intercambia_estados(var rep:integer; var r1_act, r2_act, r3_act, r4_act, r1_sig, r2_sig, r3_sig, r4_sig:boolean);
{Al final de cada turno, el estado siguiente pasa a ser el estado actual}
{Este procedimiento realiza ese cambio}
begin
    if ((r1_act=r1_sig) and (r2_act=r2_sig) and (r3_act=r3_sig) and (r4_act=r4_sig)) then
     rep:= rep +1
    else
      rep:=0;
    r1_act:=r1_sig;
    r2_act:=r2_sig;
    r3_act:=r3_sig;
    r4_act:=r4_sig;

end;

procedure escribe_estado(var tur:integer; var r1_act, r2_act, r3_act, r4_act:boolean);
{Procedimiento que escribe por pantalla el estado actual para cada turno de}
{juego. Se distingue entre turnos <10 y superiores para que quede en lnea}
{con el identificador de cada rana: ABCD}
var
r1_Est_act, r2_Est_act, r3_Est_act, r4_Est_act: boolean;{Estado actual ranas}

begin
  if (tur <10) then
    Write (' ', tur, ': ')
  else
    Write (tur, ': ');

  if (r1_Est_act= true) then
    write('C')
  else
    write('_');
  if (r2_Est_act= true) then
    write('C')
  else
    write('_');
  if (r3_Est_act= true) then
    write('C')
  else
    write('_');
  if (r4_Est_act= true) then
    write('C')
  else
    write('_');
  writeln;
end;


 var
r1_Estado_act, r2_Estado_act, r3_Estado_act, r4_Estado_act: boolean;{Estado actual ranas}
r1_Estado_sig, r2_Estado_sig, r3_Estado_sig, r4_Estado_sig: boolean;{Estado siguiente ranas}
num_veci_r1, num_veci_r2, num_veci_r3, num_veci_r4: integer;{Numero vecinos ranas}
cond_0veci_r1, cond_1veci_r1, cond_2veci_r1, cond_3veci_r1:boolean;{Condiciones croar rana1}
cond_0veci_r2, cond_1veci_r2, cond_2veci_r2, cond_3veci_r2:boolean;{Condiciones croar rana2}
cond_0veci_r3, cond_1veci_r3,  cond_2veci_r3, cond_3veci_r3:boolean;{Condiciones croar rana3}
cond_0veci_r4, cond_1veci_r4,  cond_2veci_r4, cond_3veci_r4:boolean;{Condiciones croar rana4}
repeticion:integer;{numero de turnos que se repiten}
turnos:integer; {contador de turnos}
respuesta:char; {almacena si el jugador quiere volver a jugar}


begin

  repeat
   begin
   {$I-}
   repeticion:=0;{variable que se incrementa cuando en dos turnos seguidos no}
                 {hay cambio}
   turnos:=1;{variable que almacena el nmero de turno en el juego}

   estado_actual(r1_Estado_act, r2_Estado_act, r3_Estado_act, r4_Estado_act);
   Writeln;
   cond_vecinos(1, cond_0veci_r1, cond_1veci_r1, cond_2veci_r1, cond_3veci_r1);
   Writeln;
   cond_vecinos(2, cond_0veci_r2, cond_1veci_r2, cond_2veci_r2, cond_3veci_r2);
   Writeln;

   cond_vecinos(3, cond_0veci_r3, cond_1veci_r3, cond_2veci_r3, cond_3veci_r3);
   Writeln;
   cond_vecinos(4, cond_0veci_r4, cond_1veci_r4, cond_2veci_r4, cond_3veci_r4);
   Writeln;

   Writeln('    ABCD');
   repeat
    begin

     escribe_estado(turnos,r1_Estado_act, r2_Estado_act, r3_Estado_act, r4_Estado_act );
     halla_num_vecinos(num_veci_r1,num_veci_r2,num_veci_r3,num_veci_r4,r1_Estado_act,r2_Estado_act,
                       r3_Estado_act,r4_Estado_act);
     {N=1} estado_sig_ranaN(r1_Estado_sig, num_veci_r1, cond_0veci_r1, cond_1veci_r1, cond_2veci_r1, cond_3veci_r1);
     {N=2} estado_sig_ranaN(r2_Estado_sig, num_veci_r2, cond_0veci_r2, cond_1veci_r2, cond_2veci_r2, cond_3veci_r2);
     {N=3} estado_sig_ranaN(r3_Estado_sig, num_veci_r3, cond_0veci_r3, cond_1veci_r3, cond_2veci_r3, cond_3veci_r3);
     {N=4} estado_sig_ranaN(r4_Estado_sig, num_veci_r4, cond_0veci_r4, cond_1veci_r4, cond_2veci_r4, cond_3veci_r4);
     intercambia_estados(repeticion,r1_Estado_act,r2_Estado_act,r3_Estado_act,r4_Estado_act,r1_Estado_sig,
                         r2_Estado_sig,r3_Estado_sig,r4_Estado_sig);
     turnos:= turnos +1;
    end;

   until ((turnos=21) or (repeticion=2));
   repeat
    begin

      Write('Quieres volver a jugar, S/N ?');
      readln(respuesta);
    end;
   until ((respuesta ='S') or (respuesta = 's') or (respuesta = 'N') or (respuesta = 'n'));
   end

  until ((respuesta = 'N') or (respuesta = 'n'))

End.
