Program Ranas_Croando;
{Programa para simular un grupo de cuatro ranas croando alrededor de una charca}

Uses Crt;

Function obtener_estado_inicial (Rana:char): boolean;
{Funcin que permite al usuario obtener el estado inicial de cada rana A,B,C y D}
     var
        resp:char;
        estado:boolean;
     Begin
        Repeat
           writeln ('Dime el estado de la rana ', Rana ,  ' para que croe pulse T, en caso contrario pulse F');
           readln (resp);
        Until (resp='T') OR (resp='t') OR (resp='F') OR (resp='f');
           If (resp='T') OR (resp='t') then
              estado:=true
           Else
              estado:=false;
              obtener_estado_inicial:= estado;
     end;

Function Croa_0vecinas :boolean;
{Funcin que determina si croa o no con cero ranas vecinas, en funcin de las ranas vecinas que tenga croando}
     var
        resp:char;
     Begin
        Repeat
           writeln('Con cero vecinas croando, si quiere que croe pulse T, en caso contrario pulse F');
           readln (resp);
        Until (resp='T') OR (resp='t') OR (resp='F') OR (resp='f');
           If (resp='T') OR (resp='t') then
              Croa_0vecinas:= true
           Else
              Croa_0vecinas:= false;
     end;

Function Croa_1vecina:boolean;
{Funcin que determina si croa o no con una rana vecina, en funcin de las ranas vecinas que tenga croando}
     var
        resp:char;
     Begin
        Repeat
           writeln('Con una vecina croando, si quiere que croe pulse T, en caso contrario pulse F');
           readln (resp);
        Until (resp='T') OR (resp='t') OR (resp='F') OR (resp='f');
           If (resp='T') OR (resp='t') then
              Croa_1vecina:= true
           Else
              Croa_1vecina:= false;
     end;

Function Croa_2vecinas:boolean;
{Funcin que determina si croa o no con dos ranas vecinas, en funcin de las ranas vecinas que tenga croando}
     var
        resp:char;
     Begin
        Repeat
           writeln('Con dos vecinas croando, si quiere que croe pulse T, en caso contrario pulse F');
           readln (resp);
        Until (resp='T') OR (resp='t') OR (resp='F') OR (resp='f');
           If (resp='T') OR (resp='t') then
              Croa_2vecinas:= true
           Else
              Croa_2vecinas:= false;
     end;


Function Croa_3vecinas:boolean;
{Funcin que determina si croa o no con tres ranas vecinas, en funcin de las ranas vecinas que tenga croando}
     var
        resp:char;
     Begin
        Repeat
           writeln('Con tres vecinas croando, si quiere que croe pulse T, en caso contrario pulse F');
           readln (resp);
        Until (resp='T') OR (resp='t') OR (resp='F') OR (resp='f');
           If (resp='T') OR (resp='t') then
              Croa_3vecinas:= true
           Else
              Croa_3vecinas:= false;
     end;

Function n_ranas_vecinas (e1,e2,e3:boolean):integer;
{Funcin que sirve de contador para saber las ranas que hay croando al mismo tiempo}
     var
        ranas_vecinas: integer;
     Begin
        ranas_vecinas:=0;
        If e1 then
           ranas_vecinas:=ranas_vecinas+1;
        If e2 then
           ranas_vecinas:=ranas_vecinas+1;
        If e3 then
           ranas_vecinas:=ranas_vecinas+1;
        n_ranas_vecinas:=ranas_vecinas;
     end;

Procedure siguiente_estado(rana_I,rana_v1,rana_v2,rana_v3,Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec:boolean; var rana_F:boolean);
{Este procedimiento nos permite saber el siguiente estado del juego}
     var
        n_v:integer;
     Begin
        n_v:= n_ranas_vecinas (rana_v1,rana_v2,rana_v3);

        If (n_v=0) AND (Croa_0vec) OR (n_v=1) AND (Croa_1vec)
           OR (n_v=2) AND (Croa_2vec) OR (n_v=3) AND (Croa_3vec) then
           rana_F:=true
        Else
           rana_F:=false;
     end;

Procedure Escribir (RanaA,RanaB,RanaC,RanaD:boolean);
{Procedimiento que nos escribir por pantalla si croan C, o sino croan _}
   Begin
       If RanaA then
          write ('c')
       Else
          write ('_');

       If RanaB then
          write ('c')
       Else
          write ('_');

       If RanaC then
          write ('c')
       Else
          write('_');

       If RanaD then
          write('c')
       Else
          write('_');
    end;

{Empieza el cuerpo del programa principal}

var
{Aqu se definen las variables del programa principal}
   RanaA,RanaB,RanaC,RanaD,ranaAf,ranaBf,ranaCf,ranaDf: boolean;
   Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec:boolean;
   cont:integer;
   iguales:boolean;
   r1:char;
Begin
     Repeat
        RanaA:= obtener_estado_inicial ('A');
        RanaB:= obtener_estado_inicial ('B');
        RanaC:= obtener_estado_inicial ('C');
        RanaD:= obtener_estado_inicial ('D');

        Escribir(RanaA,RanaB,RanaC,RanaD);
        writeln;

        Croa_0vec:= Croa_0vecinas;
        Croa_1vec:= Croa_1vecina;
        Croa_2vec:= Croa_2vecinas;
        Croa_3vec:= Croa_3vecinas;

        cont:=0;
        Repeat
           siguiente_estado(RanaA,RanaB,RanaC,RanaD,Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec,ranaAf);
           siguiente_estado(RanaB,RanaA,RanaC,RanaD,Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec,ranaBf);
           siguiente_estado(RanaC,RanaB,RanaA,RanaD,Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec,ranaCf);
           siguiente_estado(RanaD,RanaB,RanaC,RanaA,Croa_0vec,Croa_1vec,Croa_2vec,Croa_3vec,ranaDf);

        cont:=cont+1;
        write(cont);
        write(':');

        Escribir(ranaAf,ranaBf,ranaCf,ranaDf);
        writeln;

        If (RanaA=ranaAf) AND (RanaB=ranaBf) AND (RanaC=ranaCf) AND (RanaD=ranaDf) then
             iguales:=true
        Else
             Begin
             iguales:=false;
                RanaA:=ranaAf;
                RanaB:=ranaBf;
                RanaC:=ranaCf;
                RanaD:=ranaDf;
             end;
        Until (cont=20) OR (iguales);
   {$I-}
   Repeat
      writeln ('Quiere volver a jugar? Pulse S/N');
      readln (r1);
      ClrScr;
   Until (IOResult=0) OR (r1='S') OR (r1='s') OR (r1='N') OR (r1='n');
   {$I+}

Until (r1='N') OR (r1='n');
      writeln ('El juego ha finalizado');
end.