PROGRAM FourFroogs (input,output);

USES
crt;

PROCEDURE encabezamiento;

BEGIN

writeln;
writeln('     *************************************************');
writeln('     ********     **     **  ** **     **     ********');
writeln('     ******** *** ** *** **   * ** *** ** ************');
writeln('     ********     **     ** *   **     **     ********');
writeln('     ******** * **** *** ** **  ** *** ****** ********');
writeln('     ******** ** *** *** ** *** ** *** **     ********');
writeln('     *************************************************');
writeln
END;


FUNCTION preguntaayuda:boolean ;

VAR
a:char;

BEGIN

WHILE (a<>('s') ) and (a<>('n')) DO
  begin
  encabezamiento;
  writeln('Bienvenido a FourFrogs');
  writeln;
  writeln('Desea obtener una pequea ayuda introductoria?');
  writeln;
  Readln(a);
  IF (a=('s')) THEN preguntaayuda:=true
  ELSE preguntaayuda:=false
  end

END;





PROCEDURE ayuda;

BEGIN

writeln('El juego consiste en un estanque con cuatro ranas alrededor ');
writeln('Cada rana croa o no cro dependiendo de lo que las otras hayan');
writeln('   hecho en la ronda anterior.');
writeln('Las condiciones introducidas usted se aplicaran para el calculo');
writeln('   de cada paso');
writeln('La serie terminara cuando sucedan dos rondas iguales o cuando');
writeln('   alcancen 20 rondas');
writeln('Pulse cualquier tecla para continuar');
readln;
clrscr;
encabezamiento

END;



FUNCTION asignaCroa:boolean;

VAR
a       :char;

BEGIN

WHILE (a<>('s') ) and (a<>('n')) DO
  begin
  Writeln(' Si croa (s). Si no croa (n)');
  Readln(a);
  IF (a=('s')) THEN asignaCroa:=true
  ELSE asignaCroa:=false
  end;
END;



PROCEDURE leeranas(var a,b,c,d:boolean);
{variables por referencia por necesidad de modificarlas}
BEGIN
writeln('                  **  ESTADO INICIAL  **         ');
writeln;
write('Introduzca el estado inicial de la rana A.');
a:=asignaCroa ;
write('Introduzca el estado inicial de la rana B.');
b:=asignaCroa ;
write('Introduzca el estado inicial de la rana C.');
c:=asignaCroa ;
write('Introduzca el estado inicial de la rana D.');
d:=asignaCroa  ;
writeln;

END;



PROCEDURE leecondiciones(var con0,con1,con2,con3:boolean);
{variables por referencia por necesidad de modificarlas}
BEGIN
writeln('                  **   CONDICIONES   **                          ');
writeln;
writeln('Introduzca si una rana croar cuando haya 0 vecinas suyas croando');
con0:=asignaCroa ;
writeln('Introduzca si una rana croar cuando haya 1 vecina suya croando');
con1:=asignaCroa ;
writeln('Introduzca si una rana croar cuando haya 2 vecinas suyas croando');
con2:=asignaCroa ;
writeln('Introduzca si una rana croar cuando haya 3 vecinas suyas croando');
con3:=asignaCroa  ;
writeln;

END;



FUNCTION asignador(var bul:boolean):integer;
{variable por referencia para consumir menos memoria}
BEGIN

IF (bul=(true)) THEN asignador:=1
ELSE asignador:=0

END;




FUNCTION croantotal(var a,b,c,d:boolean):integer;
{variables por referencia para consumir menos memoria}
VAR
p1,p2,p3,p4  :integer;

BEGIN
p1:=asignador(a);
p2:=asignador(b);
p3:=asignador(c);
p4:=asignador(d);
croantotal:=(p1+p2+p3+p4)  ;

END;





FUNCTION vecinas(var  bul:boolean; var total:integer):integer;
{variables por referencia para consumir menos memoria}
BEGIN

IF  bul=(true) THEN
vecinas:=(total-1)
  ELSE
  vecinas:=total


END;




PROCEDURE dibujar (var a,b,c,d:boolean);
{variables por referencia para consumir menos memoria}
BEGIN

if a = true then write ('- C ') else write('- _ ')  ;
if b = true then write ('C ') else write('_ ') ;
if c = true then write ('C ') else write('_ ');
if d = true then writeln ('C -') else writeln('_ -')

END;



FUNCTION condition(var con0,con1,con2,con3:boolean;var vec:integer):boolean;
{variables por referencia para consumir menos memoria}
BEGIN

IF (vec=0) THEN
 condition:= (con0)
  ELSE
    IF (vec=1) THEN
    condition:= (con1)
      ELSE
        IF vec=2 THEN
        condition:= (con2)
          ELSE
          condition:= (con3);

END;



PROCEDURE round2(var a,b,c,d:boolean;con0,con1,con2,con3:boolean;var total,ronda:integer);
{variables por referencia por necesidad de modificarlas}
VAR
vecA,vecB,vecC,vecD  :integer;
a2,b2,c2,d2          :boolean;

BEGIN

a2:=a;
b2:=b;
c2:=c;
d2:=d;

vecA:=vecinas(a,total);
vecB:=vecinas(b,total);
vecC:=vecinas(c,total);
vecD:=vecinas(d,total);

a:=condition(con0,con1,con2,con3,vecA) ;
b:=condition(con0,con1,con2,con3,vecB) ;
c:=condition(con0,con1,con2,con3,vecC) ;
d:=condition(con0,con1,con2,con3,vecD) ;

if((a=a2) and (b=b2) and (c=c2) and (d=d2)) then ronda:=21 ELSE ronda:=(ronda+1);

END;



FUNCTION continuar:boolean ;

VAR
a:char;

begin

WHILE (a<>('s') ) and (a<>('n')) DO
  begin
  writeln('Desea jugar otra vez? SI (s) o NO (n)');
  Readln(a);
  IF (a=('s')) THEN continuar:=true
  ELSE continuar:=false
  end

 end;

PROCEDURE general ;

VAR
a,b,c,d,con0,con1,con2,con3,fin,juego,help :boolean;
total,ronda                                :integer;

BEGIN
juego:=true ;
help:=preguntaayuda;
IF help THEN ayuda ;


WHILE juego DO

begin
clrscr;
encabezamiento;
leeranas(a,b,c,d);
leecondiciones(con0,con1,con2,con3);
fin:=false;
ronda:=1;
dibujar(a,b,c,d);

WHILE (ronda<20) DO

  begin
  croantotal(a,b,c,d);
  total:=croantotal(a,b,c,d);
  round2(a,b,c,d,con0,con1,con2,con3,total,ronda);
  dibujar(a,b,c,d);
  end;
juego:=continuar;
end;
END;



BEGIN

general;


END.

