PROGRAM frog;

uses crt;
{G17P02D2 Programa diseado por Maria Luisa Santillan Beltran 512909 y Maria
Gloria Cortes Concha 535653}

{*********************************************}
{Funcion que comprueba que la respuesta dada por
el usuario es correcta,y en caso contrario
imprime un mensaje de error}
{*********************************************}
FUNCTION comprueb_resp(resp:CHAR): BOOLEAN;
  BEGIN
    IF ((resp <> 'Y') AND (resp <> 'N')) THEN
      BEGIN
        CLRSCR;
        WRITE('/\ Introduzca una opcion valida /\');
        TEXTCOLOR(red);
        WRITELN('(Y/N)');
        TEXTCOLOR(WHITE);
        comprueb_resp:=FALSE;
      END
      ELSE
        comprueb_resp:=TRUE;
  END;


{*********************************************}
{Mediante este procedimiento se le pregunta al usuario
que ranas desea que croen inicialmente}
{*********************************************}
PROCEDURE question (VAR rana: CHAR;id_rana:CHAR);
 VAR
   i:INTEGER;
   resp:char;

 BEGIN
   REPEAT
     CLRSCR;
     WRITE('Desea que la rana ', id_rana,' croe inicialmente? ');
     TEXTCOLOR(red);
     WRITELN ('(Y/N)');
     TEXTCOLOR(white);
     READLN(rana);
     rana:= UPCASE(rana);
   UNTIL TRUE = comprueb_resp(rana);

 END;



{*********************************************}
{Mediante este procedimiento se le pregunta al usuario
cuales van a ser las reglas para que las ranas croen en
el siguiente turno}
{*********************************************}
PROCEDURE reglas (VAR veci:CHAR;num:INTEGER);
  VAR
    i:INTEGER;

  BEGIN
    REPEAT
      CLRSCR;
      WRITE('Desea que la rana croe cuando haya ',num,' ranas vecinas croando?');
      TEXTCOLOR(red);
      WRITELN ('(Y/N)');
      TEXTCOLOR(white);
      READLN(veci);
      veci:= UPCASE(veci);
    UNTIL TRUE = comprueb_resp(veci);
  END;


{*********************************************}
{procedimento que imprime los croacs emitidos}
{*********************************************}
PROCEDURE impresion_croacs(rana:CHAR);
  VAR
    id_rana:CHAR;
  BEGIN
    IF rana = 'Y' THEN
        WRITE('C')
        ELSE WRITE('_');
  END;


{*********************************************}
{Procedimiento para calcular si una rana empieza
  a croar por tener X vecinas croando}
{*********************************************}
PROCEDURE ranas_croando(VAR rana,r1,r2,r3:CHAR;num:integer);
  VAR
    id_rana,i:CHAR;
    cuant_croaban:INTEGER;
  BEGIN
    cuant_croaban:=0;
    IF r1 ='Y' THEN cuant_croaban:=cuant_croaban +1;
    IF r2 ='Y' THEN cuant_croaban:=cuant_croaban +1;
    IF r3 ='Y' THEN cuant_croaban:=cuant_croaban +1;
    IF cuant_croaban = num THEN rana:='Y';

  END;
{*********************************************}
{Procedimiento q indica el proximo comportamiento
de las ranas}
{*********************************************}
PROCEDURE cambio_comport(VAR rana,vec,rant1,rant2,rant3:CHAR;num:INTEGER);
  VAR
    id_rana:CHAR;
    i:integer;

  BEGIN
   IF vec= 'Y' THEN ranas_croando(rana,rant1,rant2,rant3,num);
  END;

{*********************************************}
{Procedimiento que hace las llamadas a cambio de comportamiento}
{*********************************************}
PROCEDURE llama_cambio(VAR r_ini1,r_ini2,r_ini3,r_ini4,
                       r_ant1,r_ant2,r_ant3,r_ant4,
                       vec0,vec1,vec2,vec3:CHAR);
  BEGIN
      cambio_comport(r_ini1,vec0,r_ant2,r_ant3,r_ant4,0);
      cambio_comport(r_ini2,vec0,r_ant1,r_ant3,r_ant4,0);
      cambio_comport(r_ini3,vec0,r_ant1,r_ant2,r_ant4,0);
      cambio_comport(r_ini4,vec0,r_ant1,r_ant2,r_ant3,0);

      cambio_comport(r_ini1,vec1,r_ant2,r_ant3,r_ant4,1);
      cambio_comport(r_ini2,vec1,r_ant1,r_ant3,r_ant4,1);
      cambio_comport(r_ini3,vec1,r_ant1,r_ant2,r_ant4,1);
      cambio_comport(r_ini4,vec1,r_ant1,r_ant2,r_ant3,1);

      cambio_comport(r_ini1,vec2,r_ant2,r_ant3,r_ant4,2);
      cambio_comport(r_ini2,vec2,r_ant1,r_ant3,r_ant4,2);
      cambio_comport(r_ini3,vec2,r_ant1,r_ant2,r_ant4,2);
      cambio_comport(r_ini4,vec2,r_ant1,r_ant2,r_ant3,2);

      cambio_comport(r_ini1,vec3,r_ant2,r_ant3,r_ant4,3);
      cambio_comport(r_ini2,vec3,r_ant1,r_ant3,r_ant4,3);
      cambio_comport(r_ini3,vec3,r_ant1,r_ant2,r_ant4,3);
      cambio_comport(r_ini4,vec3,r_ant1,r_ant2,r_ant3,3);


  END;


{*********************************************}
FUNCTION hubo_cambios(rini1,rant1,rini2,rant2,rini3,rant3,rini4,rant4:CHAR):BOOLEAN;
{*********************************************}
  VAR
    i:CHAR;
    cambios:boolean;
  BEGIN
    cambios:=FALSE;
    IF rini1<>rant1 THEN cambios:=TRUE;
    IF rini2<>rant2 THEN cambios:=TRUE;
    IF rini3<>rant3 THEN cambios:=TRUE;
    IF rini4<>rant4 THEN cambios:=TRUE;
    hubo_cambios:=cambios;

  END;


{*********************************************}
PROCEDURE poner_cero(VAR r1,r2,r3,r4:CHAR);
{*********************************************}
  BEGIN
    r1:='N';
    r2:='N';
    r3:='N';
    r4:='N';
  END;



{*********************************************}
{ Procedimento que realizada las llamadas al
resto de modulos}
{*********************************************}
PROCEDURE inicial;
  VAR
    r_ini1,r_ini2,r_ini3,r_ini4,vec0,vec1,vec2,vec3:CHAR;
    r_ant1,r_ant2,r_ant3,r_ant4:CHAR;
    i,turno,mismo_comp:INTEGER;
  BEGIN
    {se llama al procedimiento para conocer el estado inicial de cada rana}
    question(r_ini1,'A');
    question(r_ini2,'B');
    question(r_ini3,'C');
    question(r_ini4,'D');
    {se llama al procedimiento para conocer las reglas,
    para saber en que casos van a croar las ranas en el siguiente turno }
    reglas(vec0,0);
    reglas(vec1,1);
    reglas(vec2,2);
    reglas(vec3,3);

    turno:=1;
    mismo_comp:=0;
    REPEAT
      {se imprimen los croacs }
      impresion_croacs(r_ini1);
      impresion_croacs(r_ini2);
      impresion_croacs(r_ini3);
      impresion_croacs(r_ini4);
      WRITELN; READLN;CLRSCR;
      {copiamos el estado actual de las ranas a anterior para luego comparar}
      r_ant1:=r_ini1;
      r_ant2:=r_ini2;
      r_ant3:=r_ini3;
      r_ant4:=r_ini4;
      {inicializamos las variables actuales de las ranas a no}
      r_ini1:='N';
      r_ini2:='N';
      r_ini3:='N';
      r_ini4:='N';
      {Se resuelve que ranas croan en el siguiente turno}
      llama_cambio(r_ini1,r_ini2,r_ini3,r_ini4,
                   r_ant1,r_ant2,r_ant3,r_ant4,
                   vec0,vec1,vec2,vec3);


      {se comprueba si no ha habido cambios en el comportamiento de las ranas}
      IF NOT (hubo_cambios(r_ini1,r_ant1,r_ini2,r_ant2,r_ini3,r_ant3,r_ini4,r_ant4)) THEN
        mismo_comp:=mismo_comp+1;
      turno:=turno+1;

    UNTIL (turno = 20) OR (mismo_comp=2);
  END;



{*********************************************}
{Se le pregunta al usuario si desea volver a jugar
{*********************************************}
FUNCTION continuar:CHAR;
 VAR
   i:INTEGER;
   resp:char;

 BEGIN
   REPEAT
     CLRSCR;
     WRITE('Desea volver a jugar? ');
     TEXTCOLOR(red);
     WRITELN ('(Y/N)');
     TEXTCOLOR(white);
     READLN(resp);
     resp:= UPCASE(resp);
   UNTIL TRUE = comprueb_resp(resp);
   continuar:=resp;
 END;



{*********************************************}
{procedimiento que se encarga de realizar las
llamadas iniciales}
{*********************************************}
PROCEDURE llamadas;
  VAR
  resp:CHAR;
  BEGIN
    REPEAT
      {limpiar pantalla}
      CLRSCR;
      TEXTCOLOR(white);
      inicial;
      READLN;
      resp:=continuar;
    UNTIL resp='N';
  END;


{*****************************************************}
{ P R O G R A M A      P R I N C I P A L              }
{*****************************************************}
BEGIN
  llamadas;
END.
