PROGRAM Ranas_croando;

USES
  Crt;

VAR
  rA,rB,rC,rD,rA1,rB1,rC1,rD1,ch,rep:char;
  i:integer;
  op1,op2,op3,op4:char;

PROCEDURE Pulsa (x:char); {Este procedimiento se repetir hasta que el usuario pulse una tecla cualquiera}
   BEGIN
      REPEAT UNTIL KeyPressed;
      x:=ReadKey;
   END;

PROCEDURE Mayusculas (var a:char); {Procedimiento que dada una variable de tipo caracter}
   BEGIN                           {la devuelve en maysculas}
      a:=upcase(a);
   END;

PROCEDURE Introduccion (x:char); {Procedimiento que muestra en pantalla una breve descripcin de las}
   BEGIN                         {las caractersticas del programa}
      ClrScr;
      writeln;
      TextColor(14);
      writeln('                                 RANAS CROANDO');
      writeln('                                 -------------');
      writeln;
      TextColor(2);
      writeln(' Como funciona el programa ?');
      writeln;
      TextColor(15);
      writeln('Este programa simular un grupo de 4 ranas croando alrededor de una charca');
      writeln('durante una serie de turnos. Las ranas de esta charca tienen por costumbre');
      writeln('empezar o parar de croar en cada turno segn el nmero de ranas que');
      writeln('estaban croando en el turno anterior');
      writeln;
      TextColor(2);
      writeln(' Qu deber hacer el usuario ?');
      writeln;
      TextColor(15);
      writeln('Incialmente se pedir al usuario que decida, de entre las 4 ranas,');
      writeln('las que van a croar o no en el primer turno. Tambin se le pedir que diga');
      writeln('para cada uno de los casos posibles si la rana va a croar o no en el');
      writeln('siguiente turno. Los casos posibles son 0 ranas vecinas croando,');
      writeln('1 rana vecina croando, 2 ranas vecinas croando o 3 ranas vecians croando.');
      writeln;
      writeln('El juego finalizar tras 20 turnos o antes si durante dos turnos seguidos');
      writeln('las ranas no cambian de comportamiento.');
      GotoXY(1,24); writeln('PRESIONE UNA TECLA PARA CONTINUAR');
      Pulsa(x);
   END;

PROCEDURE Introduccion_1 (x:char); {Este otro procedimiento tambin mostrar un texto explicativo de la primera decisin}
   BEGIN                           {que deber tomar el usuario para decidir el estado de las ranas en el turno inicial}
      ClrScr;
      TextColor(15);
      writeln('A continuacin debers elegir las ranas que croarn y las que callarn');
      writeln('en el primer turno.');
      writeln;
      writeln('Para que la rana este croando debers introducir la letra "S".');
      writeln('Para que la rana este callada debers introducir la letra "N".');
      writeln; writeln;
      write('PRESIONA UNA TECLA PARA CONTINUAR');
      Pulsa(x);
      ClrScr;
   END;

PROCEDURE Introduccion_2; {Procedimiento que mostrar en pantalla las distintas opciones que puede elegir el usuario}
   BEGIN
      ClrScr;
      writeln('A continuacin debers elegir una de las siguiente opciones: ');
      writeln;
      TextColor(9);
      write('> 0:');
      Textcolor(15);
      writeln(' Si una rana tiene 0 ranas vecinas croando, croar ("S") o callar ("N").');
      writeln;
      TextColor(9);
      write('> 1:');
      Textcolor(15);
      writeln(' Si una rana tiene 1 rana vecina croando, croar ("S") o callar ("N").');
      writeln;
      TextColor(9);
      write('> 2:');
      Textcolor(15);
      writeln(' Si una rana tiene 2 ranas vecinas croando, croar ("S") o callar ("N").');
      writeln;
      TextColor(9);
      write('> 3:');
      Textcolor(15);
      writeln(' Si una rana tiene 3 ranas vecinas croando, croar ("S") o callar ("N").');
      writeln;
   END;

PROCEDURE Charca; {Procedimiento que ilustrar en pantalla una charca}
   BEGIN
      TextColor(9);
      GotoXY(33,9);  write('  ');
      GotoXY(33,10); write(' ۲');
      GotoXY(33,11); write('۲');
      GotoXY(33,12); write(' ۲');
      GotoXY(33,13); write('  ');
   END;

PROCEDURE Leyenda; {Procedimiento que mostrar en pantalla una leyenda explicativa}
   BEGIN           {de la simbologia utilizada para ilustrar las ranas croando o calladas}
      TextColor(2);
      GotoXY(55,18); write('  ');
      GotoXY(55,19); write('   ');
      TextColor(15);
      write('    RANA CROANDO');
      TextColor(2);
      GotoXY(55,21); write('   ');
      GotoXY(55,22); write('   ');
      TextColor(15);
      write('    RANA CALLADA');
   END;

PROCEDURE Rana_A(r_a:char); {Este procedimiento ser el encargado de dibujar la rana A crondo o callada}
   BEGIN                    {en funcin de la variable de entrada"r_a"}
      TextColor(2);
      IF r_a='S' THEN
         BEGIN
            GotoXY(25,5); write('  ');
            GotoXY(25,6); write('   ');
         END
      ELSE
         BEGIN
            GotoXY(25,5); write('  ');
            GotoXY(25,6); write('   ');
            GotoXY(25,5); write(' ');
            GotoXY(31,5); write(' ');
         END;
      TextColor(15);
      GotoXY(23,5); write('A');
   END;

PROCEDURE Rana_D(r_d:char); {Este procedimiento ser el encargado de dibujar la rana D crondo o callada}
   BEGIN                    {en funcin de la variable de entrada"r_d"}
      TextColor(2);
      IF r_d='S' THEN
         BEGIN
            GotoXY(45,5); write('  ');
            GotoXY(45,6); write('   ');
         END
      ELSE
         BEGIN
            GotoXY(45,5); write('  ');
            GotoXY(45,6); write('   ');
            GotoXY(45,5); write(' ');
            GotoXY(51,5); write(' ');
         END;
      TextColor(15);
      GotoXY(53,5); write('D');
   END;

PROCEDURE Rana_B(r_b:char); {Este procedimiento ser el encargado de dibujar la rana B crondo o callada}
   BEGIN                    {en funcin de la variable de entrada"r_b"}
      TextColor(2);
      IF r_b='S' THEN
         BEGIN
            GotoXY(25,15); write('  ');
            GotoXY(25,16); write('   ');
         END
      ELSE
         BEGIN
            GotoXY(25,15); write('  ');
            GotoXY(25,16); write('   ');
            GotoXY(25,15); write(' ');
            GotoXY(31,15); write(' ');
         END;
      TextColor(15);
      GotoXY(23,15); write('B');
   END;

PROCEDURE Rana_C(r_c:char); {Este procedimiento ser el encargado de dibujar la rana C crondo o callada}
   BEGIN                    {en funcin de la variable de entrada"r_c"}
      TextColor(2);
      IF r_c='S' THEN
         BEGIN
            GotoXY(45,15); write('  ');
            GotoXY(45,16); write('   ');
         END
      ELSE
         BEGIN
            GotoXY(45,15); write('  ');
            GotoXY(45,16); write('   ');
            GotoXY(45,15); write(' ');
            GotoXY(51,15); write(' ');
         END;
      TextColor(15);
      GotoXY(53,15); write('D');
   END;

PROCEDURE Opciones (x:integer; var k:char); {Procedimiento que almacenar las opciones}
   BEGIN                                    {para calcular el estado de las ranas en un turno}
      GotoXY(1,11); ClrEol; write('Opcin para cuando tenga ',x,' ranas vecinas croando ? ');
      {$I-}
      readln(k);
      Mayusculas(k);
      WHILE (IOResult<>0) OR ((k<>'S') AND (k<>'N')) DO
         BEGIN
            TextColor(12);
            GotoXY(35,23); writeln(' DATO INCORRECTO !');
            TextColor(15);
            GotoXY(52,11); ClrEol;
            readln(k);
            Mayusculas(k);
         END;
      {$I+}
   END;

PROCEDURE Estado (k1,k2,k3,k4:char; var a,b,c,d:char); {Procedimieto que calcular el estado de una rana en funcin}
   BEGIN                                              {de sus vecinas y de las opciones escogidas}
      IF (d='N') AND (b='N') AND (c='N') THEN
         BEGIN
            IF k1='S' THEN a:='S'
            ELSE a:='N';
         END;
      IF ((d='S') AND (b='N') AND (c='N')) OR
         ((d='N') AND (b='S') AND (c='N')) OR
         ((d='N') AND (b='N') AND (c='S')) THEN
         BEGIN
            IF k2='S' THEN a:='S'
            ELSE a:='N';
         END;
      IF ((d='S') AND (b='S') AND (c='N')) OR
         ((d='N') AND (b='S') AND (c='S')) OR
         ((d='S') AND (b='N') AND (c='S')) THEN
         BEGIN
            IF k3='S' THEN a:='S'
            ELSE a:='N';
         END;
      IF (d='S') AND (b='S') AND (c='S') THEN
         BEGIN
            IF k4='S' THEN a:='S'
            ELSE a:='N';
         END;
   END;

FUNCTION Estado_Igual (a,b,c,d,a1,b1,c1,d1:char):boolean; {Esta funcin devolver el valor TRUE en el caso de que el estado}
   BEGIN                                                  {de las ranas en un turno sea igual al anterior}
      Estado_Igual:=((a=a1) AND (b=b1) AND (c=c1) AND (d=d1));
   END;

PROCEDURE Actualiza (k1,k2,k3,k4:char; var a,b,c,d,a1,b1,c1,d1:char); {Este procedimiento ser el encargado de actualizar}
   BEGIN                                                              {una tirada en funcin del estado de las ranas}
      Estado(k1,k2,k3,k4,a1,b,c,d);
      Estado(k1,k2,k3,k4,b1,a,c,d);
      Estado(k1,k2,k3,k4,c1,a,b,d);
      Estado(k1,k2,k3,k4,d1,a,b,c);
      Rana_A(a1);
      Rana_B(b1);
      Rana_C(c1);
      Rana_D(d1);
   END;

PROCEDURE Comprueba (var a:char); {Este procedimiento se repetir hasta que el valor de la variable "a"}
   BEGIN                          {de tipo carcter no sea el valor "S" o "N"}
      WHILE (IOResult<>0) OR ((a<>'S') AND (a<>'N')) DO
         BEGIN
            TextColor(12);
            GotoXY(1,23); ClrEol;
            GotoXY(35,23); writeln(' DATO INCORRECTO !');
            TextColor(15);
            GotoXY(1,3); ClrEol; write('Introduce un dato correcto: ');
            readln(a);
            Mayusculas(a);
         END;
   END;

PROCEDURE reinicia (var a:char); {Procedimiento que reinicia la variable}
   BEGIN
      a:='0';
   END;

BEGIN  {PROGRAMA PRINCIPAL}
   REPEAT
      Introduccion(ch);
      Introduccion_1(ch);
      {$I-}
      writeln;
      write('> Estado rana A: '); readln(rA);
      Mayusculas(rA);
      Comprueba(rA);
      {$I+}
      ClrScr;
      {$I-}
      writeln;
      write('> Estado rana B: '); readln(rB);
      Mayusculas(rB);
      Comprueba(rB);
      {$I+}
      ClrScr;
      {$I-}
      writeln;
      write('> Estado rana C: '); readln(rC);
      Mayusculas(rC);
      Comprueba(rC);
      {$I+}
      ClrScr;
      {$I-}
      writeln;
      write('> Estado rana D: '); readln(rD);
      Mayusculas(rD);
      Comprueba(rD);
      {$I+}
      Introduccion_2;
      Opciones(0,op1); Opciones(1,op2); opciones(2,op3); opciones(3,op4);
      ClrScr;
      Leyenda;
      Charca;
      Rana_A(rA);
      Rana_B(rB);
      Rana_C(rC);
      Rana_D(rD);
      i:=1;
      GotoXY(1,21); writeln('Pulsa una tecla para siguiente turno');
      GotoXY(1,22); writeln('TURNO: ',i);
      reinicia(rA1); reinicia(rB1); reinicia(rC1); reinicia(rD1);
      WHILE NOT (Estado_igual(rA,rB,rC,rD,rA1,rB1,rC1,rD1)) AND (i<20) DO
         BEGIN
            Pulsa(ch);
            Actualiza(op1,op2,op3,op4,rA,rB,rC,rD,rA1,rB1,rC1,rD1);
            i:=i+1;
            GotoXY(1,22); writeln('TURNO: ',i);
            Pulsa(ch);
            IF i<20 THEN
              BEGIN
                 Actualiza(op1,op2,op3,op4,rA1,rB1,rC1,rD1,rA,rB,rC,rD);
                 i:=i+1;
              END;
            GotoXY(1,22); writeln('TURNO: ',i);
            IF Estado_igual(rA,rB,rC,rD,rA1,rB1,rC1,rD1) THEN
               BEGIN
                  TextColor(12);
                  GotoXY(20,23); writeln(' LAS RANAS NO CAMBIAN DE COMPORTAMIENTO !');
                  TextColor(15);
               END;
            IF (i=20) THEN
               BEGIN
                  TextColor(12);
                  GotoXY(35,23); writeln(' FIN DEL JUEGO !');
                  TextColor(15);
               END
         END;
      GotoXY(1,1); write('QUIERES VOLVER A JUGAR (S/N): ');
      readln(rep);
      Mayusculas(rep);
      Comprueba(rep);
   UNTIL rep='N';
END.